/*****************************************************************************
	DTD
	by B. Collier Jones (bcjones@webelement.net)
	Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
/*****************************************************************************/

#define DEFAULT					0
#define DTD_COMMENT				1
#define DTD_ENTITY				5
#define DTD_ENTITY_ON			6
#define DTD_ENTITY_OFF			7
#define DTD_ENTITY_ATTR			8
#define DTD_ELEMENT				10
#define DTD_ELEMENT_ON			11
#define DTD_ELEMENT_OFF			12
#define DTD_ELEMENT_ENTITY		13
#define DTD_ELEMENT_KEYWORD		14
#define DTD_ATTLIST				15
#define DTD_ATTLIST_ON			16
#define DTD_ATTLIST_OFF			17
#define DTD_ATTLIST_ENTITY		18
#define DTD_ATTLIST_KEYWORD		19
#define DTD_ENTITY_INLINE		20
#define DTD_KEYWORD				21
#define DTD_ATTLIST_VALUE		22

#define IN_DEFAULT				0
#define IN_DTD_ENTITY			5
#define IN_DTD_ELEMENT			10
#define IN_DTD_ATTLIST			15

#define DONT_CARE				'[\x00-\xFF]'
#define clLtSilver				15329769
#define clOrange				33023
#define clSoftBlue				12615680

%%language
Name                    = 'DTD - Simple Coloring'
Case                    = __SENSITIVE
//Anchor					= [css_COMMENT css_SELECTOR]
StartState				= DEFAULT
EditableStyles			  ('Default Text',					DEFAULT),
						  ('DTD Comment',					DTD_COMMENT),
						  ('DTD !ENTITY Declaration',		DTD_ENTITY),
						  //('DTD !ENTITY Attribute',			DTD_ENTITY_ATTR),
						  ('DTD !ELEMENT Declaration',		DTD_ELEMENT),
						  ('DTD Entity Reference',			DTD_ENTITY_INLINE),
						  //('DTD Keywords',					DTD_KEYWORD),
						  ('DTD !ATTLIST Declaration',		DTD_ATTLIST)
						  //('DTD !ATTLIST Value',			DTD_ATTLIST_VALUE)

ExampleText				= '<!--================ Document Head =======================================-->\n\
						  \<!ENTITY % head.misc "(script|style|meta|link|object|isindex)*">\n\
						  \<!-- content model is %head.misc; combined with a single\n\
						  \     title and an optional base element in any order -->\n\
						  \<!ELEMENT head (%head.misc;,\n\
						  \     ((title, %head.misc;, (base, %head.misc;)?) |\n\
						  \      (base, %head.misc;, (title, %head.misc;))))>\n\
						  \\n\
						  \<!ATTLIST col\n\
						  \  %attrs;\n\
						  \  span        %Number;       "1"\n\
						  \  width       %MultiLength;  #IMPLIED\n\
						  \  %cellhalign;\n\
						  \  %cellvalign;\n\
						  \  >'

%%words
'<!--'				DONT_CARE				DTD_COMMENT				[IN_DEFAULT]
'<!ENTITY'			DONT_CARE				DTD_ENTITY_ON			[IN_DEFAULT]
'>'					DONT_CARE				DTD_ENTITY_OFF			[IN_DTD_ENTITY]
'<!ELEMENT'			DONT_CARE				DTD_ELEMENT_ON			[IN_DEFAULT]
'>'					DONT_CARE				DTD_ELEMENT_OFF			[IN_DTD_ELEMENT]
//'%'					'[A-Za-z0-9]'			DTD_ELEMENT_ENTITY		[IN_DTD_ELEMENT]
//'#PCDATA'			'[^A-Za-z]'				DTD_ELEMENT_KEYWORD		[IN_DTD_ELEMENT]
//'#CDATA'			'[^A-Za-z]'				DTD_ELEMENT_KEYWORD		[IN_DTD_ELEMENT]
//'EMPTY'				'[^A-Za-z]'				DTD_ELEMENT_KEYWORD		[IN_DTD_ELEMENT]


'<!ATTLIST'			DONT_CARE				DTD_ATTLIST_ON			[IN_DEFAULT]
'>'					DONT_CARE				DTD_ATTLIST_OFF			[IN_DTD_ATTLIST]
//'%'					'[A-Za-z0-9]'			DTD_ATTLIST_ENTITY		[IN_DTD_ATTLIST]
//'NMTOKEN'			'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'ID'				'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'IDREF'				'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'CDATA'				'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'PCDATA'			'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'#REQUIRED'			'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'#IMPLIED'			'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
//'#FIXED'			'[^A-Za-z]'				DTD_ATTLIST_KEYWORD		[IN_DTD_ATTLIST]
'%'					'[A-Za-z0-9]'			DTD_ENTITY_INLINE		[IN_DEFAULT]




%%handlers
DTD_COMMENT			DONT_CARE?				'\-\->'				_use_
DTD_ELEMENT_ENTITY	'[A-Za-z0-9.]'?			';'					_use_
DTD_ATTLIST_ENTITY	'[A-Za-z0-9.]'?			';'					_use_
DTD_ENTITY_INLINE	'[A-Za-z0-9.]'?			';'					_use_

%%tokens
InState IN_DTD_ENTITY (
	DTD_ENTITY			DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

InState IN_DTD_ELEMENT (
	DTD_ELEMENT			DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

InState IN_DTD_ATTLIST (
	DTD_ATTLIST			DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

%%states
DTD_ENTITY_ON		(-[IN_DEFAULT]				+[IN_DTD_ENTITY])
DTD_ENTITY_OFF		(-[IN_DTD_ENTITY]			+[IN_DEFAULT])

DTD_ELEMENT_ON		(-[IN_DEFAULT]				+[IN_DTD_ELEMENT])
DTD_ELEMENT_OFF		(-[IN_DTD_ELEMENT]			+[IN_DEFAULT])

DTD_ATTLIST_ON		(-[IN_DEFAULT]				+[IN_DTD_ATTLIST])
DTD_ATTLIST_OFF		(-[IN_DTD_ATTLIST]			+[IN_DEFAULT])

%%effects
DEFAULT					[]	 		clBlack*				clWhite*
DTD_COMMENT				[]			clGray					clWhite*
DTD_ENTITY				[]			clMaroon				clWhite*
DTD_ENTITY_ATTR			[]			clBlack*				clWhite*
DTD_ELEMENT				[]			clBlue					clWhite*
DTD_ELEMENT_ENTITY		[fsItalic]	clBlue					clWhite*
DTD_ELEMENT_KEYWORD		[]			clGreen					clWhite*
DTD_ATTLIST				[]			clTeal					clWhite*
DTD_ATTLIST_ENTITY		[fsItalic]	clTeal					clWhite*
DTD_ATTLIST_KEYWORD		[]			clGreen					clWhite*
DTD_ENTITY_INLINE		[fsBold]	clBlack					clWhite*
DTD_KEYWORD				[]			clGreen					clWhite*
DTD_ATTLIST_VALUE		[]			clBlack*				clWhite*

%%map
DEFAULT					DEFAULT
DTD_COMMENT				DTD_COMMENT
DTD_ENTITY				DTD_ENTITY
DTD_ENTITY_ON			DTD_ENTITY
DTD_ENTITY_OFF			DTD_ENTITY
DTD_ENTITY_ATTR			DTD_ENTITY_ATTR
DTD_ELEMENT				DTD_ELEMENT
DTD_ELEMENT_ON			DTD_ELEMENT
DTD_ELEMENT_OFF			DTD_ELEMENT
DTD_ELEMENT_ENTITY		DTD_ENTITY_INLINE
DTD_ELEMENT_KEYWORD		DTD_KEYWORD
DTD_ATTLIST				DTD_ATTLIST
DTD_ATTLIST_ON			DTD_ATTLIST
DTD_ATTLIST_OFF			DTD_ATTLIST
DTD_ATTLIST_ENTITY		DTD_ENTITY_INLINE
DTD_ATTLIST_KEYWORD		DTD_KEYWORD
DTD_ENTITY_INLINE		DTD_ENTITY_INLINE
DTD_KEYWORD				DTD_KEYWORD
DTD_ATTLIST_VALUE		DTD_ATTLIST_VALUE
