/* -------------------------------------------------------------------------------------------------
 *  JavaScript Parser
/* -------------------------------------------------------------------------------------------------
 *  Author: Nick Bradbury 
 *	Date: September 1998
 *  Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
 *  Use of this script in non-Allaire products is strictly prohibited.
------------------------------------------------------------------------------------------------- */

#define DEFAULT              0 
#define jt_RESERVED             1
#define jt_COMMENT              2
#define jt_COMMENT_STAR         3
#define jt_COMMENT_LINE         4
#define jt_STRING               5
#define jt_STRING_CHAR          6
#define jt_IDENTIFIER           7
#define jt_NUMBER               8
#define jt_SYMBOL               9
#define jt_BUILTINMETHOD        10
#define jt_HEXNUMBER            11
#define jt_SCRIPT_TAG		12

#define _LANG_WORDS             20

#define jt_ABSTRACT             (_LANG_WORDS + 00)
#define jt_BOOLEAN              (_LANG_WORDS + 01)
#define jt_BREAK                (_LANG_WORDS + 02)
#define jt_BYTE                 (_LANG_WORDS + 03)
#define jt_CASE                 (_LANG_WORDS + 04)
#define jt_CATCH                (_LANG_WORDS + 05)
#define jt_CHAR                 (_LANG_WORDS + 06)
#define jt_CLASS                (_LANG_WORDS + 07)
#define jt_CONST                (_LANG_WORDS + 08)
#define jt_CONTINUE             (_LANG_WORDS + 09)
#define jt_DEFAULT              (_LANG_WORDS + 10)
#define jt_DO                   (_LANG_WORDS + 11)
#define jt_DOUBLE               (_LANG_WORDS + 12)
#define jt_ELSE                 (_LANG_WORDS + 13)
#define jt_EXTENDS              (_LANG_WORDS + 14)
#define jt_FALSE                (_LANG_WORDS + 15)
#define jt_FINAL                (_LANG_WORDS + 16)
#define jt_FINALLY              (_LANG_WORDS + 17)
#define jt_FLOAT                (_LANG_WORDS + 18)
#define jt_FOR                  (_LANG_WORDS + 19)
#define jt_FUNCTION             (_LANG_WORDS + 20)
#define jt_GOTO                 (_LANG_WORDS + 21)
#define jt_IF                   (_LANG_WORDS + 22)
#define jt_IMPLEMENTS           (_LANG_WORDS + 23)
#define jt_IMPORT               (_LANG_WORDS + 24)
#define jt_IN                   (_LANG_WORDS + 25)
#define jt_INSTANCEOF           (_LANG_WORDS + 26)
#define jt_INT                  (_LANG_WORDS + 27)
#define jt_INTERFACE            (_LANG_WORDS + 28)
#define jt_LONG                 (_LANG_WORDS + 29)
#define jt_NATIVE               (_LANG_WORDS + 30)
#define jt_NEW                  (_LANG_WORDS + 31)
#define jt_NULL                 (_LANG_WORDS + 32)
#define jt_PACKAGE              (_LANG_WORDS + 33)
#define jt_PRIVATE              (_LANG_WORDS + 34)
#define jt_PROTECTED            (_LANG_WORDS + 35)
#define jt_PUBLIC               (_LANG_WORDS + 36)
#define jt_RETURN               (_LANG_WORDS + 37)
#define jt_SHORT                (_LANG_WORDS + 38)
#define jt_STATIC               (_LANG_WORDS + 39)
#define jt_SUPER                (_LANG_WORDS + 40)
#define jt_SWITCH               (_LANG_WORDS + 41)
#define jt_SYCHRONIZ            (_LANG_WORDS + 42)
#define jt_THIS                 (_LANG_WORDS + 43)
#define jt_THROW                (_LANG_WORDS + 44)
#define jt_THROWS               (_LANG_WORDS + 45)
#define jt_TRANSIENT            (_LANG_WORDS + 46)
#define jt_TRUE                 (_LANG_WORDS + 47)
#define jt_TRY                  (_LANG_WORDS + 48)
#define jt_VAR                  (_LANG_WORDS + 49)
#define jt_VOID                 (_LANG_WORDS + 50)
#define jt_WHILE                (_LANG_WORDS + 51)
#define jt_WITH                 (_LANG_WORDS + 52)

#define _LANG_OPS               _LANG_WORDS  + 60

#define jt_COMMA                (_LANG_OPS   + 00)
#define jt_EQUALS               (_LANG_OPS   + 01)
#define jt_AUTOINC              (_LANG_OPS   + 02)
#define jt_AUTODEC              (_LANG_OPS   + 03)
#define jt_AUTOMULT             (_LANG_OPS   + 04)
#define jt_AUTODIV              (_LANG_OPS   + 05)
#define jt_AUTOMOD              (_LANG_OPS   + 06)
#define jt_AUTOSHL              (_LANG_OPS   + 07)
#define jt_AUTOSHR              (_LANG_OPS   + 08)
#define jt_AUTOSHR_SIGNED       (_LANG_OPS   + 09)
#define jt_AUTOAND              (_LANG_OPS   + 10)
#define jt_AUTOXOR              (_LANG_OPS   + 11)
#define jt_AUTOOR               (_LANG_OPS   + 12)
#define jt_CONDITIONAL          (_LANG_OPS   + 13)
#define jt_LOGOR                (_LANG_OPS   + 14)
#define jt_LORAND               (_LANG_OPS   + 15)
#define jt_BITOR                (_LANG_OPS   + 16)
#define jt_BITXOR               (_LANG_OPS   + 17)
#define jt_BITAND               (_LANG_OPS   + 18)
#define jt_EQUALTO              (_LANG_OPS   + 19)
#define jt_NOTEQUALTO           (_LANG_OPS   + 20)
#define jt_LESS                 (_LANG_OPS   + 21)
#define jt_LESSTHANEQ           (_LANG_OPS   + 22)
#define jt_GREATER              (_LANG_OPS   + 23)
#define jt_GREATERTHANEQ        (_LANG_OPS   + 24)
#define jt_SHL                  (_LANG_OPS   + 25)
#define jt_SHR                  (_LANG_OPS   + 26)
#define jt_SHR_SIGNED           (_LANG_OPS   + 27)
#define jt_PLUS                 (_LANG_OPS   + 28)
#define jt_MINUS                (_LANG_OPS   + 29)
#define jt_TIMES                (_LANG_OPS   + 30)
#define jt_DIV                  (_LANG_OPS   + 31)
#define jt_MOD                  (_LANG_OPS   + 32)
#define jt_NOT                  (_LANG_OPS   + 33)
#define jt_NEGATE               (_LANG_OPS   + 34)
#define jt_INCREMENT            (_LANG_OPS   + 35)
#define jt_DECREMENT            (_LANG_OPS   + 36)
#define jt_LBRACKET             (_LANG_OPS   + 37)
#define jt_RBRACKET             (_LANG_OPS   + 39)
#define jt_LSBRACKET            (_LANG_OPS   + 40)
#define jt_RSBRACKET            (_LANG_OPS   + 41)
#define jt_DOT                  (_LANG_OPS   + 42)

#define _LANG_METHODS           _LANG_OPS    + 50

//
//
//
#define jt_ABS                  (_LANG_METHODS + 00)
#define jt_ACOS                 (_LANG_METHODS + 01)
#define jt_ALERT                (_LANG_METHODS + 02)
#define jt_ANCHOR               (_LANG_METHODS + 03)
#define jt_ASIN                 (_LANG_METHODS + 04)
#define jt_ATAN                 (_LANG_METHODS + 05)
#define jt_BACK                 (_LANG_METHODS + 06)
#define jt_BIG                  (_LANG_METHODS + 07)
#define jt_BLINK                (_LANG_METHODS + 08)
#define jt_BLUR                 (_LANG_METHODS + 09)
#define jt_BOLD                 (_LANG_METHODS + 10)
#define jt_CEIL                 (_LANG_METHODS + 11)
#define jt_CHARAT               (_LANG_METHODS + 12)
#define jt_CLEAR                (_LANG_METHODS + 13)
#define jt_CLEARTIMEOUT         (_LANG_METHODS + 14)
#define jt_CLICK                (_LANG_METHODS + 15)
#define jt_CLOSE                (_LANG_METHODS + 16)
#define jt_CONFIRM              (_LANG_METHODS + 17)
#define jt_COS                  (_LANG_METHODS + 18)
#define jt_ESCAPE               (_LANG_METHODS + 19)
#define jt_EVAL                 (_LANG_METHODS + 20)
#define jt_EXP                  (_LANG_METHODS + 21)
#define jt_FIXED                (_LANG_METHODS + 22)
#define jt_FLOOR                (_LANG_METHODS + 23)
#define jt_FOCUS                (_LANG_METHODS + 24)
#define jt_FONTCOLOR            (_LANG_METHODS + 25)
#define jt_FONTSIZE             (_LANG_METHODS + 26)
#define jt_FORWARD              (_LANG_METHODS + 27)
#define jt_GETDATE              (_LANG_METHODS + 28)
#define jt_GETDAY               (_LANG_METHODS + 29)
#define jt_GETHOURS             (_LANG_METHODS + 30)
#define jt_GETMINUTES           (_LANG_METHODS + 31)
#define jt_GETMONTH             (_LANG_METHODS + 32)
#define jt_GETSECONDS           (_LANG_METHODS + 33)
#define jt_GETTIME              (_LANG_METHODS + 34)
#define jt_GETTIMEZONEOFFSET    (_LANG_METHODS + 35)
#define jt_GETYEAR              (_LANG_METHODS + 36)
#define jt_GO                   (_LANG_METHODS + 37)
#define jt_INDEXOF              (_LANG_METHODS + 38)
#define jt_ISNAN                (_LANG_METHODS + 39)
#define jt_ITALICS              (_LANG_METHODS + 40)
#define jt_LASTINDEXOF          (_LANG_METHODS + 41)
#define jt_LINK                 (_LANG_METHODS + 42)
#define jt_LOG                  (_LANG_METHODS + 43)
#define jt_MAX                  (_LANG_METHODS + 44)
#define jt_MIN                  (_LANG_METHODS + 45)
#define jt_OPEN                 (_LANG_METHODS + 46)
#define jt_PARSE                (_LANG_METHODS + 47)
#define jt_PARSEFLOAT           (_LANG_METHODS + 48)
#define jt_PARSEINT             (_LANG_METHODS + 49)
#define jt_POW                  (_LANG_METHODS + 50)
#define jt_PROMPT               (_LANG_METHODS + 51)
#define jt_RANDOM               (_LANG_METHODS + 52)
#define jt_ROUND                (_LANG_METHODS + 53)
#define jt_SELECT               (_LANG_METHODS + 54)
#define jt_SETDATE              (_LANG_METHODS + 55)
#define jt_SETHOURS             (_LANG_METHODS + 56)
#define jt_SETMINUTES           (_LANG_METHODS + 57)
#define jt_SETMONTH             (_LANG_METHODS + 58)
#define jt_SETSECONDS           (_LANG_METHODS + 59)
#define jt_SETTIMEOUT           (_LANG_METHODS + 60)
#define jt_SETTIME              (_LANG_METHODS + 61)
#define jt_SETYEAR              (_LANG_METHODS + 62)
#define jt_SIN                  (_LANG_METHODS + 63)
#define jt_SMALL                (_LANG_METHODS + 64)
#define jt_SQRT                 (_LANG_METHODS + 65)
#define jt_STRIKE               (_LANG_METHODS + 66)
#define jt_SUB                  (_LANG_METHODS + 67)
#define jt_SUBMIT               (_LANG_METHODS + 68)
#define jt_SUBSTRING            (_LANG_METHODS + 69)
#define jt_SUP                  (_LANG_METHODS + 70)
#define jt_TAN                  (_LANG_METHODS + 71)
#define jt_TOGMTSTRING          (_LANG_METHODS + 72)
#define jt_TOLOCALESTRING       (_LANG_METHODS + 73)
#define jt_TOLOWERCASE          (_LANG_METHODS + 74)
#define jt_TOUPPERCASE          (_LANG_METHODS + 75)
#define jt_UNESCAPE             (_LANG_METHODS + 76)
#define jt_UTC                  (_LANG_METHODS + 77)
#define jt_WRITE                (_LANG_METHODS + 78)
#define jt_WRITELN              (_LANG_METHODS + 79)

/*--- jt_WRITELN == 209 ---*/


#define _non_alpha_                 '[^_A-Za-z0-9]'
#define _all_chars_                 '[\x01-\xFF]'
#define _no_chars_                  '[]'
#define _dont_care_                 _all_chars_
#define _DEFAULT_BACKGROUND         clWhite
#define _DEFAULT_FOREGROUND         clBlack

%%language
Name                     = 'JavaScript'
Case                      = __SENSITIVE
Anchor                    = _DEFAULT_START_ANCHOR
ExampleText               = '/* Javascript syntax highlighting */\n\
                            \var worldString="Hello, world"\n\
                            \document.write(worldString.small())\n\
                            \document.write("<P>" + worldString.big())\n\
                            \document.write("<P>" + worldString.fontsize(7))\n'
                            
EditableStyles              ('Reserved word', jt_RESERVED),
                            ('Comment',       jt_COMMENT),
                            ('Identifier',    jt_IDENTIFIER),
                            ('Function',      jt_BUILTINMETHOD),
                            ('String',        jt_STRING),
                            ('Number',        jt_NUMBER),
                            ('Symbols',       jt_SYMBOL),
							('Script Tag', 	  jt_SCRIPT_TAG),
                            ('Default',       DEFAULT)

%%words
'<script'		    _dont_care_       jt_SCRIPT_TAG
'</script'		    _dont_care_       jt_SCRIPT_TAG
'<SCRIP'		    _dont_care_       jt_SCRIPT_TAG
'</SCRIP'		    _dont_care_       jt_SCRIPT_TAG
//
'abstract'                  _non_alpha_       jt_ABSTRACT
'boolean'                   _non_alpha_       jt_BOOLEAN
'break'                     _non_alpha_       jt_BREAK
'byte'                      _non_alpha_       jt_BYTE
'case'                      _non_alpha_       jt_CASE
'catch'                     _non_alpha_       jt_CATCH
'char'                      _non_alpha_       jt_CHAR
'class'                     _non_alpha_       jt_CLASS
'const'                     _non_alpha_       jt_CONST
'continue'                  _non_alpha_       jt_CONTINUE
'default'                   _non_alpha_       jt_DEFAULT
'do'                        _non_alpha_       jt_DO
'double'                    _non_alpha_       jt_DOUBLE
'else'                      _non_alpha_       jt_ELSE
'extends'                   _non_alpha_       jt_EXTENDS
'false'                     _non_alpha_       jt_FALSE
'final'                     _non_alpha_       jt_FINAL
'finally'                   _non_alpha_       jt_FINALLY
'float'                     _non_alpha_       jt_FLOAT
'for'                       _non_alpha_       jt_FOR
'function'                  _non_alpha_       jt_FUNCTION
'goto'                      _non_alpha_       jt_GOTO
'if'                        _non_alpha_       jt_IF
'implements'                _non_alpha_       jt_IMPLEMENTS
'import'                    _non_alpha_       jt_IMPORT
'in'                        _non_alpha_       jt_IN
'instanceof'                _non_alpha_       jt_INSTANCEOF
'int'                       _non_alpha_       jt_INT
'interface'                 _non_alpha_       jt_INTERFACE
'long'                      _non_alpha_       jt_LONG
'native'                    _non_alpha_       jt_NATIVE
'new'                       _non_alpha_       jt_NEW
'null'                      _non_alpha_       jt_NULL
'package'                   _non_alpha_       jt_PACKAGE
'private'                   _non_alpha_       jt_PRIVATE
'protected'                 _non_alpha_       jt_PROTECTED
'public'                    _non_alpha_       jt_PUBLIC
'return'                    _non_alpha_       jt_RETURN
'short'                     _non_alpha_       jt_SHORT
'static'                    _non_alpha_       jt_STATIC
'super'                     _non_alpha_       jt_SUPER
'switch'                    _non_alpha_       jt_SWITCH
'synchroniz'                _non_alpha_       jt_SYCHRONIZ
'this'                      _non_alpha_       jt_THIS
'throw'                     _non_alpha_       jt_THROW
'throws'                    _non_alpha_       jt_THROWS
'transient'                 _non_alpha_       jt_TRANSIENT
'true'                      _non_alpha_       jt_TRUE
'try'                       _non_alpha_       jt_TRY
'var'                       _non_alpha_       jt_VAR
'void'                      _non_alpha_       jt_VOID
'while'                     _non_alpha_       jt_WHILE
'with'                      _non_alpha_       jt_WITH
//
//
//
'abs'                       _non_alpha_       jt_ABS
'acos'                      _non_alpha_       jt_ACOS
'alert'                     _non_alpha_       jt_ALERT
'anchor'                    _non_alpha_       jt_ANCHOR
'asin'                      _non_alpha_       jt_ASIN
'atan'                      _non_alpha_       jt_ATAN
'back'                      _non_alpha_       jt_BACK
'big'                       _non_alpha_       jt_BIG
'blink'                     _non_alpha_       jt_BLINK
'blur'                      _non_alpha_       jt_BLUR
'bold'                      _non_alpha_       jt_BOLD
'ceil'                      _non_alpha_       jt_CEIL
'charAt'                    _non_alpha_       jt_CHARAT
'clear'                     _non_alpha_       jt_CLEAR
'clearTimeout'              _non_alpha_       jt_CLEARTIMEOUT
'click'                     _non_alpha_       jt_CLICK
'close'                     _non_alpha_       jt_CLOSE
'confirm'                   _non_alpha_       jt_CONFIRM
'cos'                       _non_alpha_       jt_COS
'escape'                    _non_alpha_       jt_ESCAPE
'eval'                      _non_alpha_       jt_EVAL
'exp'                       _non_alpha_       jt_EXP
'fixed'                     _non_alpha_       jt_FIXED
'floor'                     _non_alpha_       jt_FLOOR
'focus'                     _non_alpha_       jt_FOCUS
'fontcolor'                 _non_alpha_       jt_FONTCOLOR
'fontsize'                  _non_alpha_       jt_FONTSIZE
'forward'                   _non_alpha_       jt_FORWARD
'getDate'                   _non_alpha_       jt_GETDATE
'getDay'                    _non_alpha_       jt_GETDAY
'getHours'                  _non_alpha_       jt_GETHOURS
'getMinutes'                _non_alpha_       jt_GETMINUTES
'getMonth'                  _non_alpha_       jt_GETMONTH
'getSeconds'                _non_alpha_       jt_GETSECONDS
'getTime'                   _non_alpha_       jt_GETTIME
'getTimezoneOffset'         _non_alpha_       jt_GETTIMEZONEOFFSET
'getYear'                   _non_alpha_       jt_GETYEAR
'go'                        _non_alpha_       jt_GO
'indexOf'                   _non_alpha_       jt_INDEXOF
'isNaN'                     _non_alpha_       jt_ISNAN
'italics'                   _non_alpha_       jt_ITALICS
'lastIndexOf'               _non_alpha_       jt_LASTINDEXOF
'link'                      _non_alpha_       jt_LINK
'log'                       _non_alpha_       jt_LOG
'max'                       _non_alpha_       jt_MAX
'min'                       _non_alpha_       jt_MIN
'open'                      _non_alpha_       jt_OPEN
'parse'                     _non_alpha_       jt_PARSE
'parseFloat'                _non_alpha_       jt_PARSEFLOAT
'parseInt'                  _non_alpha_       jt_PARSEINT
'pow'                       _non_alpha_       jt_POW
'prompt'                    _non_alpha_       jt_PROMPT
'random'                    _non_alpha_       jt_RANDOM
'round'                     _non_alpha_       jt_ROUND
'select'                    _non_alpha_       jt_SELECT
'setDate'                   _non_alpha_       jt_SETDATE
'setHours'                  _non_alpha_       jt_SETHOURS
'setMinutes'                _non_alpha_       jt_SETMINUTES
'setMonth'                  _non_alpha_       jt_SETMONTH
'setSeconds'                _non_alpha_       jt_SETSECONDS
'setTimeout'                _non_alpha_       jt_SETTIMEOUT
'setTime'                   _non_alpha_       jt_SETTIME
'setYear'                   _non_alpha_       jt_SETYEAR
'sin'                       _non_alpha_       jt_SIN
'small'                     _non_alpha_       jt_SMALL
'sqrt'                      _non_alpha_       jt_SQRT
'strike'                    _non_alpha_       jt_STRIKE
'sub'                       _non_alpha_       jt_SUB
'submit'                    _non_alpha_       jt_SUBMIT
'substring'                 _non_alpha_       jt_SUBSTRING
'sup'                       _non_alpha_       jt_SUP
'tan'                       _non_alpha_       jt_TAN
'toGMTString'               _non_alpha_       jt_TOGMTSTRING
'toLocaleString'            _non_alpha_       jt_TOLOCALESTRING
'toLowerCase'               _non_alpha_       jt_TOLOWERCASE
'toUpperCase'               _non_alpha_       jt_TOUPPERCASE
'unescape'                  _non_alpha_       jt_UNESCAPE
'UTC'                       _non_alpha_       jt_UTC
'write'                     _non_alpha_       jt_WRITE
'writeln'                   _non_alpha_       jt_WRITELN

','                         _dont_care_       jt_COMMA
'='                         _dont_care_       jt_EQUALS
'+='                        _dont_care_       jt_AUTOINC
'-='                        _dont_care_       jt_AUTODEC
'*='                        _dont_care_       jt_AUTOMULT
'/='                        _dont_care_       jt_AUTODIV
'%='                        _dont_care_       jt_AUTOMOD
'<<='                       _dont_care_       jt_AUTOSHL
'>>='                       _dont_care_       jt_AUTOSHR
'>>>='                      _dont_care_       jt_AUTOSHR_SIGNED
'&='                        _dont_care_       jt_AUTOAND
'^='                        _dont_care_       jt_AUTOXOR
'|='                        _dont_care_       jt_AUTOOR
'?:'                        _dont_care_       jt_CONDITIONAL
'||'                        _dont_care_       jt_LOGOR
'&&'                        _dont_care_       jt_LORAND
'|'                         _dont_care_       jt_BITOR
'^'                         _dont_care_       jt_BITXOR
'&'                         _dont_care_       jt_BITAND
'=='                        _dont_care_       jt_EQUALTO
'!='                        _dont_care_       jt_NOTEQUALTO
'<'                         _dont_care_       jt_LESS
'<='                        _dont_care_       jt_LESSTHANEQ
'>'                         _dont_care_       jt_GREATER
'>='                        _dont_care_       jt_GREATERTHANEQ
'<<'                        _dont_care_       jt_SHL
'>>'                        _dont_care_       jt_SHR
'>>>'                       _dont_care_       jt_SHR_SIGNED
'+'                         _dont_care_       jt_PLUS
'-'                         _dont_care_       jt_MINUS
'*'                         _dont_care_       jt_TIMES
'/'                         _dont_care_       jt_DIV
'%'                         _dont_care_       jt_MOD
'!'                         _dont_care_       jt_NOT
'~'                         _dont_care_       jt_NEGATE
'++'                        _dont_care_       jt_INCREMENT
'--'                        _dont_care_       jt_DECREMENT
'('                         _dont_care_       jt_LBRACKET
')'                         _dont_care_       jt_RBRACKET
'['                         _dont_care_       jt_LSBRACKET
']'                         _dont_care_       jt_RSBRACKET
'.'                         _dont_care_       jt_DOT
'0'                         '[xX]'            jt_HEXNUMBER

'\/*'                       _dont_care_       jt_COMMENT_STAR
'\/\/'                      _dont_care_       jt_COMMENT_LINE

%%handler
jt_COMMENT_LINE         '[^\n]'?                    '\n'           _discard_
jt_COMMENT_STAR         _all_chars_?                '*\/'          _use_
jt_HEXNUMBER            '[xX0-9A-Fa-f]'             '[^0-9a-fA-F]' _discard_
jt_SCRIPT_TAG		_all_chars_?                '>'            _use_

%%tokens
jt_STRING               __STD_C_STRING
jt_STRING_CHAR          __STD_C_CHAR
jt_IDENTIFIER           __STD_IDENTIFIER
jt_NUMBER               __STD_NUMBER_OR_FP

%%effects
DEFAULT              	[]                          _DEFAULT_FOREGROUND         _DEFAULT_BACKGROUND
jt_IDENTIFIER           []                          _DEFAULT_FOREGROUND*        _DEFAULT_BACKGROUND*
jt_STRING               []                  	    clBlue	                _DEFAULT_BACKGROUND*
jt_COMMENT              [fsItalic]                  clGreen                     _DEFAULT_BACKGROUND*
jt_RESERVED             [fsBold]                    clNavy	                _DEFAULT_BACKGROUND*
jt_BUILTINMETHOD        [fsBold]                    clNavy         		_DEFAULT_BACKGROUND*
jt_NUMBER               []                          clRed                       _DEFAULT_BACKGROUND*
jt_SYMBOL               [fsBold]                    _DEFAULT_FOREGROUND*        _DEFAULT_BACKGROUND*
jt_SCRIPT_TAG		[]		    	    clMaroon			_DEFAULT_BACKGROUND*

%%map
DEFAULT					DEFAULT
jt_RESERVED             jt_RESERVED
jt_STRING               jt_STRING
jt_COMMENT              jt_COMMENT
jt_IDENTIFIER           jt_IDENTIFIER
jt_COMMENT_LINE         jt_COMMENT
jt_COMMENT_STAR         jt_COMMENT
jt_STRING               jt_STRING
jt_STRING_CHAR          jt_STRING
jt_BUILTINMETHOD        jt_BUILTINMETHOD
jt_HEXNUMBER            jt_NUMBER
jt_NUMBER               jt_NUMBER
jt_SCRIPT_TAG		jt_SCRIPT_TAG
//
//
//
jt_ABSTRACT             jt_RESERVED
jt_BOOLEAN              jt_RESERVED
jt_BREAK                jt_RESERVED
jt_BYTE                 jt_RESERVED
jt_CASE                 jt_RESERVED
jt_CATCH                jt_RESERVED
jt_CHAR                 jt_RESERVED
jt_CLASS                jt_RESERVED
jt_CONST                jt_RESERVED
jt_CONTINUE             jt_RESERVED
jt_DEFAULT              jt_RESERVED
jt_DO                   jt_RESERVED
jt_DOUBLE               jt_RESERVED
jt_ELSE                 jt_RESERVED
jt_EXTENDS              jt_RESERVED
jt_FALSE                jt_RESERVED
jt_FINAL                jt_RESERVED
jt_FINALLY              jt_RESERVED
jt_FLOAT                jt_RESERVED
jt_FOR                  jt_RESERVED
jt_FUNCTION             jt_RESERVED
jt_GOTO                 jt_RESERVED
jt_IF                   jt_RESERVED
jt_IMPLEMENTS           jt_RESERVED
jt_IMPORT               jt_RESERVED
jt_IN                   jt_RESERVED
jt_INSTANCEOF           jt_RESERVED
jt_INT                  jt_RESERVED
jt_INTERFACE            jt_RESERVED
jt_LONG                 jt_RESERVED
jt_NATIVE               jt_RESERVED
jt_NEW                  jt_RESERVED
jt_NULL                 jt_RESERVED
jt_PACKAGE              jt_RESERVED
jt_PRIVATE              jt_RESERVED
jt_PROTECTED            jt_RESERVED
jt_PUBLIC               jt_RESERVED
jt_RETURN               jt_RESERVED
jt_SHORT                jt_RESERVED
jt_STATIC               jt_RESERVED
jt_SUPER                jt_RESERVED
jt_SWITCH               jt_RESERVED
jt_SYCHRONIZ            jt_RESERVED
jt_THIS                 jt_RESERVED
jt_THROW                jt_RESERVED
jt_THROWS               jt_RESERVED
jt_TRANSIENT            jt_RESERVED
jt_TRUE                 jt_RESERVED
jt_TRY                  jt_RESERVED
jt_VAR                  jt_RESERVED
jt_VOID                 jt_RESERVED
jt_WHILE                jt_RESERVED
jt_WITH                 jt_RESERVED

jt_COMMA                jt_SYMBOL
jt_EQUALS               jt_SYMBOL
jt_AUTOINC              jt_SYMBOL
jt_AUTODEC              jt_SYMBOL
jt_AUTOMULT             jt_SYMBOL
jt_AUTODIV              jt_SYMBOL
jt_AUTOMOD              jt_SYMBOL
jt_AUTOSHL              jt_SYMBOL
jt_AUTOSHR              jt_SYMBOL
jt_AUTOSHR_SIGNED       jt_SYMBOL
jt_AUTOAND              jt_SYMBOL
jt_AUTOXOR              jt_SYMBOL
jt_AUTOOR               jt_SYMBOL
jt_CONDITIONAL          jt_SYMBOL
jt_LOGOR                jt_SYMBOL
jt_LORAND               jt_SYMBOL
jt_BITOR                jt_SYMBOL
jt_BITXOR               jt_SYMBOL
jt_BITAND               jt_SYMBOL
jt_EQUALTO              jt_SYMBOL
jt_NOTEQUALTO           jt_SYMBOL
jt_LESS                 jt_SYMBOL
jt_LESSTHANEQ           jt_SYMBOL
jt_GREATER              jt_SYMBOL
jt_GREATERTHANEQ        jt_SYMBOL
jt_SHL                  jt_SYMBOL
jt_SHR                  jt_SYMBOL
jt_SHR_SIGNED           jt_SYMBOL
jt_PLUS                 jt_SYMBOL
jt_MINUS                jt_SYMBOL
jt_TIMES                jt_SYMBOL
jt_DIV                  jt_SYMBOL
jt_MOD                  jt_SYMBOL
jt_NOT                  jt_SYMBOL
jt_NEGATE               jt_SYMBOL
jt_INCREMENT            jt_SYMBOL
jt_DECREMENT            jt_SYMBOL
jt_LBRACKET             jt_SYMBOL
jt_RBRACKET             jt_SYMBOL
jt_LSBRACKET            jt_SYMBOL
jt_RSBRACKET            jt_SYMBOL
jt_DOT                  jt_SYMBOL


jt_ABS                  jt_BUILTINMETHOD
jt_ACOS                 jt_BUILTINMETHOD
jt_ALERT                jt_BUILTINMETHOD
jt_ANCHOR               jt_BUILTINMETHOD
jt_ASIN                 jt_BUILTINMETHOD
jt_ATAN                 jt_BUILTINMETHOD
jt_BACK                 jt_BUILTINMETHOD
jt_BIG                  jt_BUILTINMETHOD
jt_BLINK                jt_BUILTINMETHOD
jt_BLUR                 jt_BUILTINMETHOD
jt_BOLD                 jt_BUILTINMETHOD
jt_CEIL                 jt_BUILTINMETHOD
jt_CHARAT               jt_BUILTINMETHOD
jt_CLEAR                jt_BUILTINMETHOD
jt_CLEARTIMEOUT         jt_BUILTINMETHOD
jt_CLICK                jt_BUILTINMETHOD
jt_CLOSE                jt_BUILTINMETHOD
jt_CONFIRM              jt_BUILTINMETHOD
jt_COS                  jt_BUILTINMETHOD
jt_ESCAPE               jt_BUILTINMETHOD
jt_EVAL                 jt_BUILTINMETHOD
jt_EXP                  jt_BUILTINMETHOD
jt_FIXED                jt_BUILTINMETHOD
jt_FLOOR                jt_BUILTINMETHOD
jt_FOCUS                jt_BUILTINMETHOD
jt_FONTCOLOR            jt_BUILTINMETHOD
jt_FONTSIZE             jt_BUILTINMETHOD
jt_FORWARD              jt_BUILTINMETHOD
jt_GETDATE              jt_BUILTINMETHOD
jt_GETDAY               jt_BUILTINMETHOD
jt_GETHOURS             jt_BUILTINMETHOD
jt_GETMINUTES           jt_BUILTINMETHOD
jt_GETMONTH             jt_BUILTINMETHOD
jt_GETSECONDS           jt_BUILTINMETHOD
jt_GETTIME              jt_BUILTINMETHOD
jt_GETTIMEZONEOFFSET    jt_BUILTINMETHOD
jt_GETYEAR              jt_BUILTINMETHOD
jt_GO                   jt_BUILTINMETHOD
jt_INDEXOF              jt_BUILTINMETHOD
jt_ISNAN                jt_BUILTINMETHOD
jt_ITALICS              jt_BUILTINMETHOD
jt_LASTINDEXOF          jt_BUILTINMETHOD
jt_LINK                 jt_BUILTINMETHOD
jt_LOG                  jt_BUILTINMETHOD
jt_MAX                  jt_BUILTINMETHOD
jt_MIN                  jt_BUILTINMETHOD
jt_OPEN                 jt_BUILTINMETHOD
jt_PARSE                jt_BUILTINMETHOD
jt_PARSEFLOAT           jt_BUILTINMETHOD
jt_PARSEINT             jt_BUILTINMETHOD
jt_POW                  jt_BUILTINMETHOD
jt_PROMPT               jt_BUILTINMETHOD
jt_RANDOM               jt_BUILTINMETHOD
jt_ROUND                jt_BUILTINMETHOD
jt_SELECT               jt_BUILTINMETHOD
jt_SETDATE              jt_BUILTINMETHOD
jt_SETHOURS             jt_BUILTINMETHOD
jt_SETMINUTES           jt_BUILTINMETHOD
jt_SETMONTH             jt_BUILTINMETHOD
jt_SETSECONDS           jt_BUILTINMETHOD
jt_SETTIMEOUT           jt_BUILTINMETHOD
jt_SETTIME              jt_BUILTINMETHOD
jt_SETYEAR              jt_BUILTINMETHOD
jt_SIN                  jt_BUILTINMETHOD
jt_SMALL                jt_BUILTINMETHOD
jt_SQRT                 jt_BUILTINMETHOD
jt_STRIKE               jt_BUILTINMETHOD
jt_SUB                  jt_BUILTINMETHOD
jt_SUBMIT               jt_BUILTINMETHOD
jt_SUBSTRING            jt_BUILTINMETHOD
jt_SUP                  jt_BUILTINMETHOD
jt_TAN                  jt_BUILTINMETHOD
jt_TOGMTSTRING          jt_BUILTINMETHOD
jt_TOLOCALESTRING       jt_BUILTINMETHOD
jt_TOLOWERCASE          jt_BUILTINMETHOD
jt_TOUPPERCASE          jt_BUILTINMETHOD
jt_UNESCAPE             jt_BUILTINMETHOD
jt_UTC                  jt_BUILTINMETHOD
jt_WRITE                jt_BUILTINMETHOD
jt_WRITELN              jt_BUILTINMETHOD
