/******************************************************************************
	Color Coding Script Base File
	by B. Collier Jones
	Version 4.5.1
	Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
	
	Notes:
	- The only thing that is different between the various parsers are the
	  language combinations at the bottom of this file and the name in
	  the %%language section
	- This file is meant to serve as a template for all parsers.  After the
	  'Begin Language Includes' comment, include the individual languages you
	  want this parser to include.  Then, set the name in the %%language section
	  of this file to the name of this parser.  Save and compile.
	- Element Ranges
	  Default Elements: 0-4 (5 elements/states)
	  Server-Side Scripting: 5-39 (35 elements/states)
	  HTML Attributes 40-54 (10 elements/states)
	  HTML Elements: 55-114 (50 elements/states)
	  Client-Side Scripts: 115-149 (35 elements/states)
	  StyleSheets: 150-164 (15 elements/states)
	  Null: 255
	
	Revision History:
	01/18/2000 - Rewritten from HTML+ 4.0 Beta
	01/22/2000 - Modified Ranges to allow for more attribute elements
	10/28/2000 - Uncommented 'Default Text' style
******************************************************************************/
// Uncomment to allow highlighting of HTML Attributes
//#define SHOW_HTML_ATTRIBS

// Ranges
#define DEFAULT_ELEMENT_BASE		0
#define DEFAULT_ELEMENT_MAX			4
#define SERVER_SIDE_SCRIPT_BASE		5
#define SERVER_SIDE_SCRIPT_MAX		39
#define HTML_ATTRIBUTE_BASE			40
#define HTML_ATTRIBUTE_MAX			54
#define HTML_ELEMENT_BASE			55
#define HTML_ELEMENT_MAX			114
#define CLIENT_SIDE_SCRIPT_BASE		115
#define CLIENT_SIDE_SCRIPT_MAX		149
#define STYLE_SHEET_BASE			150
#define STYLE_SHEET_MAX				164

// Elements
#define DEFAULT_BASE				DEFAULT_ELEMENT_BASE
#define DEFAULT						DEFAULT_BASE + 0
#define NULL						255

// States
#define IN_DEFAULT					DEFAULT_BASE + 0
#define IN_NULL						255

// Common Elements
#define ALPHA						'[_A-Za-z0-9]'
#define NOT_ALPHA					'[^_A-Za-z0-9]'
#define ALL_CHARS					'[\x00-\xFF]'
#define NUM_START					'[0-9]'
#define NOT_NUM_START				'[^0-9]'
#define NUM_CONTAINS				'[0-9.]'
#define NOT_NUM_CONTAINS			'[^0-9.]'
#define ID_START					'[a-zA-Z_]'
#define NOT_ID_START				'[^a-zA-Z_]'
#define ID_CONTAINS					'[a-zA-Z_0-9]'
#define NOT_ID_CONTAINS				'[^a-zA-Z_0-9]'
#define NO_CHARS					'[]'
#define DONT_CARE					ALL_CHARS
#define ALL_STATES					[0..255]
#define DEFAULT_BACKGROUND			clWhite
#define DEFAULT_FOREGROUND			clBlack

// Additional Colors
// Default color for server-side scripting background
#define clLtSilver					15329769
#define clOrange					33023
#define clSoftBlue					12615680

// Language Declaration
%%language
Name							=	'JSP'
Case							=	__INSENSITIVE
StartState						=	[IN_DEFAULT]
Anchor							 =	[DEFAULT]
//ContextStates					=	(DEFAULT [IN_DEFAULT])
//BoundStates						+=	[]
EditableStyles						('Default Text'					, DEFAULT)
ExampleText						=	'Default Text\n'

%%effects
DEFAULT					[]					DEFAULT_FOREGROUND		DEFAULT_BACKGROUND

%%map
DEFAULT					DEFAULT

/*******************************************************************************
	Begin Language Includes
*******************************************************************************/
#include <languages/html/html.sc>
#include <languages/css/css.sc>
#include <languages/client/javascript.sc>
#include <languages/server/jsp.sc>

// Include attributes last so that all "virtual" elements can be defined
#ifdef SHOW_HTML_ATTRIBS
#include <languages/html/attributes.sc>
#endif
