/******************************************************************************
	SC
	by B. Collier Jones
	Version 1.0
	Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
	
	Revision History:
	01/07/2000 - Initial Creation
******************************************************************************/

#define DEFAULT					0
#define COMMENT					1
#define COMMENT_LINE_START		2
#define COMMENT_LINE_STOP		3
#define COMMENT_STAR_START		4
#define COMMENT_STAR_STOP		5
#define NUMBER					6
#define PREPROC					7
#define SECTION					8
#define STRING					9
#define STRING_START			10
#define STRING_STOP				11

#define IN_DEFAULT				0
#define IN_COMMENT_LINE			1
#define IN_COMMENT_STAR			2
#define IN_STRING				3

#define ALPHA					'[A-Za-z0-9]'
#define NON_ALPHA				'[^A-Za-z0-9]'
#define ALL_CHARS				'[\x00-\xFE]'
#define NO_CHARS				'[]'
#define DONT_CARE				ALL_CHARS

%%language
Name						=	'Syntax Color Coding'
Case						=	__SENSITIVE
StartState					=	[IN_DEFAULT]
Anchor						=	[DEFAULT]
EditableStyles					('Default Text'					, DEFAULT),
								('Comment'						, COMMENT),
								('Number'						, NUMBER),
								('Preprocessor Directive'		, PREPROC),
								('Section Heading'				, SECTION),
								('String'						, STRING)
ExampleText					=	'#define DEFAULT 0\n\
								\%%words\n\
								// Generic Keyword\n\
								\\'keyword\'	DONT_CARE	KEYWORD'
								
%%words
// Line Comments
'\/\/'					DONT_CARE			COMMENT_LINE_START		[IN_DEFAULT]
'\n'					DONT_CARE			COMMENT_LINE_STOP		[IN_COMMENT_LINE]
// Star Comments
'\/*'					DONT_CARE			COMMENT_STAR_START		[IN_DEFAULT]
'*\/'					DONT_CARE			COMMENT_STAR_STOP		[IN_COMMENT_STAR]
// Strings
'\''					DONT_CARE			STRING_START			[IN_DEFAULT]
'\''					DONT_CARE			STRING_STOP				[IN_STRING]

%%kwtables
ForState [IN_DEFAULT] endswith NON_ALPHA (
	// Preprocessor Directives
	PREPROC			is	'#ifdef', '#define', '#ifndef', '#include', '#else',
						'#endif'
	// Section Headings
	SECTION			is	'%%language', '%%kwtables', '%%words', '%%tokens',
						'%%handlers', '%%map', '%%states', '%%effects',
						'%%templates', '%%autoreplace'
)

%%tokens
InState IN_DEFAULT (
	DEFAULT			'[^0-9]'		DONT_CARE?			DONT_CARE		_discard_
	NUMBER			'[0-9]'			'[0-9.]'?			'[^0-9]'		_discard_
)

InState IN_COMMENT_LINE (
	COMMENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_COMMENT_STAR (
	COMMENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_STRING (
	STRING				'[^\'\\]'			DONT_CARE?			DONT_CARE			_discard_
	STRING				'\\'				DONT_CARE			DONT_CARE			_discard_
)

%%states
COMMENT_LINE_START		(-[IN_DEFAULT]							+[IN_COMMENT_LINE])
COMMENT_LINE_STOP		(-[IN_COMMENT_LINE]						+[IN_DEFAULT])

COMMENT_STAR_START		(-[IN_DEFAULT]							+[IN_COMMENT_STAR])
COMMENT_STAR_STOP		(-[IN_COMMENT_STAR]						+[IN_DEFAULT])

STRING_START			(-[IN_DEFAULT]							+[IN_STRING])
STRING_STOP				(-[IN_STRING]							+[IN_DEFAULT])

%%effects
COMMENT					[]					clGreen				clWhite*
DEFAULT					[]					clBlack				clWhite
NUMBER					[]					clGreen				clWhite*
PREPROC					[]					clBlue				clWhite*
SECTION					[]					clNavy				clWhite*
STRING					[]					clTeal				clWhite*

%%map
DEFAULT					DEFAULT
COMMENT					COMMENT
COMMENT_LINE_START		COMMENT
COMMENT_LINE_STOP		COMMENT
COMMENT_STAR_START		COMMENT
COMMENT_STAR_STOP		COMMENT
NUMBER					NUMBER
PREPROC					PREPROC
SECTION					SECTION
STRING					STRING
STRING_START			STRING
STRING_STOP				STRING
