/* -------------------------------------------------------------------------------------------------
 *  Text Parser
/* -------------------------------------------------------------------------------------------------
 *  Author: Nick Bradbury 
 *	Date: September 1998
 *  Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
 *  Use of this script in non-Allaire products is strictly prohibited.
------------------------------------------------------------------------------------------------- */

#define pt_DEFAULT                  0
#define pt_PLAINTEXT                1
#define pt_NEWLINE                  2 

#define _all_chars_                 '[\x01-\xFF]'
#define _dont_care_                 _all_chars_
#define _DEFAULT_BACKGROUND         clWhite
#define _DEFAULT_FOREGROUND         clBlack


%%language
Name                      = 'Plain text'
ExampleText               = 'Plain text\n'
Anchor                    = pt_PLAINTEXT
EditableStyles              ('Default',          pt_DEFAULT)


//%%words
//' '        _dont_care_       pt_PLAINTEXT
 

%%tokens
pt_PLAINTEXT    '[\x00-\x0C\x0E-\xFE]'     '[^\n]'?        '\n'           _discard_
pt_NEWLINE      '\n'                       _dont_care_?    _dont_care_    _discard_

%%effects
pt_DEFAULT      []       _DEFAULT_FOREGROUND        _DEFAULT_BACKGROUND

%%map
pt_PLAINTEXT    pt_DEFAULT
pt_NEWLINE      pt_DEFAULT

