/******************************************************************************
	VBScript Color Coding Script
	by B. Collier Jones (brjones3@vt.edu)
	Version 1.0 (11/17/99)

        *  Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
	
	11/17/99 - Original Date
	10/28/00 - BCJ - Added 'Default Text' editable style
******************************************************************************/

#define DEFAULT						0

#define VB							161
#define VB_CODE						162
#define VB_COMMENT_START			163
#define VB_COMMENT_STOP				164
#define VB_COMMENT					165
#define VB_FUNCTION					166
#define VB_IDENTIFIER				167
#define VB_METHOD					168
#define VB_NUMBER					169
#define VB_OBJECT					170
#define VB_OPERATOR					171
#define VB_RESERVED					172
#define VB_STRING					173
#define VB_STRING_START				174
#define VB_STRING_STOP				175
#define VB_WHITESPACE				176
#define VB_TAGS						177


#define IN_DEFAULT					0

// The actual VB states go first so that their color coding takes precedence over others.
#define IN_VB_CODE					1
#define IN_VB_COMMENT				2
#define IN_VB_STRING				3

#define ALPHA						'[A-Za-z0-9]'
#define NON_ALPHA					'[^A-Za-z0-9]'
#define ALL_CHARS					'[\x01-\xFE]'
#define NO_CHARS					'[]'
#define DONT_CARE					ALL_CHARS

%%language
Name							=	'VBScript'
Case							=	__INSENSITIVE
StartState						=	[IN_DEFAULT]
Anchor							=	[DEFAULT]
									
ContextStates					=	(DEFAULT [IN_DEFAULT])

EditableStyles						('Comments'				, VB_COMMENT),
									//('Default'			, VB_CODE),
									('Functions'	, VB_FUNCTION),
									('Identifier'			, VB_IDENTIFIER),
									('Methods'				, VB_METHOD),
									('Objects'				, VB_OBJECT),
									('Operators'			, VB_OPERATOR),
									('Numbers'				, VB_NUMBER),
									('Reserved Words'		, VB_RESERVED),
									('Strings'				, VB_STRING),
									('Default Text'			, DEFAULT)
						
									
									
ExampleText						=	'\' VBScript Syntax Highlighting \n\
									Dim worldString = "Hello, world"\n\
									Document.Write Len(worldString)\n\
									Document.Write "<P>" & UCase(worldString)\n\
									Document.Write "<P>" & abs(7) \n\
									'

/******************************************************************************
	VB Syntax
******************************************************************************/

%%words
// VB Comments
'\''						DONT_CARE			VB_COMMENT_START			[IN_DEFAULT]
'\n'						DONT_CARE			VB_COMMENT_STOP				[IN_VB_COMMENT]
// VB Built-in Functions
// VBScript Built-in Functions
'abs'						'[(]'				VB_FUNCTION					[IN_DEFAULT]
'asc'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'atn'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cbool'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cbyte'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cdate'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cdbl'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'chr'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cint'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'clng'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cos'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'csng'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'cstr'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
//'date'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'dateserial'				'[(]'			VB_FUNCTION					[IN_DEFAULT]
'datevalue'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'day'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'erase'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'exp'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'fix'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'filter'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'formatcurrency'			'[(]'			VB_FUNCTION					[IN_DEFAULT]
'formatdatetime'			'[(]'			VB_FUNCTION					[IN_DEFAULT]
'formatnumber'				'[(]'			VB_FUNCTION					[IN_DEFAULT]
'formatpercent'				'[(]'			VB_FUNCTION					[IN_DEFAULT]
'hex'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'hour'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'instr'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'instrrev'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'int'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isarray'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isdate'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isempty'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isnull'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isnumeric'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'isobject'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'join'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'lbound'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'lcase'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'left'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'len'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'log'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'ltrim'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'mid'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'minute'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'month'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'now'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'oct'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'randomize'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'replace'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'right'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'rnd'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'rtrim'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'second'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'sin'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'sgn'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'space'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'split'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'sqr'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'strcomp'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'strreverse'				'[(]'			VB_FUNCTION					[IN_DEFAULT]
//'string'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'tan'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'time'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'timer'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'timeserial'				'[(]'			VB_FUNCTION					[IN_DEFAULT]
'timevalue'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'trim'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'ubound'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'ucase'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
'vartype'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'weekday'					'[(]'			VB_FUNCTION					[IN_DEFAULT]
'year'						'[(]'			VB_FUNCTION					[IN_DEFAULT]
// VB Identifiers
'a'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'b'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'c'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'd'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'e'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'f'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'g'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'h'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'i'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'j'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'k'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'l'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'm'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'n'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'o'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'p'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'q'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'r'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
's'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
't'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'u'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'v'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'w'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'x'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'y'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
'z'							DONT_CARE			VB_IDENTIFIER					[IN_DEFAULT]
// VB Methods (methods start with a dot
'.'							DONT_CARE			VB_METHOD						[IN_DEFAULT]
// VB Numbers
'0'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'1'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'2'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'3'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'4'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'5'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'6'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'7'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'8'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
'9'							DONT_CARE			VB_NUMBER						[IN_DEFAULT]
// VB Built-in Objects
'document'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'date'						'[. ]'				VB_OBJECT						[IN_DEFAULT]
'frame'						'[. ]'				VB_OBJECT						[IN_DEFAULT]
'history'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'image'						'[. ]'				VB_OBJECT						[IN_DEFAULT]
'location'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'math'						'[. ]'				VB_OBJECT						[IN_DEFAULT]
'navigator'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'plugin'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'string'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
'window'					'[. ]'				VB_OBJECT						[IN_DEFAULT]
// VB Operators
','							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'~'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'!'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'@'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'#'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'$'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'%'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'*'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'_'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
';'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'?'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'('							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
')'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'{'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'}'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'['							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
']'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'+'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'-'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'='							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'^'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'&'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'/'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'\\'						DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'<'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'<='						DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'>'							DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'>='						DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'<>'						DONT_CARE			VB_OPERATOR					[IN_DEFAULT]
'and'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'eqv'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'imp'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'is'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'mod'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'not'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'or'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
'xor'						NON_ALPHA			VB_OPERATOR					[IN_DEFAULT]
// VB Reserved Words
'call'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'case'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'dim'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'do'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'each'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'else'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'elseif'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'empty'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'end'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'exit'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'explicit'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'function'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'false'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'for'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'if'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'loop'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'next'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'nothing'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'null'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'on error'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'option'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'preserve'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'redim'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'resume'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'select'					NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'set'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'sub'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'then'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'true'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'until'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'wend'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
'while'						NON_ALPHA			VB_RESERVED					[IN_DEFAULT]
// VB Strings
'"'							DONT_CARE			VB_STRING_START				[IN_DEFAULT]
'"'							DONT_CARE			VB_STRING_STOP				[IN_VB_STRING]

%%handlers
VB_IDENTIFIER				'[A-Za-z0-9_]'?		'[^A-Za-z0-9_]'		_discard_
VB_METHOD					'[A-Za-z0-9_]'?		'[^A-Za-z0-9_]'		_discard_
VB_NUMBER					'[0-9.]'?			'[^0-9.]'			_discard_

%%tokens
InState IN_VB_COMMENT (
	VB_COMMENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VB_STRING (
	//VB_STRING				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
	VB_STRING				'[^"\\]'			DONT_CARE?			DONT_CARE			_discard_
	VB_STRING				'\\'				DONT_CARE			DONT_CARE			_discard_
)

%%states
VB_COMMENT_START			(+[IN_VB_COMMENT]						-[IN_DEFAULT])
VB_COMMENT_STOP				(-[IN_VB_COMMENT]						+[IN_DEFAULT])

VB_STRING_START				(+[IN_VB_STRING]						-[IN_DEFAULT])
VB_STRING_STOP				(-[IN_VB_STRING]						+[IN_DEFAULT])

%%effects
//VB_CODE					[]					clBlack				clWhite
DEFAULT						[]					clBlack				clWhite
VB_COMMENT					[]					clGreen				clWhite*
VB_FUNCTION					[fsBold]			clNavy				clWhite*
VB_IDENTIFIER				[]					clBlack				clWhite*
VB_METHOD					[fsBold]			clBlack				clWhite*
VB_OBJECT					[]					clBlue				clWhite*
VB_OPERATOR					[fsBold]			clNavy				clWhite*
VB_NUMBER					[]					clGreen				clWhite*
VB_RESERVED					[fsBold]			clNavy				clWhite*
VB_STRING					[]					clTeal				clWhite*

%%map
DEFAULT						DEFAULT
VB_CODE						VB_CODE
VB_COMMENT					VB_COMMENT
VB_COMMENT_START			VB_COMMENT
VB_COMMENT_STOP				VB_COMMENT
VB_FUNCTION					VB_FUNCTION
VB_IDENTIFIER				VB_IDENTIFIER
VB_METHOD					VB_METHOD
VB_NUMBER					VB_NUMBER
VB_OBJECT					VB_OBJECT
VB_OPERATOR					VB_OPERATOR
VB_RESERVED					VB_RESERVED
VB_STRING					VB_STRING
VB_STRING_START				VB_STRING
VB_STRING_STOP				VB_STRING
