/*******************************************************************************
	VTML Parser v1.0
	by B. Collier Jones
	Copyright (c) 1997-2002 Macromedia, Inc. All Rights Reserved. Consult Software License Agreement for more details.
	
	01/22/2000 - Initial Creation
	01/23/2000 - Added support for quoted strings in 'Quoted Attributes' and
				 'Single-Quoted Attributes'
			   - Added support for coloring of '-' in 'Numbers'
			   - Forgot to add InState for INPUT tag
			   - Added tokens VALUEMAP, VALKEY, VERSIONS, VERKEY
			   - Added support for HTML special characters in quoted attribs.
			   - Added support for HTML tags in quoted attribs.
	10/28/2000 - Added 'Default Text' editable style
******************************************************************************/

#define DEFAULT						0

#define ATTRIB						1
#define ATTRIB_OFF					2
#define ATTRIB_ON					3
#define ATTRIBCATEGORIES			4
#define ATTRIBCATEGORIES_OFF		5
#define ATTRIBCATEGORIES_ON			6
#define ATTRIBGROUP					7
#define ATTRIBGROUP_OFF				8
#define ATTRIBGROUP_ON				9
#define ATTRIBOPTION				10
#define ATTRIBOPTION_OFF			11
#define ATTRIBOPTION_ON				12
#define ATTRIBUTES					13
#define ATTRIBUTES_OFF				14
#define ATTRIBUTES_ON				15
#define AUTOFORMATTER				16
#define AUTOFORMATTER_OFF			17
#define AUTOFORMATTER_ON			18
#define CAT							19
#define CAT_OFF						20
#define CAT_ON						21
#define CONTAINER					22
#define CONTAINER_OFF				23
#define CONTAINER_ON				24
#define CONTROL						25
#define CONTROL_OFF					26
#define CONTROL_ON					27
#define DEFAULT_TFS					28
#define DEFAULT_TFS_OFF				29
#define DEFAULT_TFS_ON				30
#define E							31
#define E_OFF						32
#define E_ON						33
#define EDITORLAYOUT				34
#define EDITORLAYOUT_OFF			35
#define EDITORLAYOUT_ON				36
#define EVENT						37
#define EVENT_OFF					38
#define EVENT_ON					39
#define GENERALSETTINGS				40
#define GENERALSETTINGS_OFF			41
#define GENERALSETTINGS_ON			42
#define GENERIC						43
#define GENERIC_OFF					44
#define GENERIC_ON					45
#define INPUT						46
#define INPUT_OFF					47
#define INPUT_ON					48
#define ITEM						49
#define ITEM_OFF					50
#define ITEM_ON						51
#define NEXTPAGE					52
#define NEXTPAGE_OFF				53
#define NEXTPAGE_ON					54
#define OUTLINEPROFILE				55
#define OUTLINEPROFILE_OFF			56
#define OUTLINEPROFILE_ON			57
#define PAGE						58
#define PAGE_OFF					59
#define PAGE_ON						60
#define PAGELAYOUT					61
#define PAGELAYOUT_OFF				62
#define PAGELAYOUT_ON				63
#define PARAM						64
#define PARAM_OFF					65
#define PARAM_ON					66
#define RECOGNIZEDTAG				67
#define RECOGNIZEDTAG_OFF			68
#define RECOGNIZEDTAG_ON			69
#define RECOGNIZEDTAGS				70
#define RECOGNIZEDTAGS_OFF			71
#define RECOGNIZEDTAGS_ON			72
#define TAG							73
#define TAG_OFF						74
#define TAG_ON						75
#define TAGDESCRIPTION				76
#define TAGDESCRIPTION_OFF			77
#define TAGDESCRIPTION_ON			78
#define TAGFORMATSETTINGS			79
#define TAGFORMATSETTINGS_OFF		80
#define TAGFORMATSETTINGS_ON		81
#define TAGLAYOUT					82
#define TAGLAYOUT_OFF				83
#define TAGLAYOUT_ON				84
#define TEMPLATE					85
#define TEMPLATE_OFF				86
#define TEMPLATE_ON					87
#define TFS							88
#define TFS_OFF						89
#define TFS_ON						90
#define VALKEY						91
#define VALKEY_OFF					92
#define VALKEY_ON					93
#define VALUEMAP					94
#define VALUEMAP_OFF				95
#define VALUEMAP_ON					96
#define VERKEY						97
#define VERKEY_OFF					98
#define VERKEY_ON					99
#define VERSIONS					100
#define VERSIONS_OFF				101
#define VERSIONS_ON					102
#define WIZARD						103
#define WIZARD_OFF					104
#define WIZARD_ON					105
#define WIZBREAK					106
#define WIZBREAK_OFF				107
#define WIZBREAK_ON					108
#define WIZCONTINUE					109
#define WIZCONTINUE_OFF				110
#define WIZCONTINUE_ON				111
#define WIZELSE						112
#define WIZELSE_OFF					113
#define WIZELSE_ON					114
#define WIZELSEIF					115
#define WIZELSEIF_OFF				116
#define WIZELSEIF_ON				117
#define WIZIF						118
#define WIZIF_OFF					119
#define WIZIF_ON					120
#define WIZINCLUDE					121
#define WIZINCLUDE_OFF				122
#define WIZINCLUDE_ON				123
#define WIZLOOP						124
#define WIZLOOP_OFF					125
#define WIZLOOP_ON					126
#define WIZSET						127
#define WIZSET_OFF					128
#define WIZSET_ON					129
#define FSETTING					130
#define FSETTING_ON					131
#define FSETTING_OFF				132

#define ATTRIB_NUM					133
#define ATTRIB_NUM_ON				134
#define ATTRIB_NUM_OFF				135
#define ATTRIB_QUOTED				136
#define ATTRIB_QUOTED_ON			137
#define ATTRIB_QUOTED_OFF			138
#define ATTRIB_SQUOTED				139
#define ATTRIB_SQUOTED_ON			140
#define ATTRIB_SQUOTED_OFF			141
#define ATTRIB_NONQUOTED			142
#define ATTRIB_NONQUOTED_ON			143
#define ATTRIB_NONQUOTED_OFF		144

#define COMMENT						144
#define COMMENT_ON					145
#define COMMENT_OFF					146

#define ATTRIB_HTML_SPECIAL			147
#define ATTRIB_HTML_TAG				148
#define ATTRIB_HTML_TAG_ON			149
#define ATTRIB_HTML_TAG_OFF			150
#define ATTRIB_DQ_HTML_TAG_ON		151
#define ATTRIB_DQ_HTML_TAG_OFF		152

#define VTINCLUDE					153
#define VTINCLUDE_ON				154
#define VTINCLUDE_OFF				155

// States
#define IN_DEFAULT					0

#define IN_ATTRIB					1
#define IN_ATTRIBCATEGORIES			2
#define IN_ATTRIBGROUP				3
#define IN_ATTRIBOPTION				4
#define IN_ATTRIBUTES				5
#define IN_CAT						6
#define IN_CONTAINER				7
#define IN_CONTROL					8
#define IN_E						9
#define IN_EDITORLAYOUT				10
#define IN_EVENT					11
#define IN_GENERALSETTINGS			12
#define IN_GENERIC					13
#define IN_INPUT					14
#define IN_ITEM						15
#define IN_NEXTPAGE					16
#define IN_OUTLINEPROFILE			17
#define IN_PAGE						18
#define IN_PAGELAYOUT				19
#define IN_PARAM					20
#define IN_RECOGNIZEDTAG			21
#define IN_RECOGNIZEDTAGS			22
#define IN_TAG						23
#define IN_TAGDESCRIPTION			24
#define IN_TAGLAYOUT				25
#define IN_TEMPLATE					26
#define IN_VALKEY					27
#define IN_VALUEMAP					28
#define IN_VERKEY					29
#define IN_VERSIONS					30
#define IN_WIZARD					31
#define IN_WIZBREAK					32
#define IN_WIZCONTINUE				33
#define IN_WIZELSE					34
#define IN_WIZELSEIF				35
#define IN_WIZIF					36
#define IN_WIZINCLUDE				37
#define IN_WIZLOOP					38
#define IN_WIZSET					39
#define	IN_AUTOFORMATTER			40
#define	IN_DEFAULT_TFS				41
#define	IN_TAGFORMATSETTINGS		42
#define	IN_TFS						43
#define IN_FSETTING					44
#define IN_VTINCLUDE				45

#define IN_ATTRIB_NUM				46
#define IN_ATTRIB_QUOTED			47
#define IN_ATTRIB_SQUOTED			48
#define IN_ATTRIB_NONQUOTED			49

#define IN_COMMENT					50

#define IN_ATTRIB_HTML_TAG			60
#define IN_ATTRIB_DQ_HTML_TAG		61

#define ATTRIB_STATES				1..45

// Common Elements
#define ALPHA						'[_A-Za-z0-9]'
#define NOT_ALPHA					'[^_A-Za-z0-9]'
#define ALL_CHARS					'[\x00-\xFF]'
#define NUM_START					'[0-9]'
#define NOT_NUM_START				'[^0-9]'
#define NUM_CONTAINS				'[0-9.]'
#define NOT_NUM_CONTAINS			'[^0-9.]'
#define ID_START					'[a-zA-Z_]'
#define NOT_ID_START				'[^a-zA-Z_]'
#define ID_CONTAINS					'[a-zA-Z_0-9]'
#define NOT_ID_CONTAINS				'[^a-zA-Z_0-9]'
#define NO_CHARS					'[]'
#define DONT_CARE					ALL_CHARS
#define ALL_STATES					[0..255]
#define DEFAULT_BACKGROUND			clWhite
#define DEFAULT_FOREGROUND			clBlack

#define clSoftBlue					12615680

%%language
Name							=	'VTML'
Case							=	__INSENSITIVE
StartState						=	[IN_DEFAULT]
Anchor							=	[ATTRIB_ON ATTRIBCATEGORIES_ON]
//ContextStates					=	(ATTRIB_ON [IN_ATTRIB]),
//									(ATTRIBCATEGORIES_ON [IN_ATTRIBCATEGORIES])
//BoundStates						=	[5..38 45 46]
EditableStyles						('Default Text'					, DEFAULT),
									('Tag - ATTRIB'					, ATTRIB),
									('Tag - ATTRIBCATEGORIES'		, ATTRIBCATEGORIES),
									('Tag - ATTRIBGROUP'			, ATTRIBGROUP),
									('Tag - ATTRIBOPTION'			, ATTRIBOPTION),
									('Tag - ATTRIBUTES'				, ATTRIBUTES),
									('Tag - CAT'					, CAT),
									('Tag - CONTAINER'				, CONTAINER),
									('Tag - CONTROL'				, CONTROL),
									('Tag - E'						, E),
									('Tag - EDITORLAYOUT'			, EDITORLAYOUT),
									('Tag - EVENT'					, EVENT),
									('Tag - INPUT'					, INPUT),
									('Tag - ITEM'					, ITEM),
									('Tag - NEXTPAGE'				, NEXTPAGE),
									('Tag - PAGE'					, PAGE),
									('Tag - PAGELAYOUT'				, PAGELAYOUT),
									('Tag - PARAM'					, PARAM),
									('Tag - TAG'					, TAG),
									('Tag - TAGDESCRIPTION'			, TAGDESCRIPTION),
									('Tag - TAGLAYOUT'				, TAGLAYOUT),
									('Tag - TEMPLATE'				, TEMPLATE),
									('Tag - WIZARD'					, WIZARD),
									('Tag - WIZBREAK'				, WIZBREAK),
									('Tag - WIZCONTINUE'			, WIZCONTINUE),
									('Tag - WIZELSE'				, WIZELSE),
									('Tag - WIZELSEIF'				, WIZELSEIF),
									('Tag - WIZIF'					, WIZIF),
									('Tag - WIZINCLUDE'				, WIZINCLUDE),
									('Tag - WIZLOOP'				, WIZLOOP),
									('Tag - WIZSET'					, WIZSET),
									('Tag - VALUEMAP'				, VALUEMAP),
									('Tag - VALKEY'					, VALKEY),
									('Tag - VERSIONS'				, VERSIONS),
									('Tag - VERKEY'					, VERKEY),
									('Tag - Generic'				, GENERIC),
									('Tag - AUTOFORMATTER'			, AUTOFORMATTER),
									('Tag - DEFAULT_TFS'			, DEFAULT_TFS),
									('Tag - TAGFORMATSETTINGS'		, TAGFORMATSETTINGS),
									('Tag - TFS'					, TFS),
									('Tag - GENERALSETTINGS'		, GENERALSETTINGS),
									('Tag - OUTLINEPROFILE'			, OUTLINEPROFILE),
									('Tag - RECOGNIZEDTAGS'			, RECOGNIZEDTAGS),
									('Tag - RECOGNIZEDTAG'			, RECOGNIZEDTAG),
									('Tag - FSETTING'				, FSETTING),
									('Tag - VTINCLUDE'				, VTINCLUDE),
									('Comments'						, COMMENT),
									('Attribute - Number'			, ATTRIB_NUM),
									('Attribute - Quoted'			, ATTRIB_QUOTED),
									//('Attribute - Single Quoted'	, ATTRIB_SQUOTED),
									('Attribute - Non-Quoted'		, ATTRIB_NONQUOTED),
									('Attribute - HTML Tags'		, ATTRIB_HTML_TAG),
									('Attribute - HTML Entities'	, ATTRIB_HTML_SPECIAL)
ExampleText						=	'<TAG NAME="SOUND">\n\'
								\	<EDITORLAYOUT WIDTH=440 LFWIDTH=528 HEIGHT=150 LFHEIGHT=177>\n\
								\	<CONTROL TYPE="Image" NAME="MOSAIC" CORNER="NW" RIGHT=5 DOWN=5 FILEPATH="Images/MOSAIC.bmp" AUTOSIZE/>\n\
		                                    \     <CONTAINER TYPE="Panel" NAME="pnlMain" WIDTH="MAXIMUM" HEIGHT=115 LFHEIGHT=136 MAXWIDTHPADDING=5 ANCHOR="MOSAIC" CORNER="NE" RIGHT=10 DOWN=-5>\n\
								\  \n\
			                              \             <CONTROL TYPE="Label" NAME="lblSrc" WIDTH=60 LFWIDTH=72 RIGHT=10 DOWN=20 CAPTION="Source:"/>\n\
			                              \             <CONTROL TYPE="FileBrowser" NAME="urlSrc" WIDTH="MAXIMUM" MAXWIDTHPADDING=10 ANCHOR="lblSrc" CORNER="NE" RELATIVE/>\n\
								\ \n\
			                              \             <CONTROL TYPE="Label" NAME="lblLoop" WIDTH="lblSrc" ANCHOR="lblSrc" CORNER="SW" DOWN=15 CAPTION="Loop:"/>\n\
			                              \             <CONTROL TYPE="DropDown" NAME="dropLoop" WIDTH=100 LFWIDTH=120 ANCHOR="lblLoop" CORNER="NE" EDITABLE>\n\
				                        \                       <ITEM VALUE="infinite"	CAPTION="infinite"/>\n\
			                              \             </CONTROL>\n\
			                              \             <CONTROL TYPE="Label" NAME="lblLoopDesc" WIDTH="MAXIMUM" ANCHOR="dropLoop" CORNER="NE" RIGHT=10 CAPTION="(number of times to play the sound)"/>\n\
								\ \n\
			                              \             <CONTROL TYPE="Label" NAME="lblDelay" WIDTH="lblSrc" ANCHOR="lblLoop" CORNER="SW" DOWN=15 CAPTION="Delay:"/>\n\
			                              \             <CONTROL TYPE="TextBox" NAME="numDelay" WIDTH=30 LFWIDTH=36 ANCHOR="lblDelay" CORNER="NE"/>\n\
			                              \             <CONTROL TYPE="Label" NAME="lblDelayDesc" WIDTH="MAXIMUM" ANCHOR="numDelay" CORNER="NE" RIGHT=10 CAPTION="(delay in seconds before the sound plays)"/>\n\
		                                    \    </CONTAINER>\n\
								\ \n\
		                                    \    <CONTROL TYPE="CheckBox" NAME="checkQuotes" WIDTH=120 LFWIDTH=144 ANCHOR="pnlMain" CORNER="SW" DOWN=10 CAPTION="Quote all attributes" CHECKED/>\n\
		                                    \    <CONTROL TYPE="CheckBox" NAME="checkSingleQuotes" WIDTH=150 LFWIDTH=180 ANCHOR="checkQuotes" CORNER="NE" RIGHT=15 CAPTION="Single quotes on attributes"/>\n\
	                                          \    </EDITORLAYOUT>\n'



%%words
'<ATTRIB'				NOT_ALPHA			ATTRIB_ON				[IN_DEFAULT]
'</ATTRIB'				NOT_ALPHA			ATTRIB_ON				[IN_DEFAULT]
'>'						DONT_CARE			ATTRIB_OFF				[IN_ATTRIB]
'<ATTRIBCATEGORIES'		NOT_ALPHA			ATTRIBCATEGORIES_ON		[IN_DEFAULT]
'</ATTRIBCATEGORIES'	NOT_ALPHA			ATTRIBCATEGORIES_ON		[IN_DEFAULT]
'>'						DONT_CARE			ATTRIBCATEGORIES_OFF	[IN_ATTRIBCATEGORIES]
'<ATTRIBGROUP'			NOT_ALPHA			ATTRIBGROUP_ON			[IN_DEFAULT]
'</ATTRIBGROUP'			NOT_ALPHA			ATTRIBGROUP_ON			[IN_DEFAULT]
'>'						DONT_CARE			ATTRIBGROUP_OFF			[IN_ATTRIBGROUP]
'<ATTRIBOPTION'			NOT_ALPHA			ATTRIBOPTION_ON			[IN_DEFAULT]
'</ATTRIBOPTION'		NOT_ALPHA			ATTRIBOPTION_ON			[IN_DEFAULT]
'>'						DONT_CARE			ATTRIBOPTION_OFF		[IN_ATTRIBOPTION]
'<ATTRIBUTES'			NOT_ALPHA			ATTRIBUTES_ON			[IN_DEFAULT]
'</ATTRIBUTES'			NOT_ALPHA			ATTRIBUTES_ON			[IN_DEFAULT]
'>'						DONT_CARE			ATTRIBUTES_OFF			[IN_ATTRIBUTES]
'<CAT'					NOT_ALPHA			CAT_ON					[IN_DEFAULT]
'</CAT'					NOT_ALPHA			CAT_ON					[IN_DEFAULT]
'>'						DONT_CARE			CAT_OFF					[IN_CAT]
'<CONTAINER'			NOT_ALPHA			CONTAINER_ON			[IN_DEFAULT]
'</CONTAINER'			NOT_ALPHA			CONTAINER_ON			[IN_DEFAULT]
'>'						DONT_CARE			CONTAINER_OFF			[IN_CONTAINER]
'<CONTROL'				NOT_ALPHA			CONTROL_ON				[IN_DEFAULT]
'</CONTROL'				NOT_ALPHA			CONTROL_ON				[IN_DEFAULT]
'>'						DONT_CARE			CONTROL_OFF				[IN_CONTROL]
'<E'					NOT_ALPHA			E_ON					[IN_DEFAULT]
'</E'					NOT_ALPHA			E_ON					[IN_DEFAULT]
'>'						DONT_CARE			E_OFF					[IN_E]
'<EDITORLAYOUT'			NOT_ALPHA			EDITORLAYOUT_ON			[IN_DEFAULT]
'</EDITORLAYOUT'		NOT_ALPHA			EDITORLAYOUT_ON			[IN_DEFAULT]
'>'						DONT_CARE			EDITORLAYOUT_OFF		[IN_EDITORLAYOUT]
'<EVENT'				NOT_ALPHA			EVENT_ON				[IN_DEFAULT]
'</EVENT'				NOT_ALPHA			EVENT_ON				[IN_DEFAULT]
'>'						DONT_CARE			EVENT_OFF				[IN_EVENT]
'<INPUT'				NOT_ALPHA			INPUT_ON				[IN_DEFAULT]
'</INPUT'				NOT_ALPHA			INPUT_ON				[IN_DEFAULT]
'>'						DONT_CARE			INPUT_OFF				[IN_INPUT]
'<ITEM'					NOT_ALPHA			ITEM_ON					[IN_DEFAULT]
'</ITEM'				NOT_ALPHA			ITEM_ON					[IN_DEFAULT]
'>'						DONT_CARE			ITEM_OFF				[IN_ITEM]
'<NEXTPAGE'				NOT_ALPHA			NEXTPAGE_ON				[IN_DEFAULT]
'</NEXTPAGE'			NOT_ALPHA			NEXTPAGE_ON				[IN_DEFAULT]
'>'						DONT_CARE			NEXTPAGE_OFF			[IN_NEXTPAGE]
'<PAGE'					NOT_ALPHA			PAGE_ON					[IN_DEFAULT]
'</PAGE'				NOT_ALPHA			PAGE_ON					[IN_DEFAULT]
'>'						DONT_CARE			PAGE_OFF				[IN_PAGE]
'<PAGELAYOUT'			NOT_ALPHA			PAGELAYOUT_ON			[IN_DEFAULT]
'</PAGELAYOUT'			NOT_ALPHA			PAGELAYOUT_ON			[IN_DEFAULT]
'>'						DONT_CARE			PAGELAYOUT_OFF			[IN_PAGELAYOUT]
'<PARAM'				NOT_ALPHA			PARAM_ON				[IN_DEFAULT]
'</PARAM'				NOT_ALPHA			PARAM_ON				[IN_DEFAULT]
'>'						DONT_CARE			PARAM_OFF				[IN_PARAM]
'<TAG'					NOT_ALPHA			TAG_ON					[IN_DEFAULT]
'</TAG'					NOT_ALPHA			TAG_ON					[IN_DEFAULT]
'>'						DONT_CARE			TAG_OFF					[IN_TAG]
'<TAGDESCRIPTION'		NOT_ALPHA			TAGDESCRIPTION_ON		[IN_DEFAULT]
'</TAGDESCRIPTION'		NOT_ALPHA			TAGDESCRIPTION_ON		[IN_DEFAULT]
'>'						DONT_CARE			TAGDESCRIPTION_OFF		[IN_TAGDESCRIPTION]
'<TAGLAYOUT'			NOT_ALPHA			TAGLAYOUT_ON			[IN_DEFAULT]
'</TAGLAYOUT'			NOT_ALPHA			TAGLAYOUT_ON			[IN_DEFAULT]
'>'						DONT_CARE			TAGLAYOUT_OFF			[IN_TAGLAYOUT]
'<TEMPLATE'				NOT_ALPHA			TEMPLATE_ON				[IN_DEFAULT]
'</TEMPLATE'			NOT_ALPHA			TEMPLATE_ON				[IN_DEFAULT]
'>'						DONT_CARE			TEMPLATE_OFF			[IN_TEMPLATE]
'<WIZARD'				NOT_ALPHA			WIZARD_ON				[IN_DEFAULT]
'</WIZARD'				NOT_ALPHA			WIZARD_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZARD_OFF				[IN_WIZARD]
'<WIZBREAK'				NOT_ALPHA			WIZBREAK_ON				[IN_DEFAULT]
'</WIZBREAK'			NOT_ALPHA			WIZBREAK_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZBREAK_OFF			[IN_WIZBREAK]
'<WIZCONTINUE'			NOT_ALPHA			WIZCONTINUE_ON			[IN_DEFAULT]
'</WIZCONTINUE'			NOT_ALPHA			WIZCONTINUE_ON			[IN_DEFAULT]
'>'						DONT_CARE			WIZCONTINUE_OFF			[IN_WIZCONTINUE]
'<WIZELSE'				NOT_ALPHA			WIZELSE_ON				[IN_DEFAULT]
'</WIZELSE'				NOT_ALPHA			WIZELSE_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZELSE_OFF				[IN_WIZELSE]
'<WIZELSEIF'			NOT_ALPHA			WIZELSEIF_ON			[IN_DEFAULT]
'</WIZELSEIF'			NOT_ALPHA			WIZELSEIF_ON			[IN_DEFAULT]
'>'						DONT_CARE			WIZELSEIF_OFF			[IN_WIZELSEIF]
'<WIZIF'				NOT_ALPHA			WIZIF_ON				[IN_DEFAULT]
'</WIZIF'				NOT_ALPHA			WIZIF_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZIF_OFF				[IN_WIZIF]
'<WIZINCLUDE'			NOT_ALPHA			WIZINCLUDE_ON			[IN_DEFAULT]
'</WIZINCLUDE'			NOT_ALPHA			WIZINCLUDE_ON			[IN_DEFAULT]
'>'						DONT_CARE			WIZINCLUDE_OFF			[IN_WIZINCLUDE]
'<WIZLOOP'				NOT_ALPHA			WIZLOOP_ON				[IN_DEFAULT]
'</WIZLOOP'				NOT_ALPHA			WIZLOOP_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZLOOP_OFF				[IN_WIZLOOP]
'<WIZSET'				NOT_ALPHA			WIZSET_ON				[IN_DEFAULT]
'</WIZSET'				NOT_ALPHA			WIZSET_ON				[IN_DEFAULT]
'>'						DONT_CARE			WIZSET_OFF				[IN_WIZSET]
'<VALUEMAP'				NOT_ALPHA			VALUEMAP_ON				[IN_DEFAULT]
'</VALUEMAP'			NOT_ALPHA			VALUEMAP_ON				[IN_DEFAULT]
'>'						DONT_CARE			VALUEMAP_OFF			[IN_VALUEMAP]
'<VALKEY'				NOT_ALPHA			VALKEY_ON				[IN_DEFAULT]
'</VALKEY'				NOT_ALPHA			VALKEY_ON				[IN_DEFAULT]
'>'						DONT_CARE			VALKEY_OFF				[IN_VALKEY]
'<VERSIONS'				NOT_ALPHA			VERSIONS_ON				[IN_DEFAULT]
'</VERSIONS'			NOT_ALPHA			VERSIONS_ON				[IN_DEFAULT]
'>'						DONT_CARE			VERSIONS_OFF			[IN_VERSIONS]
'<VERKEY'				NOT_ALPHA			VERKEY_ON				[IN_DEFAULT]
'</VERKEY'				NOT_ALPHA			VERKEY_ON				[IN_DEFAULT]
'>'						DONT_CARE			VERKEY_OFF				[IN_VERKEY]
'<VTINCLUDE'			NOT_ALPHA			VTINCLUDE_ON			[IN_DEFAULT]
'</VTINCLUDE'			NOT_ALPHA			VTINCLUDE_ON			[IN_DEFAULT]
'>'						DONT_CARE			VTINCLUDE_OFF			[IN_VTINCLUDE]
'<OUTLINEPROFILE'		NOT_ALPHA			OUTLINEPROFILE_ON		[IN_DEFAULT]
'</OUTLINEPROFILE'		NOT_ALPHA			OUTLINEPROFILE_ON		[IN_DEFAULT]
'>'						DONT_CARE			OUTLINEPROFILE_OFF		[IN_OUTLINEPROFILE]
'<RECOGNIZEDTAGS'		NOT_ALPHA			RECOGNIZEDTAGS_ON		[IN_DEFAULT]
'</RECOGNIZEDTAGS'		NOT_ALPHA			RECOGNIZEDTAGS_ON		[IN_DEFAULT]
'>'						DONT_CARE			RECOGNIZEDTAGS_OFF		[IN_RECOGNIZEDTAGS]
'<RECOGNIZEDTAG'		NOT_ALPHA			RECOGNIZEDTAG_ON		[IN_DEFAULT]
'</RECOGNIZEDTAG'		NOT_ALPHA			RECOGNIZEDTAG_ON		[IN_DEFAULT]
'>'						DONT_CARE			RECOGNIZEDTAG_OFF		[IN_RECOGNIZEDTAG]
'<TFS'					NOT_ALPHA			TFS_ON					[IN_DEFAULT]
'</TFS'					NOT_ALPHA			TFS_ON					[IN_DEFAULT]
'>'						DONT_CARE			TFS_OFF					[IN_TFS]
'<GENERALSETTINGS'		NOT_ALPHA			GENERALSETTINGS_ON		[IN_DEFAULT]
'</GENERALSETTINGS'		NOT_ALPHA			GENERALSETTINGS_ON		[IN_DEFAULT]
'>'						DONT_CARE			GENERALSETTINGS_OFF		[IN_GENERALSETTINGS]
'<DEFAULT_TFS'			NOT_ALPHA			DEFAULT_TFS_ON			[IN_DEFAULT]
'</DEFAULT_TFS'			NOT_ALPHA			DEFAULT_TFS_ON			[IN_DEFAULT]
'>'						DONT_CARE			DEFAULT_TFS_OFF			[IN_DEFAULT_TFS]
'<AUTOFORMATTER'		NOT_ALPHA			AUTOFORMATTER_ON		[IN_DEFAULT]
'</AUTOFORMATTER'		NOT_ALPHA			AUTOFORMATTER_ON		[IN_DEFAULT]
'>'						DONT_CARE			AUTOFORMATTER_OFF		[IN_AUTOFORMATTER]
'<TAGFORMATSETTINGS'	NOT_ALPHA			TAGFORMATSETTINGS_ON	[IN_DEFAULT]
'</TAGFORMATSETTINGS'	NOT_ALPHA			TAGFORMATSETTINGS_ON	[IN_DEFAULT]
'>'						DONT_CARE			TAGFORMATSETTINGS_OFF	[IN_TAGFORMATSETTINGS]
'<FSETTING'				NOT_ALPHA			FSETTING_ON				[IN_DEFAULT]
'</FSETTING'			NOT_ALPHA			FSETTING_ON				[IN_DEFAULT]
'>'						DONT_CARE			FSETTING_OFF			[IN_FSETTING]
'<'						'[A-Za-z0-9]'		GENERIC_ON				[IN_DEFAULT]
'</'					'[A-Za-z0-9]'		GENERIC_ON				[IN_DEFAULT]
'>'						DONT_CARE			GENERIC_OFF				[IN_GENERIC]
// Comments
'<!--'					DONT_CARE			COMMENT_ON				[IN_DEFAULT]
'-->'					DONT_CARE			COMMENT_OFF				[IN_COMMENT]
// Attributes
'0'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'1'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'2'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'3'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'4'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'5'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'6'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'7'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'8'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'9'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'-'						'[0-9 %>]'			ATTRIB_NUM_ON			[ATTRIB_STATES]
'"'						DONT_CARE			ATTRIB_QUOTED_ON		[ATTRIB_STATES]
'"'						DONT_CARE			ATTRIB_QUOTED_OFF		[IN_ATTRIB_QUOTED IN_ATTRIB_DQ_HTML_TAG]
'\''					DONT_CARE			ATTRIB_SQUOTED_ON		[ATTRIB_STATES]
'\''					DONT_CARE			ATTRIB_SQUOTED_OFF		[IN_ATTRIB_SQUOTED IN_ATTRIB_HTML_TAG]
'=a'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=b'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=c'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=d'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=e'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=f'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=g'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=h'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=i'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=j'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=k'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=l'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=m'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=n'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=o'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=p'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=q'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=r'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=s'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=t'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=u'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=v'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=w'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=x'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=y'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
'=z'					'[A-Za-z0-9 ]'		ATTRIB_NONQUOTED_ON		[ATTRIB_STATES]
// Attribute HTML
'&'						'[A-Za-z0-9#]'		ATTRIB_HTML_SPECIAL		[IN_ATTRIB_QUOTED IN_ATTRIB_SQUOTED]
'<'						'[A-Za-z0-9]'		ATTRIB_HTML_TAG_ON		[IN_ATTRIB_SQUOTED]
'</'					'[A-Za-z0-9]'		ATTRIB_HTML_TAG_ON		[IN_ATTRIB_SQUOTED]
'<'						'[A-Za-z0-9]'		ATTRIB_DQ_HTML_TAG_ON	[IN_ATTRIB_QUOTED]
'</'					'[A-Za-z0-9]'		ATTRIB_DQ_HTML_TAG_ON	[IN_ATTRIB_QUOTED]

%%handlers
ATTRIB_HTML_SPECIAL		'[A-Za-z0-9#]'?		';'						_use_
ATTRIB_HTML_TAG_ON		'[A-Za-z0-9 =\"/]'?	'>'						_use_
ATTRIB_DQ_HTML_TAG_ON	'[A-Za-z0-9 =\'/]'?	'>'						_use_

%%handlers
ATTRIB_NUM_ON			'[0-9]'?			'[^0-9]'				_discard_
ATTRIB_NONQUOTED_ON		'[A-Za-z0-9]'?		'[^A-Za-z0-9]'			_discard_

%%tokens
InState IN_ATTRIB (
	ATTRIB				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ATTRIBCATEGORIES (
	ATTRIBCATEGORIES	DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ATTRIBGROUP (
	ATTRIBGROUP			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ATTRIBOPTION (
	ATTRIBOPTION		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ATTRIBUTES (
	ATTRIBUTES			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_CAT (
	CAT					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_CONTAINER (
	CONTAINER			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_CONTROL (
	CONTROL				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_E (
	E					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_EDITORLAYOUT (
	EDITORLAYOUT		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_EVENT (
	EVENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_INPUT (
	INPUT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ITEM (
	ITEM				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_NEXTPAGE (
	NEXTPAGE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_PAGE (
	PAGE				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_PAGELAYOUT (
	PAGELAYOUT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_PARAM (
	PARAM				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TAG (
	TAG					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TAGDESCRIPTION (
	TAGDESCRIPTION		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TAGLAYOUT (
	TAGLAYOUT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TEMPLATE (
	TEMPLATE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZARD (
	WIZARD				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZBREAK (
	WIZBREAK			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZCONTINUE (
	WIZCONTINUE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZELSE (
	WIZELSE				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZELSEIF (
	WIZELSEIF			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZIF (
	WIZIF				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZINCLUDE (
	WIZINCLUDE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZLOOP (
	WIZLOOP				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_WIZSET (
	WIZSET				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VALUEMAP (
	VALUEMAP			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VALKEY (
	VALKEY				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VERSIONS (
	VERSIONS				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VERKEY (
	VERKEY				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_VTINCLUDE (
	VTINCLUDE		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_GENERIC (
	GENERIC				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_AUTOFORMATTER (
	AUTOFORMATTER		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_DEFAULT_TFS (
	DEFAULT_TFS			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TAGFORMATSETTINGS (
	TAGFORMATSETTINGS	DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_TFS (
	TFS					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_GENERALSETTINGS (
	GENERALSETTINGS		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_OUTLINEPROFILE (
	OUTLINEPROFILE		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_RECOGNIZEDTAGS (
	RECOGNIZEDTAGS		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_RECOGNIZEDTAG (
	RECOGNIZEDTAG		DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_FSETTING (
	FSETTING			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

// Comments
InState IN_COMMENT (
	COMMENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ATTRIB_QUOTED (
	ATTRIB_QUOTED		'[^"\\]'			DONT_CARE?			DONT_CARE			_discard_
	ATTRIB_QUOTED		'\\'				DONT_CARE			DONT_CARE			_discard_
)

InState IN_ATTRIB_SQUOTED (
	ATTRIB_SQUOTED		'[^\'\\]'			DONT_CARE?			DONT_CARE			_discard_
	ATTRIB_SQUOTED		'\\'				DONT_CARE			DONT_CARE			_discard_
)

%%states
ATTRIB_ON				(-[IN_DEFAULT]						+[IN_ATTRIB])
ATTRIB_OFF				(-[IN_ATTRIB]						+[IN_DEFAULT])

ATTRIBCATEGORIES_ON		(-[IN_DEFAULT]						+[IN_ATTRIBCATEGORIES])
ATTRIBCATEGORIES_OFF	(-[IN_ATTRIBCATEGORIES]				+[IN_DEFAULT])

ATTRIBGROUP_ON			(-[IN_DEFAULT]						+[IN_ATTRIBGROUP])
ATTRIBGROUP_OFF			(-[IN_ATTRIBGROUP]					+[IN_DEFAULT])

ATTRIBOPTION_ON			(-[IN_DEFAULT]						+[IN_ATTRIBOPTION])
ATTRIBOPTION_OFF		(-[IN_ATTRIBOPTION]					+[IN_DEFAULT])

ATTRIBUTES_ON			(-[IN_DEFAULT]						+[IN_ATTRIBUTES])
ATTRIBUTES_OFF			(-[IN_ATTRIBUTES]					+[IN_DEFAULT])

CAT_ON					(-[IN_DEFAULT]						+[IN_CAT])
CAT_OFF					(-[IN_CAT]							+[IN_DEFAULT])

CONTAINER_ON			(-[IN_DEFAULT]						+[IN_CONTAINER])
CONTAINER_OFF			(-[IN_CONTAINER]					+[IN_DEFAULT])

CONTROL_ON				(-[IN_DEFAULT]						+[IN_CONTROL])
CONTROL_OFF				(-[IN_CONTROL]						+[IN_DEFAULT])

E_ON					(-[IN_DEFAULT]						+[IN_E])
E_OFF					(-[IN_E]							+[IN_DEFAULT])

EDITORLAYOUT_ON			(-[IN_DEFAULT]						+[IN_EDITORLAYOUT])
EDITORLAYOUT_OFF		(-[IN_EDITORLAYOUT]					+[IN_DEFAULT])

EVENT_ON				(-[IN_DEFAULT]						+[IN_EVENT])
EVENT_OFF				(-[IN_EVENT]						+[IN_DEFAULT])

INPUT_ON				(-[IN_DEFAULT]						+[IN_INPUT])
INPUT_OFF				(-[IN_INPUT]						+[IN_DEFAULT])

ITEM_ON					(-[IN_DEFAULT]						+[IN_ITEM])
ITEM_OFF				(-[IN_ITEM]							+[IN_DEFAULT])

NEXTPAGE_ON				(-[IN_DEFAULT]						+[IN_NEXTPAGE])
NEXTPAGE_OFF			(-[IN_NEXTPAGE]						+[IN_DEFAULT])

PAGE_ON					(-[IN_DEFAULT]						+[IN_PAGE])
PAGE_OFF				(-[IN_PAGE]							+[IN_DEFAULT])

PAGELAYOUT_ON			(-[IN_DEFAULT]						+[IN_PAGELAYOUT])
PAGELAYOUT_OFF			(-[IN_PAGELAYOUT]					+[IN_DEFAULT])

PARAM_ON				(-[IN_DEFAULT]						+[IN_PARAM])
PARAM_OFF				(-[IN_PARAM]						+[IN_DEFAULT])

TAG_ON					(-[IN_DEFAULT]						+[IN_TAG])
TAG_OFF					(-[IN_TAG]							+[IN_DEFAULT])

TAGDESCRIPTION_ON		(-[IN_DEFAULT]						+[IN_TAGDESCRIPTION])
TAGDESCRIPTION_OFF		(-[IN_TAGDESCRIPTION]				+[IN_DEFAULT])

TAGLAYOUT_ON			(-[IN_DEFAULT]						+[IN_TAGLAYOUT])
TAGLAYOUT_OFF			(-[IN_TAGLAYOUT]					+[IN_DEFAULT])

TEMPLATE_ON				(-[IN_DEFAULT]						+[IN_TEMPLATE])
TEMPLATE_OFF			(-[IN_TEMPLATE]						+[IN_DEFAULT])

WIZARD_ON				(-[IN_DEFAULT]						+[IN_WIZARD])
WIZARD_OFF				(-[IN_WIZARD]						+[IN_DEFAULT])

WIZBREAK_ON				(-[IN_DEFAULT]						+[IN_WIZBREAK])
WIZBREAK_OFF			(-[IN_WIZBREAK]						+[IN_DEFAULT])

WIZCONTINUE_ON			(-[IN_DEFAULT]						+[IN_WIZCONTINUE])
WIZCONTINUE_OFF			(-[IN_WIZCONTINUE]					+[IN_DEFAULT])

WIZELSE_ON				(-[IN_DEFAULT]						+[IN_WIZELSE])
WIZELSE_OFF				(-[IN_WIZELSE]						+[IN_DEFAULT])

WIZELSEIF_ON			(-[IN_DEFAULT]						+[IN_WIZELSEIF])
WIZELSEIF_OFF			(-[IN_WIZELSEIF]					+[IN_DEFAULT])

WIZIF_ON				(-[IN_DEFAULT]						+[IN_WIZIF])
WIZIF_OFF				(-[IN_WIZIF]						+[IN_DEFAULT])

WIZINCLUDE_ON			(-[IN_DEFAULT]						+[IN_WIZINCLUDE])
WIZINCLUDE_OFF			(-[IN_WIZINCLUDE]					+[IN_DEFAULT])

WIZLOOP_ON				(-[IN_DEFAULT]						+[IN_WIZLOOP])
WIZLOOP_OFF				(-[IN_WIZLOOP]						+[IN_DEFAULT])

WIZSET_ON				(-[IN_DEFAULT]						+[IN_WIZSET])
WIZSET_OFF				(-[IN_WIZSET]						+[IN_DEFAULT])

VALUEMAP_ON				(-[IN_DEFAULT]						+[IN_VALUEMAP])
VALUEMAP_OFF			(-[IN_VALUEMAP]						+[IN_DEFAULT])

VALKEY_ON				(-[IN_DEFAULT]						+[IN_VALKEY])
VALKEY_OFF				(-[IN_VALKEY]						+[IN_DEFAULT])

VERSIONS_ON				(-[IN_DEFAULT]						+[IN_VERSIONS])
VERSIONS_OFF			(-[IN_VERSIONS]						+[IN_DEFAULT])

VERKEY_ON				(-[IN_DEFAULT]						+[IN_VERKEY])
VERKEY_OFF				(-[IN_VERKEY]						+[IN_DEFAULT])

VTINCLUDE_ON				(-[IN_DEFAULT]						+[IN_VTINCLUDE])
VTINCLUDE_OFF				(-[IN_VTINCLUDE]						+[IN_DEFAULT])

GENERIC_ON				(-[IN_DEFAULT]						+[IN_GENERIC])
GENERIC_OFF				(-[IN_GENERIC]						+[IN_DEFAULT])

AUTOFORMATTER_ON		(-[IN_DEFAULT]						+[IN_AUTOFORMATTER])
AUTOFORMATTER_OFF		(-[IN_AUTOFORMATTER]				+[IN_DEFAULT])

DEFAULT_TFS_ON			(-[IN_DEFAULT]						+[IN_DEFAULT_TFS])
DEFAULT_TFS_OFF			(-[IN_DEFAULT_TFS]					+[IN_DEFAULT])

TAGFORMATSETTINGS_ON	(-[IN_DEFAULT]						+[IN_TAGFORMATSETTINGS])
TAGFORMATSETTINGS_OFF	(-[IN_TAGFORMATSETTINGS]			+[IN_DEFAULT])

GENERALSETTINGS_ON		(-[IN_DEFAULT]						+[IN_GENERALSETTINGS])
GENERALSETTINGS_OFF		(-[IN_GENERALSETTINGS]				+[IN_DEFAULT])

TFS_ON					(-[IN_DEFAULT]						+[IN_TFS])
TFS_OFF					(-[IN_TFS]							+[IN_DEFAULT])

OUTLINEPROFILE_ON		(-[IN_DEFAULT]						+[IN_OUTLINEPROFILE])
OUTLINEPROFILE_OFF		(-[IN_OUTLINEPROFILE]				+[IN_DEFAULT])

RECOGNIZEDTAGS_ON		(-[IN_DEFAULT]						+[IN_RECOGNIZEDTAGS])
RECOGNIZEDTAGS_OFF		(-[IN_RECOGNIZEDTAGS]				+[IN_DEFAULT])

RECOGNIZEDTAG_ON		(-[IN_DEFAULT]						+[IN_RECOGNIZEDTAG])
RECOGNIZEDTAG_OFF		(-[IN_RECOGNIZEDTAG]				+[IN_DEFAULT])

FSETTING_ON				(-[IN_DEFAULT]						+[IN_FSETTING])
FSETTING_OFF			(-[IN_FSETTING]						+[IN_DEFAULT])

// Comments
COMMENT_ON				(-[IN_DEFAULT]						+[IN_COMMENT])
COMMENT_OFF				(-[IN_COMMENT]						+[IN_DEFAULT])

ATTRIB_QUOTED_ON		push	(-ALL_STATES				+[IN_ATTRIB_QUOTED])
ATTRIB_QUOTED_OFF		pop		()

ATTRIB_SQUOTED_ON		push	(-ALL_STATES				+[IN_ATTRIB_SQUOTED])
ATTRIB_SQUOTED_OFF		pop		()

%%effects
DEFAULT					[]					DEFAULT_FOREGROUND		DEFAULT_BACKGROUND
ATTRIB					[]					clBlue					DEFAULT_BACKGROUND*
ATTRIBCATEGORIES		[]					clBlue					DEFAULT_BACKGROUND*
ATTRIBGROUP				[]					clBlue					DEFAULT_BACKGROUND*
ATTRIBOPTION			[]					clBlue					DEFAULT_BACKGROUND*
ATTRIBUTES				[]					clBlue					DEFAULT_BACKGROUND*
CAT						[]					clBlue					DEFAULT_BACKGROUND*
CONTAINER				[]					clBlue					DEFAULT_BACKGROUND*
CONTROL					[]					clBlue					DEFAULT_BACKGROUND*
E						[]					clBlue					DEFAULT_BACKGROUND*
EDITORLAYOUT			[]					clBlue					DEFAULT_BACKGROUND*
EVENT					[]					clBlue					DEFAULT_BACKGROUND*
INPUT					[]					clBlue					DEFAULT_BACKGROUND*
ITEM					[]					clBlue					DEFAULT_BACKGROUND*
NEXTPAGE				[]					clBlue					DEFAULT_BACKGROUND*
PAGE					[]					clBlue					DEFAULT_BACKGROUND*
PAGELAYOUT				[]					clBlue					DEFAULT_BACKGROUND*
PARAM					[]					clBlue					DEFAULT_BACKGROUND*
TAG						[]					clBlue					DEFAULT_BACKGROUND*
TAGDESCRIPTION			[]					clBlue					DEFAULT_BACKGROUND*
TAGLAYOUT				[]					clBlue					DEFAULT_BACKGROUND*
TEMPLATE				[]					clBlue					DEFAULT_BACKGROUND*
WIZARD					[]					clBlue					DEFAULT_BACKGROUND*
WIZBREAK				[]					clBlue					DEFAULT_BACKGROUND*
WIZCONTINUE				[]					clBlue					DEFAULT_BACKGROUND*
WIZELSE					[]					clBlue					DEFAULT_BACKGROUND*
WIZELSEIF				[]					clBlue					DEFAULT_BACKGROUND*
WIZIF					[]					clBlue					DEFAULT_BACKGROUND*
WIZINCLUDE				[]					clBlue					DEFAULT_BACKGROUND*
WIZLOOP					[]					clBlue					DEFAULT_BACKGROUND*
WIZSET					[]					clBlue					DEFAULT_BACKGROUND*
VALUEMAP				[]					clBlue					DEFAULT_BACKGROUND*
VALKEY					[]					clBlue					DEFAULT_BACKGROUND*
VERSIONS				[]					clBlue					DEFAULT_BACKGROUND*
VERKEY					[]					clBlue					DEFAULT_BACKGROUND*
VTINCLUDE				[]					clBlue					DEFAULT_BACKGROUND*
GENERIC					[]					clRed					DEFAULT_BACKGROUND*
AUTOFORMATTER			[]					clBlue					DEFAULT_BACKGROUND*
DEFAULT_TFS				[]					clBlue					DEFAULT_BACKGROUND*
TAGFORMATSETTINGS		[]					clBlue					DEFAULT_BACKGROUND*
TFS						[]					clBlue					DEFAULT_BACKGROUND*
GENERALSETTINGS			[]					clBlue					DEFAULT_BACKGROUND*
OUTLINEPROFILE			[]					clBlue					DEFAULT_BACKGROUND*
RECOGNIZEDTAGS			[]					clBlue					DEFAULT_BACKGROUND*
RECOGNIZEDTAG			[]					clBlue					DEFAULT_BACKGROUND*
FSETTING				[]					clBlue					DEFAULT_BACKGROUND*
// Comments
COMMENT					[fsItalic]			clGray					DEFAULT_BACKGROUND*
ATTRIB_NUM				[]					clMaroon				DEFAULT_BACKGROUND*
ATTRIB_QUOTED			[]					clBlack					DEFAULT_BACKGROUND*
ATTRIB_SQUOTED			[]					clBlack					DEFAULT_BACKGROUND*
ATTRIB_NONQUOTED		[]					clOlive					DEFAULT_BACKGROUND*
ATTRIB_HTML_SPECIAL		[fsBold]			clBlack					DEFAULT_BACKGROUND*
ATTRIB_HTML_TAG			[]					clSoftBlue				DEFAULT_BACKGROUND*

%%map
DEFAULT					DEFAULT
ATTRIB					ATTRIB
ATTRIB_ON				ATTRIB
ATTRIB_OFF				ATTRIB
ATTRIBCATEGORIES		ATTRIBCATEGORIES
ATTRIBCATEGORIES_ON		ATTRIBCATEGORIES
ATTRIBCATEGORIES_OFF	ATTRIBCATEGORIES
ATTRIBGROUP				ATTRIBGROUP
ATTRIBGROUP_ON			ATTRIBGROUP
ATTRIBGROUP_OFF			ATTRIBGROUP
ATTRIBOPTION			ATTRIBOPTION
ATTRIBOPTION_ON			ATTRIBOPTION
ATTRIBOPTION_OFF		ATTRIBOPTION
ATTRIBUTES				ATTRIBUTES
ATTRIBUTES_ON			ATTRIBUTES
ATTRIBUTES_OFF			ATTRIBUTES
CAT						CAT
CAT_ON					CAT
CAT_OFF					CAT
CONTAINER				CONTAINER
CONTAINER_ON			CONTAINER
CONTAINER_OFF			CONTAINER
CONTROL					CONTROL
CONTROL_ON				CONTROL
CONTROL_OFF				CONTROL
E						E
E_ON					E
E_OFF					E
EDITORLAYOUT			EDITORLAYOUT
EDITORLAYOUT_ON			EDITORLAYOUT
EDITORLAYOUT_OFF		EDITORLAYOUT
EVENT					EVENT
EVENT_ON				EVENT
EVENT_OFF				EVENT
INPUT					INPUT
INPUT_ON				INPUT
INPUT_OFF				INPUT
ITEM					ITEM
ITEM_ON					ITEM
ITEM_OFF				ITEM
NEXTPAGE				NEXTPAGE
NEXTPAGE_ON				NEXTPAGE
NEXTPAGE_OFF			NEXTPAGE
PAGE					PAGE
PAGE_ON					PAGE
PAGE_OFF				PAGE
PAGELAYOUT				PAGELAYOUT
PAGELAYOUT_ON			PAGELAYOUT
PAGELAYOUT_OFF			PAGELAYOUT
PARAM					PARAM
PARAM_ON				PARAM
PARAM_OFF				PARAM
TAG						TAG
TAG_ON					TAG
TAG_OFF					TAG
TAGDESCRIPTION			TAGDESCRIPTION
TAGDESCRIPTION_ON		TAGDESCRIPTION
TAGDESCRIPTION_OFF		TAGDESCRIPTION
TAGLAYOUT				TAGLAYOUT
TAGLAYOUT_ON			TAGLAYOUT
TAGLAYOUT_OFF			TAGLAYOUT
INPUT					INPUT
INPUT_ON				INPUT
INPUT_OFF				INPUT
ITEM					ITEM
ITEM_ON					ITEM
ITEM_OFF				ITEM
NEXTPAGE				NEXTPAGE
NEXTPAGE_ON				NEXTPAGE
NEXTPAGE_OFF			NEXTPAGE
PAGE					PAGE
PAGE_ON					PAGE
PAGE_OFF				PAGE
PAGELAYOUT				PAGELAYOUT
PAGELAYOUT_ON			PAGELAYOUT
PAGELAYOUT_OFF			PAGELAYOUT
PARAM					PARAM
PARAM_ON				PARAM
PARAM_OFF				PARAM
TAG						TAG
TAG_ON					TAG
TAG_OFF					TAG
TAGDESCRIPTION			TAGDESCRIPTION
TAGDESCRIPTION_ON		TAGDESCRIPTION
TAGDESCRIPTION_OFF		TAGDESCRIPTION
TAGLAYOUT				TAGLAYOUT
TAGLAYOUT_ON			TAGLAYOUT
TAGLAYOUT_OFF			TAGLAYOUT
TEMPLATE				TEMPLATE
TEMPLATE_ON				TEMPLATE
TEMPLATE_OFF			TEMPLATE
WIZARD					WIZARD
WIZARD_ON				WIZARD
WIZARD_OFF				WIZARD
WIZBREAK				WIZBREAK
WIZBREAK_ON				WIZBREAK
WIZBREAK_OFF			WIZBREAK
WIZCONTINUE				WIZCONTINUE
WIZCONTINUE_ON			WIZCONTINUE
WIZCONTINUE_OFF			WIZCONTINUE
WIZELSE					WIZELSE
WIZELSE_ON				WIZELSE
WIZELSE_OFF				WIZELSE
WIZELSEIF				WIZELSEIF
WIZELSEIF_ON			WIZELSEIF
WIZELSEIF_OFF			WIZELSEIF
WIZIF					WIZIF
WIZIF_ON				WIZIF
WIZIF_OFF				WIZIF
WIZINCLUDE				WIZINCLUDE
WIZINCLUDE_ON			WIZINCLUDE
WIZINCLUDE_OFF			WIZINCLUDE
WIZLOOP					WIZLOOP
WIZLOOP_ON				WIZLOOP
WIZLOOP_OFF				WIZLOOP
WIZSET					WIZSET
WIZSET_ON				WIZSET
WIZSET_OFF				WIZSET
VALUEMAP				VALUEMAP
VALUEMAP_ON				VALUEMAP
VALUEMAP_OFF			VALUEMAP
VALKEY					VALKEY
VALKEY_ON				VALKEY
VALKEY_OFF				VALKEY
VERSIONS				VERSIONS
VERSIONS_ON				VERSIONS
VERSIONS_OFF			VERSIONS
VERKEY					VERKEY
VERKEY_ON				VERKEY
VERKEY_OFF				VERKEY
GENERIC					GENERIC
GENERIC_ON				GENERIC
GENERIC_OFF				GENERIC
AUTOFORMATTER			AUTOFORMATTER
AUTOFORMATTER_ON		AUTOFORMATTER
AUTOFORMATTER_OFF		AUTOFORMATTER
DEFAULT_TFS				DEFAULT_TFS
DEFAULT_TFS_ON			DEFAULT_TFS
DEFAULT_TFS_OFF			DEFAULT_TFS
TAGFORMATSETTINGS		TAGFORMATSETTINGS
TAGFORMATSETTINGS_ON	TAGFORMATSETTINGS
TAGFORMATSETTINGS_OFF	TAGFORMATSETTINGS
TFS						TFS
TFS_ON					TFS
TFS_OFF					TFS
GENERALSETTINGS			GENERALSETTINGS
GENERALSETTINGS_ON		GENERALSETTINGS
GENERALSETTINGS_OFF		GENERALSETTINGS
OUTLINEPROFILE			OUTLINEPROFILE
OUTLINEPROFILE_ON		OUTLINEPROFILE
OUTLINEPROFILE_OFF		OUTLINEPROFILE
RECOGNIZEDTAGS			RECOGNIZEDTAGS
RECOGNIZEDTAGS_ON		RECOGNIZEDTAGS
RECOGNIZEDTAGS_OFF		RECOGNIZEDTAGS
RECOGNIZEDTAG			RECOGNIZEDTAG
RECOGNIZEDTAG_ON		RECOGNIZEDTAG
RECOGNIZEDTAG_OFF		RECOGNIZEDTAG
FSETTING				FSETTING
FSETTING_ON				FSETTING
FSETTING_OFF			FSETTING
// Comments
COMMENT					COMMENT
COMMENT_ON				COMMENT
COMMENT_OFF				COMMENT
ATTRIB_NUM				ATTRIB_NUM
ATTRIB_NUM_ON			ATTRIB_NUM
ATTRIB_NUM_OFF			ATTRIB_NUM
ATTRIB_QUOTED			ATTRIB_QUOTED
ATTRIB_QUOTED_ON		ATTRIB_QUOTED
ATTRIB_QUOTED_OFF		ATTRIB_QUOTED
ATTRIB_SQUOTED			ATTRIB_QUOTED
ATTRIB_SQUOTED_ON		ATTRIB_QUOTED
ATTRIB_SQUOTED_OFF		ATTRIB_QUOTED
ATTRIB_NONQUOTED		ATTRIB_NONQUOTED
ATTRIB_NONQUOTED_ON		ATTRIB_NONQUOTED
ATTRIB_NONQUOTED_ON		ATTRIB_NONQUOTED
ATTRIB_HTML_SPECIAL		ATTRIB_HTML_SPECIAL
ATTRIB_HTML_TAG			ATTRIB_HTML_TAG
ATTRIB_HTML_TAG_ON		ATTRIB_HTML_TAG
ATTRIB_HTML_TAG_OFF		ATTRIB_HTML_TAG
ATTRIB_DQ_HTML_TAG_ON	ATTRIB_HTML_TAG
ATTRIB_DQ_HTML_TAG_OFF	ATTRIB_HTML_TAG
VTINCLUDE				VTINCLUDE
VTINCLUDE_ON			VTINCLUDE
VTINCLUDE_OFF			VTINCLUDE

