/*******************************************************************************
	Generic Script
	- Use this script as a basis for all other client-side scripting languages
*******************************************************************************/
// Elements
#define GS_BASE						CLIENT_SIDE_SCRIPT_BASE
// Begin Virtual Elements - These must be defined by every script parser
// so that the attributes can be colored properly
#define HTML_SCRIPT					GS_BASE + 0
#define HTML_SCRIPT_START_START		GS_BASE + 1
#define HTML_SCRIPT_START_STOP		GS_BASE + 2
#define HTML_SCRIPT_STOP_START		GS_BASE + 3
#define HTML_SCRIPT_STOP_STOP		GS_BASE + 4
// End Virtual Elements
#define GS_DEFAULT					GS_BASE + 5

// States
#define IN_HTML_SCRIPT_START		GS_BASE + 0
#define IN_HTML_SCRIPT_STOP			GS_BASE + 1
#define IN_GS_DEFAULT				GS_BASE + 2

%%language
Anchor							+=	[HTML_SCRIPT_START_START HTML_SCRIPT_STOP_START]
BoundStates						+=	[IN_HTML_SCRIPT_START IN_HTML_SCRIPT_STOP IN_GS_DEFAULT]
ContextStates					=	(HTML_SCRIPT_START_START [IN_HTML_SCRIPT_START]),
									(HTML_SCRIPT_STOP_START [IN_HTML_SCRIPT_STOP])
EditableStyles						('HTML Script'					, HTML_SCRIPT),
									('GenericScript Default'		, GS_DEFAULT)
ExampleText						+=	'------- GenericScript -------\n\
									\<script language="Generic" type="text/generic">\n\
									\     function hello() {\n\
									\          print "hello";\n\
									\     }\n\
									\</script>\n'

%%words
'<script'				NOT_ALPHA			HTML_SCRIPT_START_START	[IN_DEFAULT]
'>'						DONT_CARE			HTML_SCRIPT_START_STOP	[IN_HTML_SCRIPT_START]
'</script'				NOT_ALPHA			HTML_SCRIPT_STOP_START	[IN_GS_DEFAULT]
'>'						DONT_CARE			HTML_SCRIPT_STOP_STOP	[IN_HTML_SCRIPT_STOP]

%%tokens
InState IN_GS_DEFAULT (
	GS_DEFAULT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_SCRIPT_START (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_SCRIPT_STOP (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
HTML_SCRIPT_START_START	(-[IN_DEFAULT]						+[IN_HTML_SCRIPT_START])
HTML_SCRIPT_START_STOP	(-[IN_HTML_SCRIPT_START]			+[IN_GS_DEFAULT])

HTML_SCRIPT_STOP_START	(-[IN_GS_DEFAULT]					+[IN_HTML_SCRIPT_STOP])
HTML_SCRIPT_STOP_STOP	(-[IN_HTML_SCRIPT_STOP]				+[IN_DEFAULT])

%%effects
GS_DEFAULT				[]					clMaroon				DEFAULT_BACKGROUND*
HTML_SCRIPT				[]					clMaroon				DEFAULT_BACKGROUND*

%%map
HTML_SCRIPT				HTML_SCRIPT
HTML_SCRIPT_START_START	HTML_SCRIPT
HTML_SCRIPT_START_STOP	HTML_SCRIPT
HTML_SCRIPT_STOP_START	HTML_SCRIPT
HTML_SCRIPT_STOP_STOP	HTML_SCRIPT
GS_DEFAULT				GS_DEFAULT
