/******************************************************************************
	JavaScript Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Current Version Revision History:
	01/19/2000 - Rewritten from HTML+ 4.0 Beta
			   - Isolated JS information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
			   - Added Style: 'JavaScript Separators'
	02/05/2000 - Added '[' and ']' as separators
******************************************************************************/
// Elements
#define JS_BASE						CLIENT_SIDE_SCRIPT_BASE
#define HTML_SCRIPT					JS_BASE + 0
#define HTML_SCRIPT_START_START		JS_BASE + 1
#define HTML_SCRIPT_START_STOP		JS_BASE + 2
#define HTML_SCRIPT_STOP_START		JS_BASE + 3
#define HTML_SCRIPT_STOP_STOP		JS_BASE + 4
#define JS_DEFAULT					JS_BASE + 5
#define JS_RESERVED					JS_BASE + 6
#define JS_OBJECT					JS_BASE + 7
#define JS_FUNCTION					JS_BASE + 8
#define JS_OPERATOR					JS_BASE + 9
#define JS_COMMENT					JS_BASE + 10
#define JS_COMMENT_LINE_START		JS_BASE + 11
#define JS_COMMENT_LINE_STOP		JS_BASE + 12
#define JS_COMMENT_STAR_START		JS_BASE + 13
#define JS_COMMENT_STAR_STOP		JS_BASE + 14
#define JS_SEPARATOR				JS_BASE + 15
#define JS_STRING					JS_BASE + 16
#define JS_STRING_START				JS_BASE + 17
#define JS_STRING_STOP				JS_BASE + 18
#define JS_STRING_SQ_START			JS_BASE + 19
#define JS_STRING_SQ_STOP			JS_BASE + 20
#define JS_IDENTIFIER				JS_BASE + 21
#define JS_NUMBER					JS_BASE + 22
#define JS_PROPERTY					JS_BASE + 23

// States
#define IN_HTML_SCRIPT_START		JS_BASE + 0
#define IN_HTML_SCRIPT_STOP			JS_BASE + 1
#define IN_JS_DEFAULT				JS_BASE + 2
#define IN_JS_COMMENT_LINE			JS_BASE + 3
#define IN_JS_COMMENT_STAR			JS_BASE + 4
#define IN_JS_STRING				JS_BASE + 5
#define IN_JS_STRING_SQ				JS_BASE + 6

%%language
Anchor							+=	[HTML_SCRIPT_START_START HTML_SCRIPT_STOP_START JS_DEFAULT JS_FUNCTION JS_IDENTIFIER JS_OBJECT JS_OPERATOR JS_NUMBER JS_RESERVED JS_SEPARATOR JS_PROPERTY]
BoundStates						+=	[IN_HTML_SCRIPT_START IN_HTML_SCRIPT_STOP IN_JS_DEFAULT IN_JS_COMMENT_LINE IN_JS_COMMENT_STAR]
ContextStates					=	(HTML_SCRIPT_START_START [IN_HTML_SCRIPT_START]),
									(HTML_SCRIPT_STOP_START [IN_HTML_SCRIPT_STOP]),
									(JS_DEFAULT JS_FUNCTION JS_IDENTIFIER JS_OBJECT JS_OPERATOR JS_NUMBER JS_RESERVED JS_SEPARATOR JS_PROPERTY [IN_JS_DEFAULT])
EditableStyles						('HTML Script'					, HTML_SCRIPT),
									('JavaScript Default'			, JS_DEFAULT),
									('JavaScript Comments'			, JS_COMMENT),
									('JavaScript Functions'			, JS_FUNCTION),
									('JavaScript Identifiers'		, JS_IDENTIFIER),
									('JavaScript Objects'			, JS_OBJECT),
									('JavaScript Operators'			, JS_OPERATOR),
									('JavaScript Numbers'			, JS_NUMBER),
									('JavaScript Reserved Words'	, JS_RESERVED),
									('JavaScript Separators'		, JS_SEPARATOR),
									('JavaScript Strings'			, JS_STRING),
									('JavaScript Properties'		, JS_PROPERTY)
ExampleText						+=	'------- JavaScript -------\n\
									\<script language="JavaScript" type="text/javascript">\n\
									\<!--\n\
									\     function testMe() {\n\
									\          var i = abs(-134) + "test";\n\
									\          // Open a new window\n\
									\          window.open("http://www.macromedia.com");\n\
									\     }\n\
									\\/\/ -->\n\
									\</script>\n'

%%words
// HTML Script
'<script'				NOT_ALPHA			HTML_SCRIPT_START_START	[IN_DEFAULT]
'>'						DONT_CARE			HTML_SCRIPT_START_STOP	[IN_HTML_SCRIPT_START]
'</script'				NOT_ALPHA			HTML_SCRIPT_STOP_START	[IN_JS_DEFAULT IN_JS_COMMENT_LINE]
'>'						DONT_CARE			HTML_SCRIPT_STOP_STOP	[IN_HTML_SCRIPT_STOP]
// JavaScript Comments
'<!--'					DONT_CARE			JS_COMMENT				[IN_JS_DEFAULT]
'\/\/'					DONT_CARE			JS_COMMENT_LINE_START	[IN_JS_DEFAULT]
'\n'					DONT_CARE			JS_COMMENT_LINE_STOP	[IN_JS_COMMENT_LINE]
'\/*'					DONT_CARE			JS_COMMENT_STAR_START	[IN_JS_DEFAULT]
'*\/'					DONT_CARE			JS_COMMENT_STAR_STOP	[IN_JS_COMMENT_STAR]
// JavaScript Operators
'-'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'+'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'*'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'/'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'%'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'!'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'<'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'>'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'='						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'&'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'|'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'?'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
':'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
','						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'^'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
'.'						DONT_CARE			JS_OPERATOR				[IN_JS_DEFAULT]
// JavaScript Separators
'('						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
')'						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
'{'						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
'}'						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
'['						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
']'						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
';'						DONT_CARE			JS_SEPARATOR			[IN_JS_DEFAULT]
// JavaScript Strings
'"'						DONT_CARE			JS_STRING_START			[IN_JS_DEFAULT]
'"'						DONT_CARE			JS_STRING_STOP			[IN_JS_STRING]
'\''					DONT_CARE			JS_STRING_SQ_START		[IN_JS_DEFAULT]
'\''					DONT_CARE			JS_STRING_SQ_STOP		[IN_JS_STRING_SQ]

%%kwtables
ForState [IN_JS_DEFAULT] endswith NOT_ALPHA (
	// JavaScript Reserved Words
	JS_RESERVED		is '@cc_on', '@if', 'break', 'case', 'catch', 'continue', 'delete', 'do', 'else', 'for', 'function', 'if', 'in', 'label', 'return', 'switch', 'this', 'throw', 'try', 'typeof', 'var', 'void', 'while', 'with'
	// JavaScript Functions
	JS_FUNCTION		is	'abs', 'acos', 'anchor', 'asin', 'atan', 'atan2', 'atEnd', 'big', 'blink', 'bold', 'ceil', 'charAt', 'charCodeAt', 'compile', 'concat', 'cos', 'dimensions', 'escape', 'eval', 'exec', 'exp', 'fixed', 'floor', 'fontcolor',  'fromCharCode', 'getDate', 'getDay', 'getFullYear', 'getHours', 'getItem', 'getMilliseconds', 'getMinutes', 'getMonth', 'GetObject', 'getSeconds', 'getTime', 'getTimezoneOffset', 'getUTCDate', 'getUTCFullYear', 'getUTCHours', 'getUTCMilliseconds', 'getUTCMinutes', 'getUTCMonth', 'getUTCSeconds', 'getYear', 'indexOf', 'isFinite', 'isNan', 'italics', 'join', 'lastIndexOf', 'lbound', 'link', 'log', 'match', 'max', 'min', 'moveFirst', 'moveNext', 'parse', 'parseFloat', 'parseInt', 'pop', 'pow', 'push', 'random', 'replace', 'reverse', 'round', 'ScriptEngine', 'ScriptEngineBuildVersion', 'ScriptEngineMajorVersion', 'ScriptEngineMinorVersion', 'search', 'setDate', 'setFullYear', 'setHours', 'setMilliseconds', 'setMinutes', 'setMonth', 'setSeconds', 'setTime', 'setUTCDate', 'setUTCFullYear', 'setUTCHours', 'setUTCMilliseconds', 'setUTCMinutes', 'setUTCMonth', 'setUTCSeconds', 'setYear', 'shift', 'sin', 'slice', 'small', 'sort', 'split', 'sqrt', 'strike', 'sub', 'substr', 'substring', 'sup', 'tan', 'test', 'toArray', 'toGMTString', 'toLocaleString', 'toLowerCase', 'toString', 'toUpperCase', 'toUTCString', 'ubound', 'unescape', 'unshift', 'unwatch', 'UTC', 'valueOf', 'watch', 'add', 'addImport', 'addReadRequest', 'addRule', 'alert', 'assign', 'back', 'blur', 'captureEvents', 'clear', 'clearInterval', 'clearRequest', 'clearTimeout', 'click', 'close', 'collapse', 'compareEndPoints', 'confirm', 'contains', 'createElement', 'createRange', 'createStyleSheet', 'createTextRange', 'disableExternalCapture', 'doReadRequest', 'duplicate', 'elementFromPoint', 'empty', 'enableExternalCapture', 'execCommand', 'execScript', 'expand', 'findText', 'find', 'focus', 'forward', 'getAttribute', 'getBookmark', 'getSelection', 'go', 'handleEvent', 'home', 'inRange', 'insertAdjacentHTML', 'insertAdjacentText', 'isEqual', 'item', 'javaEnabled', 'load', 'move', 'moveAbove', 'moveBelow', 'moveBy', 'moveEnd', 'moveStart', 'moveTo', 'moveToAbsolute', 'moveToBookmark', 'moveToElementText', 'moveToPoint', 'navigate', 'nextPage', 'open', 'pasteHTML', 'preference', 'previousPage', 'print', 'prompt', 'queryCommandIndeterm', 'queryCommandState', 'queryCommandEnabled', 'queryCommandSupported', 'queryCommandText', 'queryCommandValue', 'refresh', 'releaseEvents', 'reload', 'remove', 'removeAttribute', 'reset', 'resizeBy', 'resizeTo', 'routeEvent', 'scroll', 'scrollBy', 'scrollIntoView', 'scrollTo', 'select', 'setAttribute', 'setEndPoint', 'setInterval', 'setTimeout', 'showHelp', 'showModalDialog', 'start', 'stop', 'submit', 'tags', 'taintEnabled', 'write', 'writeln'
	// JavaScript Objects
	JS_OBJECT		is	'Array', 'Boolean', 'Date', 'Dictionary', 'Enumerator', 'Error', 'FileSystemObject', 'Math', 'Object', 'RegExp', 'String', 'VBArray', 'document', 'event', 'frame', 'history', 'layer', 'location', 'navigator', 'window'
	// JavaScript Properties
	JS_PROPERTY		is	'$1', '$2', '$3', '$4', '$5', '$6', '$7', '$8', '$9', 'arguments', 'arity', 'caller', 'description', 'E', 'global', 'ignoreCase', 'index', 'input', 'lastIndex', 'lastMatch', 'lastParen', 'leftContext', 'length', 'LN10', 'LN2', 'LOG10E', 'LOG2E', 'MAX_VALUE', 'MIN_VALUE', 'multiline', 'NaN', 'NEGATIVE_INFINITY', 'number', 'PI', 'POSITIVE_INFINITY', 'prototype', 'rightContext', 'source', 'SQRT1_2', 'ABORT', 'above', 'accessKey', 'action', 'activeElement', 'align', 'alink', 'alinkColor', 'alt', 'ALT_MASK', 'altHtml', 'altKey', 'appCodeName', 'appMinorVersion', 'appName', 'appVersion', 'availHeight', 'availLeft', 'availTop', 'availWidth', 'background', 'backgroundColor', 'backgroundImage', 'backgroundPosition', 'backgroundPositionX', 'backgroundPositionY', 'backgroundRepeat', 'balance', 'behavior', 'below', 'bgColor', 'bgProperties', 'body', 'border', 'borderBottom', 'borderBottomColor', 'borderBottomStyle', 'borderBottomWidth', 'borderColor', 'borderColorDark', 'borderColorLight', 'borderLeft', 'borderLeftColor', 'borderLeftStyle', 'borderLeftWidth', 'borderRight', 'borderRightColor', 'borderRightStyle', 'borderRightWidth', 'borderStyle', 'borderTop', 'borderTopColor', 'borderTopStyle', 'borderTopWidth', 'borderWidth', 'borderWidths', 'bottomMargin', 'boundingHeight', 'boundingLeft', 'boundingTop', 'boundingWidth', 'browserLanguage', 'bufferDepth', 'button', 'cancelBubble', 'caption', 'cellIndex', 'cellPadding', 'cellSpacing', 'CHANGE', 'charset', 'checked', 'cite', 'classid', 'className', 'clientHeight', 'clientInformation', 'clientLeft', 'clientTop', 'clientWidth', 'clientX', 'clientY', 'clip', 'closed', 'code', 'codeBase', 'codeType', 'color', 'colorDepth', 'cols', 'colSpan', 'compact', 'complete', 'content', 'CONTROL_MASK', 'cookie', 'cookieEnabled', 'coords', 'cpuClass', 'cssText', 'ctrlKey', 'current', 'cursor', 'data', 'dataFld', 'dataFormatAs', 'dataPageSize', 'dataSrc', 'dateTime', 'DBLCLICK', 'defaultCharset', 'defaultChecked', 'defaultSelected','defaultStatus', 'defaultValue', 'defer', 'dialogArguments', 'dialogHeight', 'dialogLeft', 'dialogTop', 'dialogWidth', 'dir', 'direction', 'disabled', 'display', 'domain', 'DRAGDROP', 'dynsrc', 'enabledPlugin', 'encoding', 'expando', 'face','fgColor', 'filename', 'filter', 'font', 'fontFamily', 'fontSize', 'fontStyle', 'fontVariant', 'fontWeight', 'form', 'frameBorder', 'frameSpacing', 'fromElement', 'gackgroundAttachment', 'hash', 'height', 'HELP', 'hidden', 'host', 'hostname', 'href','hspace', 'htmlFor', 'htmlText', 'httpEquiv', 'id', 'indeterminate', 'innerHeight', 'innerHTML', 'innerText', 'innerWidth', 'isMap', 'isTextEdit','keyCode', 'KEYDOWN', 'KEYPRESS', 'KEYUP', 'lang', 'language','lastModified', 'layerX', 'layerY', 'left', 'leftMargin', 'letterSpacing', 'lineHeight', 'linkColor', 'listStyle','listStyleImage', 'listStyleType', 'LOCATE', 'locationbar', 'loop', 'lowsrc', 'margin', 'marginBottom', 'marginHeight','marginLeft', 'marginRight', 'margins', 'marginTop', 'marginWidth','maxLength', 'media', 'menubar', 'META_MASK', 'method', 'Methods','mimeType', 'modifiers', 'MOUSEDOWN', 'MOUSEDRAG', 'MOUSEMOVE', 'MOUSEOUT','MOUSEUP', 'multiple', 'name', 'nameProp', 'next','noHref', 'noResize', 'noShade', 'noWrap', 'offscreenBuffering','offsetHeight', 'offsetLeft', 'offsetTop', 'offsetWidth', 'offsetX', 'offsetY', 'onLine', 'opener', 'outerHeight', 'outerHTML', 'outerText','outerWidth', 'overflow', 'owningElement', 'padding', 'paddingBottom','paddingLeft', 'paddingRight', 'paddings', 'paddingTop', 'pageBreakAfter', 'pageBreakBefore', 'pageX', 'pageXOffset', 'pageY', 'pageYOffset','palette', 'parent', 'parentElement', 'parentLayer', 'parentStyleSheet','parentTextEdit', 'parentWindow', 'pathname', 'personalbar','pixelDepth', 'pixelHeight', 'pixelLeft', 'pixelTop', 'pixelWidth','platform', 'pluginspage', 'port', 'posHeight', 'position', 'posLeft','posTop', 'posWidth', 'previous', 'protocol', 'protocolLong', 'readOnly', 'readyState', 'reason', 'recordNumber','referrer', 'rel', 'RESIZE', 'returnValue', 'rev', 'rightMargin', 'rowIndex', 'rows', 'rowSpan', 'rules', 'screen', 'screenX', 'screenY', 'scrollAmount', 'scrollbars', 'scrollDelay', 'scrollHeight', 'scrolling', 'scrollLeft', 'scrollTop', 'scrollWidth', 'sectionRowIndex', 'selected', 'selectedIndex', 'selection','selectorText', 'shape', 'SHIFT_MASK', 'shiftKey', 'siblingAbove','siblingBelow', 'size', 'sourceIndex', 'span', 'src', 'srcElement','srcFilter', 'status', 'statusbar', 'style', 'styleFloat', 'suffixes', 'systemLanguage', 'tabIndex', 'tagName', 'target', 'text','textAlign', 'textDecoration', 'textDecorationBlink', 'textDecorationLineThrough', 'textDecorationNone', 'textDecorationOverline','textDecorationUnderline', 'textIndent', 'textTransform','tFoot', 'tHead', 'title', 'toElement', 'toolbar', 'top', 'topMargin','trueSpeed', 'type', 'units', 'UNLOAD', 'updateInterval', 'url', 'urn', 'useMap', 'userAgent', 'userLanguage', 'userProfile', 'vAlign', 'value','verticalAlign', 'visibility', 'visible', 'vLink', 'vlinkColor', 'volume','vspace', 'which', 'whiteSpace', 'width', 'wrap', 'x', 'XFER_DONE', 'y','zIndex', 'all', 'anchors', 'applets', 'children', 'classes', 'embeds', 'filters', 'forms', 'frames', 'ids', 'images', 'links', 'plugins', 'scripts', 'styleSheets'
)

%%tokens
InState IN_HTML_SCRIPT_START (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_SCRIPT_STOP (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_JS_DEFAULT (
	JS_DEFAULT			'[^A-Za-z0-9_$]'	DONT_CARE?			DONT_CARE			_discard_
	JS_IDENTIFIER		'[A-Za-z_$]'		'[A-Za-z0-9_$]'?	'[^A-Za-z0-9_$]'	_discard_
	JS_NUMBER			NUM_START			NUM_CONTAINS?		NOT_NUM_CONTAINS	_discard_
)

InState IN_JS_COMMENT_LINE (
	JS_COMMENT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_JS_COMMENT_STAR (
	JS_COMMENT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_JS_STRING (
	JS_STRING			'[^"\\]'			DONT_CARE?			DONT_CARE			_discard_
	JS_STRING			'\\'				DONT_CARE			DONT_CARE			_discard_
)

InState IN_JS_STRING_SQ (
	JS_STRING			'[^\'\\]'			DONT_CARE?			DONT_CARE			_discard_
	JS_STRING			'\\'				DONT_CARE			DONT_CARE			_discard_
)


%%states
HTML_SCRIPT_START_START	(-[IN_DEFAULT]						+[IN_HTML_SCRIPT_START])
HTML_SCRIPT_START_STOP	(-[IN_HTML_SCRIPT_START]			+[IN_JS_DEFAULT])

HTML_SCRIPT_STOP_START	(-[IN_JS_DEFAULT IN_JS_COMMENT_LINE]	+[IN_HTML_SCRIPT_STOP])
HTML_SCRIPT_STOP_STOP	(-[IN_HTML_SCRIPT_STOP]				+[IN_DEFAULT])

JS_COMMENT_LINE_START	(-[IN_JS_DEFAULT]					+[IN_JS_COMMENT_LINE])
JS_COMMENT_LINE_STOP	(-[IN_JS_COMMENT_LINE]				+[IN_JS_DEFAULT])

JS_COMMENT_STAR_START	(-[IN_JS_DEFAULT]					+[IN_JS_COMMENT_STAR])
JS_COMMENT_STAR_STOP	(-[IN_JS_COMMENT_STAR]				+[IN_JS_DEFAULT])

JS_STRING_START			(-[IN_JS_DEFAULT]					+[IN_JS_STRING])
JS_STRING_STOP			(-[IN_JS_STRING]					+[IN_JS_DEFAULT])

JS_STRING_SQ_START		(-[IN_JS_DEFAULT]					+[IN_JS_STRING_SQ])
JS_STRING_SQ_STOP		(-[IN_JS_STRING_SQ]					+[IN_JS_DEFAULT])

%%effects
HTML_SCRIPT				[]					clMaroon				DEFAULT_BACKGROUND*
JS_DEFAULT				[]					clMaroon				DEFAULT_BACKGROUND*
JS_COMMENT				[fsBold]			clGreen					DEFAULT_BACKGROUND*
JS_FUNCTION				[fsBold]			clNavy					DEFAULT_BACKGROUND*
JS_IDENTIFIER			[]					clBlack					DEFAULT_BACKGROUND*
JS_NUMBER				[]					clGreen					DEFAULT_BACKGROUND*
JS_OBJECT				[fsBold]			clNavy					DEFAULT_BACKGROUND*
JS_OPERATOR				[]					clNavy					DEFAULT_BACKGROUND*
JS_RESERVED				[fsBold]			clBlue					DEFAULT_BACKGROUND*
JS_SEPARATOR			[]					clBlack					DEFAULT_BACKGROUND*
JS_STRING				[]					clTeal					DEFAULT_BACKGROUND*
JS_PROPERTY				[]					clMaroon				DEFAULT_BACKGROUND*

%%map
HTML_SCRIPT				HTML_SCRIPT
HTML_SCRIPT_START_START	HTML_SCRIPT
HTML_SCRIPT_START_STOP	HTML_SCRIPT
HTML_SCRIPT_STOP_START	HTML_SCRIPT
HTML_SCRIPT_STOP_STOP	HTML_SCRIPT
JS_DEFAULT				JS_DEFAULT
JS_COMMENT				JS_COMMENT
JS_COMMENT_LINE_START	JS_COMMENT
JS_COMMENT_LINE_STOP	JS_COMMENT
JS_COMMENT_STAR_START	JS_COMMENT
JS_COMMENT_STAR_STOP	JS_COMMENT
JS_FUNCTION				JS_FUNCTION
JS_IDENTIFIER			JS_IDENTIFIER
JS_NUMBER				JS_NUMBER
JS_OBJECT				JS_OBJECT
JS_OPERATOR				JS_OPERATOR
JS_RESERVED				JS_RESERVED
JS_SEPARATOR			JS_SEPARATOR
JS_STRING				JS_STRING
JS_STRING_START			JS_STRING
JS_STRING_STOP			JS_STRING
JS_STRING_SQ_START		JS_STRING
JS_STRING_SQ_STOP		JS_STRING
JS_PROPERTY				JS_PROPERTY