/*******************************************************************************
	Generic Style
	- Use this script as a basis for all other CSS parsers
*******************************************************************************/
// Elements
#define CSS_BASE					STYLE_SHEET_BASE
// Begin Virtual Elements - These must be defined by every style sheet parser
// so that the attributes can be colored properly
#define HTML_STYLE					CSS_BASE + 0
#define HTML_STYLE_START_START		CSS_BASE + 1
#define HTML_STYLE_START_STOP		CSS_BASE + 2
#define HTML_STYLE_STOP_START		CSS_BASE + 3
#define HTML_STYLE_STOP_STOP		CSS_BASE + 4
// End Virtual Elements
#define CSS_DEFAULT					CSS_BASE + 5

// States
#define IN_HTML_STYLE_START			CSS_BASE + 0
#define IN_HTML_STYLE_STOP			CSS_BASE + 1
#define IN_CSS_DEFAULT				CSS_BASE + 2

%%language
Anchor							+=	[HTML_STYLE_START_START HTML_STYLE_STOP_START]
BoundStates						+=	[IN_HTML_STYLE_START IN_HTML_STYLE_STOP IN_CSS_DEFAULT]
ContextStates					=	(HTML_STYLE_START_START [IN_HTML_STYLE_START]),
									(HTML_STYLE_STOP_START [IN_HTML_STYLE_STOP])
EditableStyles						('HTML Style'				, HTML_STYLE),
									('CSS Default'				, CSS_DEFAULT)
ExampleText						+=	'<style type="text/css">\n\
									\     h1 {\n\
									\		font-family: Verdana;\n\
									\		font-size: 8pt;\n\
									\		font-style: none;
									\     }\n\
									\</style>\n'

%%words
'<style'				NOT_ALPHA			HTML_STYLE_START_START	[IN_DEFAULT]
'>'						DONT_CARE			HTML_STYLE_START_STOP	[IN_HTML_STYLE_START]
'</style'				NOT_ALPHA			HTML_STYLE_STOP_START	[IN_CSS_DEFAULT]
'>'						DONT_CARE			HTML_STYLE_STOP_STOP	[IN_HTML_STYLE_STOP]

%%tokens
InState IN_CSS_DEFAULT (
	CSS_DEFAULT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_STYLE_START (
	HTML_STYLE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_STYLE_STOP (
	HTML_STYLE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
HTML_STYLE_START_START	(-[IN_DEFAULT]						+[IN_HTML_STYLE_START])
HTML_STYLE_START_STOP	(-[IN_HTML_STYLE_START]				+[IN_CSS_DEFAULT])

HTML_STYLE_STOP_START	(-[IN_CSS_DEFAULT]					+[IN_HTML_STYLE_STOP])
HTML_STYLE_STOP_STOP	(-[IN_HTML_STYLE_STOP]				+[IN_DEFAULT])

%%effects
CSS_DEFAULT				[]					clBlue					DEFAULT_BACKGROUND*
HTML_STYLE				[]					clBlue					DEFAULT_BACKGROUND*

%%map
HTML_STYLE				HTML_STYLE
HTML_STYLE_START_START	HTML_STYLE
HTML_STYLE_START_STOP	HTML_STYLE
HTML_STYLE_STOP_START	HTML_STYLE
HTML_STYLE_STOP_STOP	HTML_STYLE
CSS_DEFAULT				CSS_DEFAULT
