/*******************************************************************************
	HTML Attributes
	01/22/00 - Added Support for Single Quote attributes and numbers without
			   quotes of any kind
*******************************************************************************/
#define ATTRIB_BASE					HTML_ATTRIBUTE_BASE
#define HTML_ATTRIB					ATTRIB_BASE + 0
#define HTML_ATTRIB_START			ATTRIB_BASE + 1
#define HTML_ATTRIB_STOP			ATTRIB_BASE + 2
#define HTML_ATTRIB_SQ_START		ATTRIB_BASE + 3
#define HTML_ATTRIB_SQ_STOP			ATTRIB_BASE + 4
#define HTML_ATTRIB_NQ_START		ATTRIB_BASE + 5

#define IN_HTML_ATTRIB				ATTRIB_BASE + 0
#define IN_HTML_ATTRIB_SQ			ATTRIB_BASE + 1
#define HTML_ATTRIB_STATES			IN_HTML_BLOCK IN_HTML_FORM IN_HTML_FORMAT IN_HTML_FRAME IN_HTML_IMAGE IN_HTML_IMAGEMAP IN_HTML_LINK IN_HTML_LIST IN_HTML_MEDIA IN_HTML_STRUCTURE IN_HTML_TABLE IN_HTML_TAG IN_HTML_WHITESPACE IN_HTML_SCRIPT_START IN_HTML_SCRIPT_STOP IN_HTML_STYLE_START IN_HTML_STYLE_STOP

%%language
// Add HTML Attributes to the BoundStates and give an EditableStyle to modify
// TODO: Find out why BoundStates doesn't work?
//Anchor							+=	[HTML_ATTRIB_START]
//BoundStates						+=	[IN_HTML_ATTRIB]
EditableStyles						('HTML Attributes'				, HTML_ATTRIB)

%%words
// HTML Attributes
'"'						DONT_CARE			HTML_ATTRIB_START		[HTML_ATTRIB_STATES]
'"'						DONT_CARE			HTML_ATTRIB_STOP		[IN_HTML_ATTRIB]
// Single-Quoted Attributes
'\''					DONT_CARE			HTML_ATTRIB_SQ_START	[HTML_ATTRIB_STATES]
'\''					DONT_CARE			HTML_ATTRIB_SQ_STOP		[IN_HTML_ATTRIB_SQ]
// Non-quoted Attributes
'0'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'1'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'2'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'3'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'4'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'5'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'6'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'7'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'8'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]
'9'						'[0-9% >]'			HTML_ATTRIB_NQ_START	[HTML_ATTRIB_STATES]

%%handlers
HTML_ATTRIB_NQ_START	'[0-9%]'?			'[ >]'					_discard_

%%tokens
InState IN_HTML_ATTRIB (
	HTML_ATTRIB			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_HTML_ATTRIB_SQ (
	HTML_ATTRIB			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
HTML_ATTRIB_START		push	(-ALL_STATES				+[IN_HTML_ATTRIB])
HTML_ATTRIB_STOP		pop		()

HTML_ATTRIB_SQ_START	push	(-ALL_STATES				+[IN_HTML_ATTRIB_SQ])
HTML_ATTRIB_SQ_STOP		pop		()


%%effects
HTML_ATTRIB				[]					clBlack					DEFAULT_BACKGROUND*

%%map
HTML_ATTRIB				HTML_ATTRIB
HTML_ATTRIB_START		HTML_ATTRIB
HTML_ATTRIB_STOP		HTML_ATTRIB
HTML_ATTRIB_SQ_START	HTML_ATTRIB
HTML_ATTRIB_SQ_STOP		HTML_ATTRIB
HTML_ATTRIB_NQ_START	HTML_ATTRIB