/******************************************************************************
	ASP-VBScript Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Current Version Revision History:
	01/18/2000 - Rewritten from HTML+ 4.0 Beta
			   - Isolated ASP information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
			   - Added Style: 'ASP Separators'
			   - Added Style: 'ASP Processing Directives'
			   - Added Style: 'ASP Server-Side Includes' - moved to this file
			     since only #include works in ASP files
******************************************************************************/
// Elements
#define ASP_BASE					SERVER_SIDE_SCRIPT_BASE
#define ASP							ASP_BASE + 0
#define ASP_START					ASP_BASE + 1
#define ASP_STOP					ASP_BASE + 2
#define ASP_DEFAULT					ASP_BASE + 7
#define ASP_DIRECTIVE				ASP_BASE + 8
#define ASP_DIRECTIVE_START			ASP_BASE + 9
#define ASP_DIRECTIVE_STOP			ASP_BASE + 10
#define ASP_OBJECT					ASP_BASE + 14
#define ASP_SSI						ASP_BASE + 18
#define ASP_SSI_START				ASP_BASE + 19
#define ASP_SSI_STOP				ASP_BASE + 20

// States
#define IN_ASP_DEFAULT				ASP_BASE + 0
#define IN_ASP_DIRECTIVE			ASP_BASE + 2
#define IN_ASP_SSI					ASP_BASE + 3

// States where ASP can be found
#define ASP_STATES					IN_DEFAULT HTML_ATTRIBUTE_BASE..STYLE_SHEET_MAX

%%language
//Anchor							+=	[ASP_START]
BoundStates						+=	[IN_ASP_DIRECTIVE IN_ASP_SSI]
EditableStyles						('ASP Delimiters'				, ASP),
									('ASP Default'					, ASP_DEFAULT),
									('ASP Processing Directives'	, ASP_DIRECTIVE),
									('ASP Objects'					, ASP_OBJECT),
									('ASP Server-Side Includes'		, ASP_SSI)
																		
ExampleText						+=	'------- ASP -------\n\
									\<%@ LANGUAGE=VBScript %>\n\
									\<!--#include virtual="file.inc"-->\n\
									\<%\n\
									\     Response.Write("Value = " & 1.54 & vbCrLf)\n\
									\     \' Switch the value\n\
									\     If (bValue = True) Then\n\
									\          bValue = abs(iValue)\n\
									\     End If\n\
									\%>'

%%TriggerContexts
On ASP_START SeekTo	(ASP_DEFAULT [IN_ASP_DEFAULT])
									
%%words
// ASP Delimiters
'<\%'					DONT_CARE			ASP_START				[ASP_STATES]
'<\%='					DONT_CARE			ASP_START				[ASP_STATES]
'\%>'					DONT_CARE			ASP_STOP				[IN_ASP_DEFAULT]
// ASP Processing Directives
'<\%@'					DONT_CARE			ASP_DIRECTIVE_START		[ASP_STATES]
'\%>'					DONT_CARE			ASP_DIRECTIVE_STOP		[IN_ASP_DIRECTIVE]
// ASP Server-Side Includes
'<!--#'					DONT_CARE			ASP_SSI_START			[ASP_STATES]
'<!-- #'				DONT_CARE			ASP_SSI_START			[ASP_STATES]
'-->'					DONT_CARE			ASP_SSI_STOP			[IN_ASP_SSI]

%%kwtables
ForState [IN_ASP_DEFAULT] endswith NOT_ALPHA (
	// ASP Objects
	ASP_OBJECT			is	'application', 'asperror', 'objectcontext',	'request', 'response', 'server', 'session'
)

%%tokens
InState IN_ASP_DEFAULT (
	ASP_DEFAULT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ASP_DIRECTIVE (
	ASP_DIRECTIVE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ASP_SSI (
	ASP_SSI					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
ASP_START				push	(-ALL_STATES				+[IN_ASP_DEFAULT])
ASP_STOP				pop		()

ASP_DIRECTIVE_START		push	(-ALL_STATES				+[IN_ASP_DIRECTIVE])
ASP_DIRECTIVE_STOP		pop		()

ASP_SSI_START			push	(-ALL_STATES				+[IN_ASP_SSI])
ASP_SSI_STOP			pop		()

%%effects
ASP						[]					clRed					clLtSilver
ASP_DEFAULT				[]					DEFAULT_FOREGROUND*		clLtSilver
ASP_DIRECTIVE			[]					clRed					clLtSilver
ASP_OBJECT				[fsBold]			clNavy					clLtSilver
ASP_SSI					[fsBold]			clGray					clLtSilver

%%map
ASP						ASP
ASP_START				ASP
ASP_STOP				ASP
ASP_DEFAULT				ASP_DEFAULT
ASP_DIRECTIVE			ASP_DIRECTIVE
ASP_DIRECTIVE_START		ASP_DIRECTIVE
ASP_DIRECTIVE_STOP		ASP_DIRECTIVE
ASP_OBJECT				ASP_OBJECT
ASP_SSI					ASP_SSI
ASP_SSI_START			ASP_SSI
ASP_SSI_STOP			ASP_SSI
