/******************************************************************************
	ASP-VBScript Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Current Version Revision History:
	01/18/2000 - Rewritten from HTML+ 4.0 Beta
			   - Isolated ASP information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
			   - Added Style: 'ASP Separators'
			   - Added Style: 'ASP Processing Directives'
			   - Added Style: 'ASP Server-Side Includes' - moved to this file
			     since only #include works in ASP files
******************************************************************************/
// Elements
#define ASP_BASE					SERVER_SIDE_SCRIPT_BASE
#define ASP							ASP_BASE + 0
#define ASP_START					ASP_BASE + 1
#define ASP_STOP					ASP_BASE + 2
#define ASP_COMMENT					ASP_BASE + 3
#define ASP_COMMENT_START			ASP_BASE + 4
#define ASP_COMMENT_STOP			ASP_BASE + 5
#define ASP_CONSTANT				ASP_BASE + 6
#define ASP_DEFAULT					ASP_BASE + 7
#define ASP_DIRECTIVE				ASP_BASE + 8
#define ASP_DIRECTIVE_START			ASP_BASE + 9
#define ASP_DIRECTIVE_STOP			ASP_BASE + 10
#define ASP_FUNCTION				ASP_BASE + 11
#define ASP_IDENTIFIER				ASP_BASE + 12
#define ASP_NUMBER					ASP_BASE + 13
#define ASP_OBJECT					ASP_BASE + 14
#define ASP_OPERATOR				ASP_BASE + 15
#define ASP_RESERVED				ASP_BASE + 16
#define ASP_SEPARATOR				ASP_BASE + 17
#define ASP_SSI						ASP_BASE + 18
#define ASP_SSI_START				ASP_BASE + 19
#define ASP_SSI_STOP				ASP_BASE + 20
#define ASP_STRING					ASP_BASE + 21
#define ASP_STRING_START			ASP_BASE + 22
#define ASP_STRING_STOP				ASP_BASE + 23

// States
#define IN_ASP_DEFAULT				ASP_BASE + 0
#define IN_ASP_COMMENT				ASP_BASE + 1
#define IN_ASP_DIRECTIVE			ASP_BASE + 2
#define IN_ASP_SSI					ASP_BASE + 3
#define IN_ASP_STRING				ASP_BASE + 4

// States where ASP can be found
#define ASP_STATES					IN_DEFAULT HTML_ATTRIBUTE_BASE..STYLE_SHEET_MAX

%%language
//Anchor							+=	[ASP_START]
BoundStates						+=	[IN_ASP_COMMENT IN_ASP_DIRECTIVE IN_ASP_SSI IN_ASP_STRING]
EditableStyles						('ASP Delimiters'				, ASP),
									('ASP Comments'					, ASP_COMMENT),
									('ASP Constants'				, ASP_CONSTANT),
									('ASP Default'					, ASP_DEFAULT),
									('ASP Processing Directives'	, ASP_DIRECTIVE),
									('ASP Functions'				, ASP_FUNCTION),
									('ASP Identifiers'				, ASP_IDENTIFIER),
									('ASP Numbers'					, ASP_NUMBER),
									('ASP Objects'					, ASP_OBJECT),
									('ASP Operators'				, ASP_OPERATOR),
									('ASP Reserved Words'			, ASP_RESERVED),
									('ASP Separators'				, ASP_SEPARATOR),
									('ASP Server-Side Includes'		, ASP_SSI),
									('ASP Strings'					, ASP_STRING)
																		
ExampleText						+=	'------- ASP -------\n\
									\<%@ LANGUAGE=VBScript %>\n\
									\<!--#include virtual="file.inc"-->\n\
									\<%\n\
									\     Response.Write("Value = " & 1.54 & vbCrLf)\n\
									\     \' Switch the value\n\
									\     If (bValue = True) Then\n\
									\          bValue = abs(iValue)\n\
									\     End If\n\
									\%>'

%%TriggerContexts
On ASP_START SeekTo	(ASP_DEFAULT [IN_ASP_DEFAULT])
									
%%words
// ASP Comments
'\''					DONT_CARE			ASP_COMMENT_START		[IN_ASP_DEFAULT]
'rem'					NOT_ALPHA			ASP_COMMENT_START		[IN_ASP_DEFAULT]
'\n'					DONT_CARE			ASP_COMMENT_STOP		[IN_ASP_COMMENT]
// ASP Delimiters
'<\%'					DONT_CARE			ASP_START				[ASP_STATES]
'<\%='					DONT_CARE			ASP_START				[ASP_STATES]
'\%>'					DONT_CARE			ASP_STOP				[IN_ASP_DEFAULT IN_ASP_COMMENT]
// ASP Processing Directives
'<\%@'					DONT_CARE			ASP_DIRECTIVE_START		[ASP_STATES]
'\%>'					DONT_CARE			ASP_DIRECTIVE_STOP		[IN_ASP_DIRECTIVE]
// ASP Operators
'.'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'*'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'+'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'-'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'='						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'^'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'&'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'/'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'\\'					DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'<'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
'>'						DONT_CARE			ASP_OPERATOR			[IN_ASP_DEFAULT]
// ASP Separators
','						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
';'						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
'('						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
')'						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
'['						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
']'						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
'{'						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
'}'						DONT_CARE			ASP_SEPARATOR			[IN_ASP_DEFAULT]
// ASP Server-Side Includes
'<!--#'					DONT_CARE			ASP_SSI_START			[ASP_STATES]
'<!-- #'				DONT_CARE			ASP_SSI_START			[ASP_STATES]
'-->'					DONT_CARE			ASP_SSI_STOP			[IN_ASP_SSI]
// ASP Strings
'"'						DONT_CARE			ASP_STRING_START		[IN_ASP_DEFAULT]
'"'						DONT_CARE			ASP_STRING_STOP			[IN_ASP_STRING]

%%kwtables
ForState [IN_ASP_DEFAULT] endswith NOT_ALPHA (
	// ASP Constants
	ASP_CONSTANT		is	'vbBlack', 'vbRed', 'vbGreen', 'vbYellow', 'vbBlue',
							'vbMagenta', 'vbCyan', 'vbWhite', 'vbBinaryCompare',
							'vbTextCompare', 'vbSunday', 'vbMonday', 'vbTuesday',
							'vbWednesday', 'vbThursday', 'vbFriday', 'vbSaturday',
							'vbUseSystem', 'vbUseSystemDayOfWeek', 'vbFirstJan1',
							'vbFirstFourHours', 'vbFirstFullWeek', 'vbGeneralDate',
							'vbLongDate', 'vbShortDate', 'vbLongTime', 'vbShortTime',
							'vbObjectError', 'vbOKOnly', 'vbOKCancel', 'vbAbortRetryIgnore',
							'vbYesNoCancel', 'vbYesNo', 'vbRetryCancel', 'vbCritical',
							'vbQuestion', 'vbExclamation', 'vbInformation',
							'vbDefaultButton1', 'vbDefaultButton2',
							'vbDefaultButton3', 'vbApplicationModal', 'vbSystemModal',
							'vbOK', 'vbCancel', 'vbAbort', 'vbRetry', 'vbIgnore',
							'vbYes', 'vbNo', 'vbCr', 'vbCrLf', 'vbFormFeed', 'vbLf',
							'vbNewLine', 'vbNullChar', 'vbNullString', 'vbTab',
							'vbVerticalTab', 'vbUseDefault', 'vbTrue', 'vbFalse'
	// ASP Functions
	ASP_FUNCTION		is	'abs', 'array', 'asc', 'atn', 'cbool', 'cbyte', 'ccur',
							'cdate', 'cdbl', 'chr', 'chrb', 'chrw', 'cint', 'clng',
							'cos', 'createobject', 'csng', 'cstr', 'date', 'dateadd',
							'datediff', 'datepart', 'dateserial', 'datevalue',
							'day', 'exp', 'filter', 'fix', 'formatcurrency',
							'formatdatetime', 'formatnumber', 'formatpercent',
							'getlocale', 'getobject', 'getref', 'hex', 'hour',
							'inputbox', 'instr', 'instrrev', 'int', 'isarray',
							'isdate', 'isempty', 'isnull', 'isnumeric', 'isobject',
							'join', 'lbound', 'lcase', 'left', 'len', 'loadpicture',
							'log', 'ltrim', 'mid', 'minute', 'month', 'monthname',
							'msgbox', 'now', 'oct', 'replace', 'rgb', 'right', 'rnd',
							'round', 'rtrim', 'scriptengine', 'scriptenginebuildversion',
							'scriptenginemajorversion', 'scriptengineminorversion',
							'second', 'setlocale', 'sgn', 'sin', 'space', 'split',
							'sqr', 'strcomp', 'string', 'strreverse', 'tan', 'time',
							'timer', 'timeserial', 'timevalue', 'trim', 'typename',
							'ubound', 'ucase', 'vartype', 'weekday', 'weekdayname',
							'year'
	// ASP Objects
	ASP_OBJECT			is	'application', 'asperror', 'dictionary', 'err',
							'filesystemobject', 'match', 'matches', 'objectcontext',
							'regexp', 'request', 'response', 'server', 'session'
	// ASP Operator
	ASP_OPERATOR		is	'and', 'eqv', 'imp', 'is', 'mod', 'not', 'or', 'xor'
	// ASP Reserved Words
	ASP_RESERVED		is	'call', 'case', 'class', 'const', 'dim', 'do', 'each',
							'else', 'elseif', 'empty', 'end', 'erase', 'error',
							'execute', 'executeglobal', 'exit', 'explicit', 'false',
							'for', 'function', 'goto', 'if', 'in', 'loop', 'next',
							'nothing', 'null', 'on', 'option', 'preserve', 'private',
							'propertyset', 'propertyget', 'public', 'randomize',
							'redim', 'resume', 'select', 'set', 'sub', 'then',
							'to', 'true', 'until', 'wend', 'while', 'with'
)

%%tokens
InState IN_ASP_DEFAULT (
	ASP_DEFAULT				NOT_ALPHA			DONT_CARE?			DONT_CARE			_discard_
	ASP_IDENTIFIER			ID_START			ID_CONTAINS?		NOT_ID_CONTAINS		_discard_
	ASP_NUMBER				NUM_START			NUM_CONTAINS?		NOT_NUM_CONTAINS	_discard_
)

InState IN_ASP_COMMENT (
	ASP_COMMENT				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ASP_DIRECTIVE (
	ASP_DIRECTIVE			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ASP_SSI (
	ASP_SSI					DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_ASP_STRING (
	ASP_STRING				DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
ASP_START				push	(-ALL_STATES				+[IN_ASP_DEFAULT])
ASP_STOP				pop		()

ASP_COMMENT_START		(-[IN_ASP_DEFAULT]					+[IN_ASP_COMMENT])
ASP_COMMENT_STOP		(+[IN_ASP_DEFAULT]					-[IN_ASP_COMMENT])

ASP_DIRECTIVE_START		push	(-ALL_STATES				+[IN_ASP_DIRECTIVE])
ASP_DIRECTIVE_STOP		pop		()

ASP_SSI_START			push	(-ALL_STATES				+[IN_ASP_SSI])
ASP_SSI_STOP			pop		()

ASP_STRING_START		(-[IN_ASP_DEFAULT]					+[IN_ASP_STRING])
ASP_STRING_STOP			(+[IN_ASP_DEFAULT]					-[IN_ASP_STRING])

%%effects
ASP						[]					clRed					clLtSilver
ASP_CONSTANT			[fsBold]			clBlue					clLtSilver
ASP_COMMENT				[fsBold]			clGreen					clLtSilver
ASP_DEFAULT				[]					DEFAULT_FOREGROUND*		clLtSilver
ASP_DIRECTIVE			[]					clRed					clLtSilver
ASP_FUNCTION			[fsBold]			clNavy					clLtSilver
ASP_IDENTIFIER			[]					clBlack					clLtSilver
ASP_NUMBER				[]					clGreen					clLtSilver
ASP_OBJECT				[fsBold]			clNavy					clLtSilver
ASP_OPERATOR			[fsBold]			clNavy					clLtSilver
ASP_RESERVED			[fsBold]			clBlue					clLtSilver
ASP_SEPARATOR			[fsBold]			clBlack					clLtSilver
ASP_SSI					[fsBold]			clGray					clLtSilver
ASP_STRING				[]					clTeal					clLtSilver

%%map
ASP						ASP
ASP_START				ASP
ASP_STOP				ASP
ASP_CONSTANT			ASP_CONSTANT
ASP_COMMENT				ASP_COMMENT
ASP_COMMENT_START		ASP_COMMENT
ASP_COMMENT_STOP		ASP_COMMENT
ASP_DEFAULT				ASP_DEFAULT
ASP_DIRECTIVE			ASP_DIRECTIVE
ASP_DIRECTIVE_START		ASP_DIRECTIVE
ASP_DIRECTIVE_STOP		ASP_DIRECTIVE
ASP_FUNCTION			ASP_FUNCTION
ASP_IDENTIFIER			ASP_IDENTIFIER
ASP_NUMBER				ASP_NUMBER
ASP_OBJECT				ASP_OBJECT
ASP_OPERATOR			ASP_OPERATOR
ASP_RESERVED			ASP_RESERVED
ASP_SEPARATOR			ASP_SEPARATOR
ASP_SSI					ASP_SSI
ASP_SSI_START			ASP_SSI
ASP_SSI_STOP			ASP_SSI
ASP_STRING				ASP_STRING
ASP_STRING_START		ASP_STRING
ASP_STRING_STOP			ASP_STRING