/******************************************************************************
	JSP Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Current Version Revision History:
	01/22/2000 - Rewritten from HTML+ 4.0 Beta
			   - Isolated JSP information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
			   - Added 'JSP Separators'
			   - Added 'JSP Action Attributes' only when SHOW_HTML_ATTRIBS is
			     defined
			   - Added support for JSP Strings with single quotes
******************************************************************************/
// Elements
#define JSP_BASE					SERVER_SIDE_SCRIPT_BASE
#define JSP_DEFAULT					JSP_BASE + 0
#define JSP							JSP_BASE + 1
#define JSP_START					JSP_BASE + 2
#define JSP_STOP					JSP_BASE + 3
#define JSP_ACTION					JSP_BASE + 4
#define JSP_ACTION_START			JSP_BASE + 5
#define JSP_ACTION_STOP				JSP_BASE + 6
#define JSP_COMMENT					JSP_BASE + 7
#define JSP_COMMENT_START			JSP_BASE + 8
#define JSP_COMMENT_STOP			JSP_BASE + 9
#define JSP_SCOMMENT				JSP_BASE + 10
#define JSP_SCOMMENT_STAR_START		JSP_BASE + 11
#define JSP_SCOMMENT_STAR_STOP		JSP_BASE + 12
#define JSP_SCOMMENT_LINE_START		JSP_BASE + 13
#define JSP_SCOMMENT_LINE_STOP		JSP_BASE + 14
#define JSP_DIRECTIVE				JSP_BASE + 15
#define JSP_DIRECTIVE_START			JSP_BASE + 16
#define JSP_DIRECTIVE_STOP			JSP_BASE + 17
#define JSP_IDENTIFIER				JSP_BASE + 18
#define JSP_NUMBER					JSP_BASE + 19
#define JSP_OBJECT					JSP_BASE + 20
#define JSP_OPERATOR				JSP_BASE + 21
#define JSP_STRING					JSP_BASE + 22
#define JSP_STRING_START			JSP_BASE + 23
#define JSP_STRING_STOP				JSP_BASE + 24
#define JSP_STRING_SQ_START			JSP_BASE + 25
#define JSP_STRING_SQ_STOP			JSP_BASE + 26
#define JSP_RESERVED				JSP_BASE + 27
#define JSP_ACTION_ATTRIB			JSP_BASE + 28
#define JSP_SEPARATOR				JSP_BASE + 29

// States
#define IN_JSP_DEFAULT				JSP_BASE + 0
#define IN_JSP_COMMENT				JSP_BASE + 1
#define IN_JSP_SCOMMENT_LINE		JSP_BASE + 2
#define IN_JSP_SCOMMENT_STAR		JSP_BASE + 3
#define IN_JSP_ACTION				JSP_BASE + 4
#define IN_JSP_DIRECTIVE			JSP_BASE + 5
#define IN_JSP_STRING				JSP_BASE + 6
#define IN_JSP_STRING_SQ			JSP_BASE + 7

// States where JSP can be found
#define JSP_STATES					IN_DEFAULT HTML_ATTRIBUTE_BASE..STYLE_SHEET_MAX

%%language
//Anchor							+=	[JSP_START]
BoundStates						+=	[IN_JSP_ACTION IN_JSP_COMMENT IN_JSP_SCOMMENT_LINE IN_JSP_SCOMMENT_STAR IN_JSP_STRING]
EditableStyles						('JSP Default'					, JSP_DEFAULT),
									('JSP Actions'					, JSP_ACTION),
#ifdef SHOW_HTML_ATTRIBS
									('JSP Action Attributes'		, JSP_ACTION_ATTRIB),
#endif
									('JSP Comments'					, JSP_COMMENT),
									('JSP Delimiters'				, JSP),
									('JSP Directives'				, JSP_DIRECTIVE),
									('JSP Identifiers'				, JSP_IDENTIFIER),
									('JSP Numbers'					, JSP_NUMBER),								
									('JSP Objects'					, JSP_OBJECT),
									('JSP Operators'				, JSP_OPERATOR),
									('JSP Reserved Words'			, JSP_RESERVED),
									('JSP Strings'					, JSP_STRING),
									('JSP Separators'				, JSP_SEPARATOR)
ExampleText						+=	'------- JSP -------\n\
									\<jsp:useBean id="connection" class="com.myco.myapp.Connection">\n\
									\<jsp:setProperty name="connection" property="timeout" value="33">\n\
									\</jsp:useBean>\n\
									\<%-- JSP Comment --%>\n\
									\<%\n\
									\     out.println("Value = " + 1.54)\n\
									\     // Switch the value\n\
									\     if (bValue == true) {\n\
									\          bValue = 45;\n\
									\     }\n\
									\%>'

%%TriggerContexts
On JSP_START SeekTo	(JSP_DEFAULT [IN_JSP_DEFAULT])
									
%%words
// JSP
'<%'					DONT_CARE			JSP_START				[JSP_STATES]
'<%='					DONT_CARE			JSP_START				[JSP_STATES]
'<%!'					DONT_CARE			JSP_START				[JSP_STATES]
'%>'					DONT_CARE			JSP_STOP				[IN_JSP_DEFAULT IN_JSP_SCOMMENT_LINE IN_JSP_SCOMMENT_STAR]
// JSP Directives
'<%@'					DONT_CARE			JSP_DIRECTIVE_START		[JSP_STATES]
'%>'					DONT_CARE			JSP_DIRECTIVE_STOP		[IN_JSP_DIRECTIVE]
// JSP Comments
'<%--'					DONT_CARE			JSP_COMMENT_START		[IN_DEFAULT]
'--%>'					DONT_CARE			JSP_COMMENT_STOP		[IN_JSP_COMMENT]
'\/\/'					DONT_CARE			JSP_SCOMMENT_LINE_START	[IN_JSP_DEFAULT]
'\n'					DONT_CARE			JSP_SCOMMENT_LINE_STOP	[IN_JSP_SCOMMENT_LINE]
'\/*'					DONT_CARE			JSP_SCOMMENT_STAR_START	[IN_JSP_DEFAULT]
'*\/'					DONT_CARE			JSP_SCOMMENT_STAR_STOP	[IN_JSP_SCOMMENT_STAR]
// JSP Tags
'<jsp:forward'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:getProperty'		NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:include'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:plugin'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'</jsp:plugin'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:setProperty'		NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:useBean'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'</jsp:useBean'			NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<jsp:'					ALPHA				JSP_ACTION_START		[IN_DEFAULT]
'</jsp:'				ALPHA				JSP_ACTION_START		[IN_DEFAULT]
'<usebean'				NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'</usebean'				NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'<bean'					NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'</bean'				NOT_ALPHA			JSP_ACTION_START		[IN_DEFAULT]
'>'						DONT_CARE			JSP_ACTION_STOP			[IN_JSP_ACTION]
// JSP Separators
'('						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
')'						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
'{'						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
'}'						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
'['						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
']'						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
';'						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
','						DONT_CARE			JSP_SEPARATOR			[IN_JSP_DEFAULT]
// JSP Operators
'.'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'='						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'>'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'<'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'!'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'~'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'?'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
':'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'&'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'|'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'+'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'-'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'*'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'/'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'^'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
'%'						DONT_CARE			JSP_OPERATOR			[IN_JSP_DEFAULT]
// JSP Strings
'"'						DONT_CARE			JSP_STRING_START		[IN_JSP_DEFAULT]
'"'						DONT_CARE			JSP_STRING_STOP			[IN_JSP_STRING]
'\''					DONT_CARE			JSP_STRING_SQ_START		[IN_JSP_DEFAULT]
'\''					DONT_CARE			JSP_STRING_SQ_STOP		[IN_JSP_STRING_SQ]

%%kwtables
ForState [IN_JSP_DEFAULT] endswith NOT_ALPHA (
	JSP_OBJECT		is	'request', 'response', 'pageContext', 'session', 'application',
						'out', 'config', 'page', 'exception', 'object', 'string',
						'system'
						
	JSP_RESERVED	is	'abstract', 'default', 'if', 'private', 'throw', 'boolean',
						'do', 'implements', 'protected', 'throws', 'break', 'double',
						'import', 'public', 'transient', 'byte', 'else', 'instanceof',
						'return', 'try', 'case', 'extends', 'int', 'short', 'void',
						'catch', 'final', 'interface', 'static', 'volatile', 'char',
						'finally', 'long', 'super', 'while', 'class', 'float', 'native',
						'switch', 'const', 'for', 'new', 'synchronized', 'continue',
						'goto', 'package', 'this', 'true', 'false', 'null'
)

%%tokens
InState IN_JSP_DEFAULT (
	JSP_DEFAULT			NOT_ALPHA			DONT_CARE?			DONT_CARE			_discard_
	JSP_IDENTIFIER		ID_START			ID_CONTAINS?		NOT_ID_CONTAINS		_discard_
	JSP_NUMBER			NUM_START			NUM_CONTAINS?		NOT_NUM_CONTAINS	_discard_
)

InState IN_JSP_ACTION (
#ifndef SHOW_HTML_ATTRIBS
	JSP_ACTION			DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
#else
	JSP_ACTION			'[^"]'				DONT_CARE?			DONT_CARE		_discard_
	JSP_ACTION_ATTRIB	'["]'				DONT_CARE?			'["]'			_use_
#endif
)

InState IN_JSP_DIRECTIVE (
	JSP_DIRECTIVE		DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
//	JSP_DIRECTIVE		NOT_ALPHA			DONT_CARE?			DONT_CARE		_discard_
//	JSP_IDENTIFIER		ID_START			ID_CONTAINS?		NOT_ID_CONTAINS		_discard_
//	JSP_NUMBER			NUM_START			NUM_CONTAINS?		NOT_NUM_CONTAINS	_discard_
)

InState IN_JSP_COMMENT (
	JSP_COMMENT			DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

InState IN_JSP_SCOMMENT_LINE (
	JSP_SCOMMENT		DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

InState IN_JSP_SCOMMENT_STAR (
	JSP_SCOMMENT		DONT_CARE			DONT_CARE?			DONT_CARE		_discard_
)

InState IN_JSP_STRING (
	JSP_STRING			'[^"\\]'			DONT_CARE?			DONT_CARE		_discard_
	JSP_STRING			'\\'				DONT_CARE			DONT_CARE		_discard_
)

InState IN_JSP_STRING_SQ (
	JSP_STRING			'[^\'\\]'			DONT_CARE?			DONT_CARE		_discard_
	JSP_STRING			'\\'				DONT_CARE			DONT_CARE		_discard_
)

%%states
JSP_START				push (-ALL_STATES						+[IN_JSP_DEFAULT])
JSP_STOP				pop ()

JSP_ACTION_START		(+[IN_JSP_ACTION]						-[IN_DEFAULT])
JSP_ACTION_STOP			(-[IN_JSP_ACTION]						+[IN_DEFAULT])

JSP_DIRECTIVE_START		push (-ALL_STATES						+[IN_JSP_DIRECTIVE])
JSP_DIRECTIVE_STOP		pop ()

JSP_COMMENT_START		(+[IN_JSP_COMMENT]						-[IN_DEFAULT])
JSP_COMMENT_STOP		(-[IN_JSP_COMMENT]						+[IN_DEFAULT])

JSP_SCOMMENT_LINE_START	(+[IN_JSP_SCOMMENT_LINE]				-[IN_JSP_DEFAULT])
JSP_SCOMMENT_LINE_STOP	(-[IN_JSP_SCOMMENT_LINE]				+[IN_JSP_DEFAULT])

JSP_SCOMMENT_STAR_START	(+[IN_JSP_SCOMMENT_STAR]				-[IN_JSP_DEFAULT])
JSP_SCOMMENT_STAR_STOP	(-[IN_JSP_SCOMMENT_STAR]				+[IN_JSP_DEFAULT])

JSP_STRING_START		(+[IN_JSP_STRING]						-[IN_JSP_DEFAULT])
JSP_STRING_STOP			(-[IN_JSP_STRING]						+[IN_JSP_DEFAULT])

JSP_STRING_SQ_START		(+[IN_JSP_STRING_SQ]						-[IN_JSP_DEFAULT])
JSP_STRING_SQ_STOP		(-[IN_JSP_STRING_SQ]						+[IN_JSP_DEFAULT])

%%effects
JSP_DEFAULT				[]					clBlack				clLtSilver
JSP						[]					clRed				clLtSilver
JSP_COMMENT				[]					clGreen				clLtSilver
JSP_ACTION				[]					clRed				clLtSilver
JSP_DIRECTIVE			[]					clRed				clLtSilver
JSP_IDENTIFIER			[]					clBlack				clLtSilver
JSP_NUMBER				[]					clGreen				clLtSilver
JSP_OBJECT				[fsBold]			clNavy				clLtSilver
JSP_OPERATOR			[fsBold]			clNavy				clLtSilver
JSP_RESERVED			[fsBold]			clBlue				clLtSilver
JSP_STRING				[]					clTeal				clLtSilver
JSP_SEPARATOR			[fsBold]			clBlack				clLtSilver
#ifdef SHOW_HTML_ATTRIBS
JSP_ACTION_ATTRIB		[]					clBlack				clLtSilver
#endif

%%map
JSP_DEFAULT				JSP_DEFAULT
JSP						JSP
JSP_START				JSP
JSP_STOP				JSP
JSP_COMMENT				JSP_COMMENT
JSP_COMMENT_START		JSP_COMMENT
JSP_COMMENT_STOP		JSP_COMMENT
JSP_SCOMMENT			JSP_COMMENT
JSP_SCOMMENT_LINE_START	JSP_COMMENT
JSP_SCOMMENT_LINE_STOP	JSP_COMMENT
JSP_SCOMMENT_STAR_START	JSP_COMMENT
JSP_SCOMMENT_STAR_STOP	JSP_COMMENT
JSP_ACTION				JSP_ACTION
JSP_ACTION_START		JSP_ACTION
JSP_ACTION_STOP			JSP_ACTION
JSP_DIRECTIVE			JSP_DIRECTIVE
JSP_DIRECTIVE_START		JSP_DIRECTIVE
JSP_DIRECTIVE_STOP		JSP_DIRECTIVE
JSP_IDENTIFIER			JSP_IDENTIFIER
JSP_NUMBER				JSP_NUMBER
JSP_OBJECT				JSP_OBJECT
JSP_OPERATOR			JSP_OPERATOR
JSP_RESERVED			JSP_RESERVED
JSP_STRING				JSP_STRING
JSP_STRING_START		JSP_STRING
JSP_STRING_STOP			JSP_STRING
JSP_STRING_SQ_START		JSP_STRING
JSP_STRING_SQ_STOP		JSP_STRING
JSP_SEPARATOR			JSP_SEPARATOR
#ifdef SHOW_HTML_ATTRIBS
JSP_ACTION_ATTRIB		JSP_ACTION_ATTRIB
#endif