/******************************************************************************
	PHP Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Special Thanks to Marjolein Katsma for input and testing.
	
	Current Version Revision History:
	01/22/2000 - Rewritten from HTML+PHP 4.0 Beta
			   - Isolated PHP information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
	08/09/2000 - Added support for PHP inside of script blocks detected by
				 language attribute
	08/10/2000 - Added type="text/php" attribute detection
******************************************************************************/
// Elements
#define PHP_BASE					SERVER_SIDE_SCRIPT_BASE
#define PHP_DEFAULT					PHP_BASE + 0
#define PHP							PHP_BASE + 1
#define PHP_START					PHP_BASE + 2
#define PHP_STOP					PHP_BASE + 3
#define PHP_IDENTIFIER				PHP_BASE + 4
#define PHP_NUMBER					PHP_BASE + 5
#define PHP_COMMENT					PHP_BASE + 6
#define PHP_COMMENT_LINE_START		PHP_BASE + 7
#define PHP_COMMENT_LINE_STOP		PHP_BASE + 8
#define PHP_COMMENT_STAR_START		PHP_BASE + 9
#define PHP_COMMENT_STAR_STOP		PHP_BASE + 10
#define PHP_RESERVED				PHP_BASE + 11
#define PHP_FUNCTION				PHP_BASE + 12
#define PHP_VARIABLE				PHP_BASE + 13
#define PHP_CONSTANT				PHP_BASE + 14
#define PHP_EXECSTRING				PHP_BASE + 15
#define PHP_EXECSTRING_START		PHP_BASE + 16
#define PHP_EXECSTRING_STOP			PHP_BASE + 17
#define PHP_OPERATOR				PHP_BASE + 18
#define PHP_STRING					PHP_BASE + 19
#define PHP_STRING_START			PHP_BASE + 20
#define PHP_STRING_STOP				PHP_BASE + 21
#define PHP_STRING_SQ_START			PHP_BASE + 22
#define PHP_STRING_SQ_STOP			PHP_BASE + 23
#define PHP_THIS					PHP_BASE + 24
#define PHP_SEPARATOR				PHP_BASE + 25
// Script support
#define SCRIPT_PHP_START			PHP_BASE + 26
#define PHP_SCRIPT_START_STOP		PHP_BASE + 27
#define PHP_SCRIPT_STOP_START		PHP_BASE + 28
#define PHP_SCRIPT_STOP_STOP		PHP_BASE + 29

// States
#define IN_PHP_DEFAULT				PHP_BASE + 0
#define IN_PHP_COMMENT_LINE			PHP_BASE + 1
#define IN_PHP_COMMENT_STAR			PHP_BASE + 2
#define IN_PHP_STRING				PHP_BASE + 3
#define IN_PHP_STRING_SQ			PHP_BASE + 4
#define IN_PHP_EXECSTRING			PHP_BASE + 5
// Script support
#define IN_PHP_SCRIPT_START			PHP_BASE + 6
#define IN_PHP_SCRIPT_STOP			PHP_BASE + 7

// States where ASP can be found
#define PHP_STATES					IN_DEFAULT HTML_ATTRIBUTE_BASE..STYLE_SHEET_MAX

%%language
//Anchor							+=	[PHP_START]
// 1105
BoundStates						+=	[IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR IN_PHP_EXECSTRING IN_PHP_STRING IN_PHP_STRING_SQ]
EditableStyles						('PHP Delimiters'				, PHP),
									('PHP Default'					, PHP_DEFAULT),
									('PHP Comments'					, PHP_COMMENT),
									('PHP Identifiers'				, PHP_IDENTIFIER),
									('PHP Numbers'					, PHP_NUMBER),
									('PHP Reserved Words'			, PHP_RESERVED),
									('PHP Functions'				, PHP_FUNCTION),
									('PHP Variables'				, PHP_VARIABLE),
									('PHP Constants'				, PHP_CONSTANT),
									('PHP Shell Commands'			, PHP_EXECSTRING),
									('PHP Operators'				, PHP_OPERATOR),
									('PHP Strings'					, PHP_STRING),
									('PHP This'						, PHP_THIS),
									('PHP Separators'				, PHP_SEPARATOR)
																		
ExampleText						+=	'------- PHP -------\n\
									\<?php\n\
									\     $size = GetImageSize("testimg.jpg",&$info);\n\
									\     if (isset($info["APP13"])) {\n\
									\          $iptc = iptcparse($info["APP13"]);\n\
									\          var_dump($iptc);\n\
									\     }\n\
									\?>'
									
%%TriggerContexts
On PHP_START SeekTo	(PHP_DEFAULT [IN_PHP_DEFAULT])

%%words
// <SCRIPT> support
'language="php"'		DONT_CARE			SCRIPT_PHP_START		[IN_HTML_SCRIPT_START]
'type="text/php"'		DONT_CARE			SCRIPT_PHP_START		[IN_HTML_SCRIPT_START]
'>'						DONT_CARE			PHP_SCRIPT_START_STOP	[IN_PHP_SCRIPT_START]
'</script'				NOT_ALPHA			PHP_SCRIPT_STOP_START	[IN_PHP_DEFAULT]
'>'						DONT_CARE			PHP_SCRIPT_STOP_STOP	[IN_PHP_SCRIPT_STOP]
// PHP
'<?'					DONT_CARE			PHP_START				[PHP_STATES]
'<?php'					DONT_CARE			PHP_START				[PHP_STATES]
'?>'					DONT_CARE			PHP_STOP				[IN_PHP_DEFAULT IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR]
'<%'					DONT_CARE			PHP_START				[PHP_STATES]
'<%='					DONT_CARE			PHP_START				[PHP_STATES]
'%>'					DONT_CARE			PHP_STOP				[IN_PHP_DEFAULT IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR]
// PHP Comments
'#'						DONT_CARE			PHP_COMMENT_LINE_START	[IN_PHP_DEFAULT]
'\/\/'					DONT_CARE			PHP_COMMENT_LINE_START	[IN_PHP_DEFAULT]
'\n'					DONT_CARE			PHP_COMMENT_LINE_STOP	[IN_PHP_COMMENT_LINE]
'\/*'					DONT_CARE			PHP_COMMENT_STAR_START	[IN_PHP_DEFAULT]
'*\/'					DONT_CARE			PHP_COMMENT_STAR_STOP	[IN_PHP_COMMENT_STAR]
// PHP Operator
'.'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'+'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'-'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'*'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'/'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'%'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'<'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'>'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'='						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'!'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'?'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
':'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'|'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'&'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'~'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'^'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'@'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
// PHP separators
','						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
';'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'('						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
')'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'['						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
']'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'{'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'}'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
// PHP This
'$this'					NOT_ALPHA			PHP_THIS				[IN_PHP_DEFAULT]
// PHP Variable
'$'						'[A-Za-z_${]'		PHP_VARIABLE			[IN_PHP_DEFAULT]
//'$$'					ALPHA				PHP_VARIABLE			[IN_PHP_DEFAULT]
// PHP Execution String
'`'						DONT_CARE			PHP_EXECSTRING_START	[IN_PHP_DEFAULT]
'`'						DONT_CARE			PHP_EXECSTRING_STOP		[IN_PHP_EXECSTRING]
// PHP String
'"'						DONT_CARE			PHP_STRING_START		[IN_PHP_DEFAULT]
'"'						DONT_CARE			PHP_STRING_STOP			[IN_PHP_STRING]
'\''					DONT_CARE			PHP_STRING_SQ_START		[IN_PHP_DEFAULT]
'\''					DONT_CARE			PHP_STRING_SQ_STOP		[IN_PHP_STRING_SQ]

%%handlers
PHP_VARIABLE			'[A-Za-z0-9_$]'?			'[^A-Za-z0-9_]'				_discard_

%%kwtables
// 1192
ForState [IN_PHP_DEFAULT] endswith NOT_ALPHA (
	// PHP Constant
	PHP_CONSTANT	is	'__FILE__', '__LINE__', 'PHP_VERSION', 'PHP_OS', 'TRUE', 'FALSE',
						'E_ERROR', 'E_WARNING', 'E_PARSE', 'E_NOTICE', 'M_PI'
	// PHP Function
	PHP_FUNCTION	is	'abs', 'acos', 'ada_afetch', 'ada_autocommit', 'ada_close',
						'ada_commit', 'ada_connect', 'ada_exec', 'ada_fetchrow',
						'ada_fieldname', 'ada_fieldnum', 'ada_fieldtype', 'ada_freeresult',
						'ada_numfields', 'ada_numrows', 'ada_result', 'ada_resultall',
						'ada_rollback', 'addcslashes', 'addslashes', 'apache_lookup_uri',
						'apache_note', 'array', 'array_count_values', 'array_flip', 'array_keys',
						'array_merge', 'array_pad', 'array_pop', 'array_push', 'array_reverse',
						'array_shift', 'array_slice', 'array_splice', 'array_unshift', 'array_values',
						'array_walk', 'arsort', 'asin', 'asort', 'aspell_check', 'aspell_check_raw',
						'aspell_new', 'aspell_suggest', 'atan', 'atan2', 'base64_decode',
						'base64_encode', 'base_convert', 'basename', 'bcadd', 'bccomp', 'bcdiv',
						'bcmod', 'bcmul', 'bcpow', 'bcscale', 'bcsqrt', 'bcsub', 'bin2hex', 'bindec',
						'ceil', 'chdir', 'checkdate', 'checkdnsrr', 'chgrp', 'chmod', 'chop', 'chown',
						'chr', 'chunk_split', 'clearstatcache', 'closedir', 'closelog', 'compact',
						'connection_aborted', 'connection_status', 'connection_timeout',
						'convert_cyr_string', 'copy', 'cos', 'count', 'cpdf_add_annotation',
						'cpdf_add_outline', 'cpdf_arc', 'cpdf_begin_text', 'cpdf_circle', 'cpdf_clip',
						'cpdf_close', 'cpdf_closepath', 'cpdf_closepath_fill_stroke',
						'cpdf_closepath_stroke', 'cpdf_continue_text', 'cpdf_curveto',
						'cpdf_end_text', 'cpdf_endpath', 'cpdf_fill', 'cpdf_fill_stroke',
						'cpdf_finalize', 'cpdf_finalize_page', 'cpdf_import_jpeg', 'cpdf_lineto',
						'cpdf_moveto', 'cpdf_open', 'cpdf_output_buffer', 'cpdf_page_init',
						'cpdf_place_inline_image', 'cpdf_rect', 'cpdf_restore', 'cpdf_rlineto',
						'cpdf_rmoveto', 'cpdf_rotate', 'cpdf_save', 'cpdf_save_to_file',
						'cpdf_scale', 'cpdf_set_char_spacing', 'cpdf_set_creator', 'cpdf_set_current_page',
						'cpdf_set_font', 'cpdf_set_horiz_scaling', 'cpdf_set_keywords', 'cpdf_set_leading',
						'cpdf_set_page_animation', 'cpdf_set_subject', 'cpdf_set_text_matrix',
						'cpdf_set_text_pos', 'cpdf_set_text_rendering', 'cpdf_set_text_rise',
						'cpdf_set_title', 'cpdf_set_word_spacing', 'cpdf_setdash',
						'cpdf_setflat', 'cpdf_setgray', 'cpdf_setgray_fill', 'cpdf_setgray_stroke',
						'cpdf_setlinecap', 'cpdf_setlinejoin', 'cpdf_setlinewidth',
						'cpdf_setmiterlimit', 'cpdf_setrgbcolor', 'cpdf_setrgbcolor_fill',
						'cpdf_setrgbcolor_stroke', 'cpdf_show', 'cpdf_show_xy',
						'cpdf_stringwidth', 'cpdf_stroke', 'cpdf_text', 'cpdf_translate',
						'crypt', 'current', 'date', 'dba_close', 'dba_delete',
						'dba_exists', 'dba_fetch', 'dba_firstkey', 'dba_insert',
						'dba_nextkey', 'dba_open', 'dba_optimize', 'dba_popen',
						'dba_replace', 'dba_sync', 'dbase_add_record', 'dbase_close',
						'dbase_create', 'dbase_delete_record', 'dbase_get_record',
						'dbase_get_record_with_names', 'dbase_numfields', 'dbase_numrecords',
						'dbase_open', 'dbase_pack', 'dbase_replace_record', 'dblist',
						'dbmclose', 'dbmdelete', 'dbmexists', 'dbmfetch', 'dbmfirstkey',
						'dbminsert', 'dbmnextkey', 'dbmopen', 'dbmreplace', 'debugger_off',
						'debugger_on', 'decbin', 'dechex', 'decoct', 'define',
						'defined', 'delete', 'die', 'dir', 'dirname', 'diskfreespace',
						'dl', 'doubleval', 'each', 'easter_date', 'easter_days',
						'empty', 'end', 'ereg', 'ereg_replace', 'eregi', 'eregi_replace',
						'error_log', 'error_reporting', 'escapeshellcmd', 'eval',
						'exec', 'exp', 'explode', 'extension_loaded', 'extract',
						'fclose', 'fdf_close', 'fdf_create', 'fdf_get_file', 'fdf_get_status',
						'fdf_get_value', 'fdf_next_field_name', 'fdf_open', 'fdf_save',
						'fdf_set_ap', 'fdf_set_file', 'fdf_set_status', 'fdf_set_value',
						'feof', 'fgetc', 'fgetcsv', 'fgets', 'fgetss', 'file', 'file_exists',
						'fileatime', 'filectime', 'filegroup', 'fileinode', 'filemtime',
						'fileowner', 'fileperms', 'filepro', 'filepro_fieldcount',
						'filepro_fieldname', 'filepro_fieldtype', 'filepro_fieldwidth',
						'filepro_retrieve', 'filepro_rowcount', 'filesize', 'filetype',
						'flock', 'floor', 'flush', 'fopen', 'fpassthru', 'fputs',
						'fread', 'frenchtojd', 'fseek', 'fseekv', 'fsockopen', 'ftell',
						'ftp_cdup', 'ftp_chdir', 'ftp_connect', 'ftp_delete', 'ftp_fget',
						'ftp_fput', 'ftp_get', 'ftp_login', 'ftp_mdtm', 'ftp_mkdir',
						'ftp_nlist', 'ftp_pasv', 'ftp_put', 'ftp_pwd', 'ftp_quit',
						'ftp_rawlist', 'ftp_rename', 'ftp_rmdir', 'ftp_size', 'ftp_systype',
						'func_get_arg', 'func_get_args', 'func_num_args', 'function_exists',
						'fwrite', 'get_browser', 'get_cfg_var', 'get_current_user',
						'get_html_translation_table', 'get_magic_quotes_gpc',
						'get_magic_quotes_runtime', 'get_meta_tags', 'getallheaders',
						'getdate', 'getenv', 'gethostbyaddr', 'gethostbyname',
						'gethostbynamel', 'getimagesize', 'getlastmod','getmxrr',
						'getmyinode', 'getmypid', 'getmyuid', 'getprotobyname',
						'getprotobynumber', 'getrandmax', 'getrusage', 'getservbyname',
						'getservbyport', 'gettimeofday', 'gettype', 'gmdate',
						'gmmktime', 'gmstrftime', 'gregoriantojd', 'gzclose',
						'gzeof', 'gzfile', 'gzgetc', 'gzgets', 'gzgetss', 'gzopen',
						'gzpassthru', 'gzputs', 'gzread', 'gzrewind', 'gzseek', 'gztell',
						'gzwrite', 'header', 'hexdec', 'htmlentities', 'htmlspecialchars',
						'hw_array2objrec', 'hw_children', 'hw_childrenobj', 'hw_close',
						'hw_connect', 'hw_cp', 'hw_deleteobject', 'hw_docbyanchor',
						'hw_docbyanchorobj', 'hw_documentattributes', 'hw_documentbodytag',
						'hw_documentcontent', 'hw_documentsetcontent', 'hw_documentsize',
						'hw_edittext', 'hw_error', 'hw_errormsg', 'hw_free_document',
						'hw_getanchors', 'hw_getanchorsobj', 'hw_getandlock', 'hw_getchildcoll',
						'hw_getchildcollobj', 'hw_getchilddoccoll', 'hw_getchilddoccollobj',
						'hw_getobject', 'hw_getobjectbyquery', 'hw_getobjectbyquerycoll',
						'hw_getobjectbyquerycollobj','hw_getobjectbyqueryobj', 'hw_getparents',
						'hw_getparentsobj', 'hw_getremote', 'hw_getremotechildren',
						'hw_getsrcbydestobj', 'hw_gettext', 'hw_getusername', 'hw_identify',
						'hw_incollections', 'hw_info', 'hw_inscoll', 'hw_insdoc',
						'hw_insertdocument', 'hw_insertobject', 'hw_mapid', 'hw_modifyobject',
						'hw_mv', 'hw_new_document', 'hw_objrec2array', 'hw_outputdocument',
						'hw_pconnect', 'hw_pipedocument', 'hw_root', 'hw_unlock',
						'hw_who', 'ibase_bind', 'ibase_close', 'ibase_connect',
						'ibase_execute', 'ibase_fetch_row', 'ibase_free_query',
						'ibase_free_result', 'ibase_pconnect', 'ibase_prepare',
						'ibase_query', 'ibase_timefmt', 'icap_close', 'icap_delete_event',
						'icap_fetch_event', 'icap_list_alarms', 'icap_list_events',
						'icap_open', 'icap_snooze', 'icap_store_event', 'ifx_affected_rows',
						'ifx_blobinfile_mode', 'ifx_byteasvarchar', 'ifx_close',
						'ifx_connect', 'ifx_copy_blob', 'ifx_create_blob', 'ifx_create_char',
						'ifx_do', 'ifx_error', 'ifx_errormsg', 'ifx_fetch_row',
						'ifx_fieldproperties', 'ifx_fieldtypes', 'ifx_free_blob',
						'ifx_free_char', 'ifx_free_result', 'ifx_get_blob', 'ifx_get_char',
						'ifx_getsqlca', 'ifx_htmltbl_result', 'ifx_nullformat',
						'ifx_num_fields', 'ifx_num_rows', 'ifx_pconnect', 'ifx_prepare',
						'ifx_query', 'ifx_textasvarchar', 'ifx_update_blob',
						'ifx_update_char', 'ifxus_close_slob', 'ifxus_create_slob',
						'ifxus_free_slob', 'ifxus_open_slob', 'ifxus_read_slob',
						'ifxus_seek_slob', 'ifxus_tell_slob', 'ifxus_write_slob',
						'ignore_user_abort', 'imagearc', 'imagechar', 'imagecharup',
						'imagecolorallocate', 'imagecolorat', 'imagecolorclosest',
						'imagecolorexact', 'imagecolorresolve', 'imagecolorset',
						'imagecolorsforindex', 'imagecolorstotal', 'imagecolortransparent',
						'imagecopyresized', 'imagecreate', 'imagecreatefromgif',
						'imagedashedline', 'imagedestroy', 'imagefill', 'imagefilledpolygon',
						'imagefilledrectangle', 'imagefilltoborder', 'imagefontheight',
						'imagefontwidth', 'imagegif', 'imageinterlace', 'imageline',
						'imageloadfont', 'imagepolygon', 'imagepsbbox', 'imagepsencodefont',
						'imagepsfreefont', 'imagepsloadfont', 'imagepstext', 'imagerectangle',
						'imagesetpixel', 'imagestring', 'imagestringup', 'imagesx',
						'imagesy', 'imagettfbbox', 'imagettftext', 'imap_8bit',
						'imap_alerts', 'imap_append', 'imap_base64', 'imap_binary',
						'imap_body', 'imap_check', 'imap_clearflag_full', 'imap_close',
						'imap_createmailbox', 'imap_delete', 'imap_deletemailbox',
						'imap_errors', 'imap_expunge', 'imap_fetchbody', 'imap_fetchheader',
						'imap_fetchstructure', 'imap_getmailboxes', 'imap_getsubscribed',
						'imap_header', 'imap_headers', 'imap_last_error', 'imap_listmailbox',
						'imap_listsubscribed', 'imap_mail_copy', 'imap_mail_move',
						'imap_mailboxmsginfo', 'imap_msgno', 'imap_num_msg',
						'imap_num_recent', 'imap_open', 'imap_ping', 'imap_qprint',
						'imap_renamemailbox', 'imap_reopen', 'imap_rfc822_parse_adrlist',
						'imap_rfc822_write_address', 'imap_scanmailbox', 'imap_search',
						'imap_setflag_full', 'imap_sort', 'imap_status', 'imap_subscribe',
						'imap_uid', 'imap_undelete', 'imap_unsubscribe', 'implode',
						'in_array', 'intval', 'iptcparse', 'is_array', 'is_dir',
						'is_double', 'is_executable', 'is_file', 'is_float', 'is_int',
						'is_integer', 'is_link', 'is_long', 'is_object', 'is_readable',
						'is_real', 'is_string', 'is_writeable', 'isset', 'jddayofweek',
						'jdmonthname', 'jdtofrench', 'jdtogregorian', 'jdtojewish',
						'jdtojulian', 'jewishtojd', 'join', 'juliantojd', 'key',
						'krsort', 'ksort', 'ldap_add', 'ldap_bind', 'ldap_close',
						'ldap_connect', 'ldap_count_entries', 'ldap_delete',
						'ldap_dn2ufn', 'ldap_err2str', 'ldap_errno', 'ldap_error',
						'ldap_explode_dn', 'ldap_first_attribute', 'ldap_first_entry',
						'ldap_free_result', 'ldap_get_attributes', 'ldap_get_dn',
						'ldap_get_entries', 'ldap_get_values', 'ldap_get_values_len',
						'ldap_list', 'ldap_mod_add', 'ldap_mod_del', 'ldap_mod_replace',
						'ldap_modify', 'ldap_next_attribute', 'ldap_next_entry',
						'ldap_read', 'ldap_search', 'ldap_unbind', 'leak', 'link',
						'linkinfo', 'list','log', 'log10', 'lstat', 'ltrim', 'mail',
						'max', 'mcal_close', 'mcal_date_compare', 'mcal_date_valid',
						'mcal_day_of_week', 'mcal_day_of_year', 'mcal_days_in_month',
						'mcal_delete_event', 'mcal_event_init', 'mcal_event_set_alarm',
						'mcal_event_set_category', 'mcal_event_set_class', 'mcal_event_set_description',
						'mcal_event_set_end', 'mcal_event_set_recur_daily', 'mcal_event_set_recur_monthly_mday',
						'mcal_event_set_recur_monthly_wday', 'mcal_event_set_recur_weekly',
						'mcal_event_set_recur_yearly', 'mcal_event_set_start',
						'mcal_event_set_title', 'mcal_fetch_current_stream_event',
						'mcal_fetch_event', 'mcal_is_leap_year', 'mcal_list_alarms',
						'mcal_list_events', 'mcal_next_recurrence', 'mcal_open',
						'mcal_snooze', 'mcal_store_event', 'mcal_time_valid', 'mcrypt_cbc',
						'mcrypt_cfb', 'mcrypt_create_iv', 'mcrypt_ecb', 'mcrypt_get_block_size',
						'mcrypt_get_cipher_name', 'mcrypt_get_key_size', 'mcrypt_ofb',
						'md5', 'metaphone', 'mhash', 'mhash_count', 'mhash_get_block_size',
						'mhash_get_hash_name', 'microtime', 'min', 'mkdir', 'mktime',
						'msql', 'msql_affected_rows', 'msql_close', 'msql_connect',
						'msql_create_db', 'msql_createdb', 'msql_data_seek', 'msql_dbname',
						'msql_drop_db', 'msql_dropdb', 'msql_error', 'msql_fetch_array',
						'msql_fetch_field', 'msql_fetch_object','msql_fetch_row',
						'msql_field_seek', 'msql_fieldflags', 'msql_fieldlen', 'msql_fieldname',
						'msql_fieldtable', 'msql_fieldtype', 'msql_free_result',
						'msql_freeresult', 'msql_list_dbs', 'msql_list_fields',
						'msql_list_tables', 'msql_listdbs', 'msql_listfields',
						'msql_listtables', 'msql_num_fields', 'msql_num_rows',
						'msql_numfields', 'msql_numrows', 'msql_pconnect', 'msql_query',
						'msql_regcase', 'msql_result', 'msql_select_db', 'msql_selectdb',
						'msql_tablename', 'mssql_affected_rows', 'mssql_close', 'mssql_connect',
						'mssql_data_seek', 'mssql_fetch_array', 'mssql_fetch_field',
						'mssql_fetch_object', 'mssql_fetch_row', 'mssql_field_seek',
						'mssql_free_result', 'mssql_num_fields', 'mssql_num_rows',
						'mssql_pconnect', 'mssql_query', 'mssql_result', 'mssql_select_db',
						'mt_getrandmax', 'mt_rand', 'mt_srand', 'mysql_affected_rows',
						'mysql_change_user', 'mysql_close', 'mysql_connect', 'mysql_create_db',
						'mysql_data_seek', 'mysql_db_query', 'mysql_drop_db', 'mysql_errno',
						'mysql_error','mysql_fetch_array', 'mysql_fetch_field',
						'mysql_fetch_lengths', 'mysql_fetch_object', 'mysql_fetch_row','mysql_field_flags', 'mysql_field_len', 'mysql_field_name', 'mysql_field_seek', 'mysql_field_table', 'mysql_field_type', 'mysql_free_result', 'mysql_insert_id', 'mysql_list_dbs', 'mysql_list_fields', 'mysql_list_tables','mysql_num_fields', 'mysql_num_rows', 'mysql_pconnect', 'mysql_query', 'mysql_result', 'mysql_select_db', 'mysql_tablename', 'next', 'nl2br', 'number_format', 'ocibindbyname', 'ocicolumnisnull','ocicolumnname', 'ocicolumnsize', 'ocicolumntype', 'ocicommit', 'ocidefinebyname', 'ocierror','ociexecute', 'ocifetch', 'ocifetchinto', 'ocifetchstatement', 'ocifreecursor', 'ocifreestatement', 'ociinternaldebug', 'ocilogoff', 'ocilogon', 'ocinewcursor', 'ocinewdescriptor', 'ocinlogon', 'ocinumcols', 'ocinumrows', 'ociparse', 'ociplogon', 'ociresult', 'ocirollback', 'ocirowcount', 'ociserverversion', 'ocistatementtype', 'octdec', 'odbc_autocommit', 'odbc_binmode', 'odbc_close', 'odbc_close_all', 'odbc_commit', 'odbc_connect', 'odbc_cursor', 'odbc_do', 'odbc_exec', 'odbc_execute', 'odbc_fetch_into', 'odbc_fetch_row', 'odbc_field_len', 'odbc_field_name', 'odbc_field_type', 'odbc_free_result', 'odbc_longreadlen', 'odbc_num_fields', 'odbc_num_rows', 'odbc_pconnect', 'odbc_prepare', 'odbc_result', 'odbc_result_all', 'odbc_rollback', 'odbc_setoption', 'opendir', 'openlog', 'ora_bind', 'ora_close', 'ora_columnname', 'ora_columntype', 'ora_commit', 'ora_commitoff', 'ora_commiton', 'ora_error', 'ora_errorcode', 'ora_exec', 'ora_fetch', 'ora_getcolumn', 'ora_logoff', 'ora_logon', 'ora_open', 'ora_parse', 'ora_rollback', 'ord', 'pack', 'parse_str', 'parse_url', 'passthru', 'pclose', 'pdf_add_annotation', 'pdf_add_outline', 'pdf_arc', 'pdf_begin_page', 'pdf_circle', 'pdf_clip', 'pdf_close', 'pdf_close_image', 'pdf_closepath', 'pdf_closepath_fill_stroke', 'pdf_closepath_stroke', 'pdf_continue_text', 'pdf_curveto', 'pdf_end_page', 'pdf_endpath', 'pdf_execute_image', 'pdf_fill', 'pdf_fill_stroke', 'pdf_get_info', 'pdf_lineto', 'pdf_moveto', 'pdf_open', 'pdf_open_gif', 'pdf_open_jpeg', 'pdf_open_memory_image', 'pdf_place_image', 'pdf_put_image', 'pdf_rect', 'pdf_restore', 'pdf_rotate', 'pdf_save', 'pdf_scale', 'pdf_set_char_spacing', 'pdf_set_duration', 'pdf_set_font', 'pdf_set_horiz_scaling', 'pdf_set_info_author', 'pdf_set_info_creator', 'pdf_set_info_keywords', 'pdf_set_info_subject', 'pdf_set_info_title', 'pdf_set_leading', 'pdf_set_text_matrix', 'pdf_set_text_pos', 'pdf_set_text_rendering', 'pdf_set_text_rise', 'pdf_set_transition', 'pdf_set_word_spacing', 'pdf_setdash', 'pdf_setflat', 'pdf_setgray', 'pdf_setgray_fill', 'pdf_setgray_stroke', 'pdf_setlinecap', 'pdf_setlinejoin', 'pdf_setlinewidth', 'pdf_setmiterlimit', 'pdf_setrgbcolor', 'pdf_setrgbcolor_fill', 'pdf_setrgbcolor_stroke', 'pdf_show', 'pdf_show_xy', 'pdf_stringwidth', 'pdf_stroke', 'pdf_translate', 'pfsockopen', 'pg_close', 'pg_cmdtuples', 'pg_connect', 'pg_dbname', 'pg_errormessage', 'pg_exec', 'pg_fetch_array', 'pg_fetch_object', 'pg_fetch_row', 'pg_fieldisnull', 'pg_fieldname', 'pg_fieldnum', 'pg_fieldprtlen', 'pg_fieldsize', 'pg_fieldtype', 'pg_freeresult', 'pg_getlastoid', 'pg_host', 'pg_loclose', 'pg_locreate', 'pg_loopen', 'pg_loread', 'pg_loreadall', 'pg_lounlink', 'pg_lowrite', 'pg_numfields', 'pg_numrows', 'pg_options', 'pg_pconnect', 'pg_port', 'pg_result', 'pg_tty', 'phpinfo', 'phpversion', 'pi', 'popen', 'pos', 'posix_ctermid', 'posix_getcwd', 'posix_getegid', 'posix_geteuid', 'posix_getgid', 'posix_getgrgid', 'posix_getgrnam', 'posix_getgroups', 'posix_getlogin', 'posix_getpgid', 'posix_getpgrp', 'posix_getpid', 'posix_getppid', 'posix_getpwnam', 'posix_getpwuid', 'posix_getrlimit', 'posix_getsid', 'posix_getuid', 'posix_isatty', 'posix_kill', 'posix_mkfifo', 'posix_setgid', 'posix_setpgid', 'posix_setsid', 'posix_setuid', 'posix_times', 'posix_ttyname', 'posix_uname', 'pow', 'preg_grep', 'preg_match', 'preg_match_all', 'preg_quote', 'preg_replace', 'preg_split', 'prev', 'print', 'printf', 'putenv', 'quoted_printable_decode', 'quotemeta', 'rand', 'range', 'rawurldecode', 'rawurlencode', 'readdir', 'readfile', 'readgzfile', 'readlink', 'recode_file', 'recode_string', 'register_shutdown_function', 'rename', 'reset', 'rewind', 'rewinddir', 'rmdir', 'round', 'rsort', 'sem_acquire', 'sem_get', 'sem_release', 'serialize', 'session_decode', 'session_destroy', 'session_encode', 'session_id', 'session_is_registered', 'session_module_name', 'session_name', 'session_register', 'session_save_path', 'session_start', 'session_unregister', 'set_file_buffer', 'set_magic_quotes_runtime', 'set_socket_blocking', 'set_time_limit', 'setcookie', 'setlocale', 'settype', 'shm_attach', 'shm_detach', 'shm_get_var', 'shm_put_var', 'shm_remove', 'shm_remove_var', 'shuffle', 'similar_text', 'sin', 'sizeof', 'sleep', 'snmp_get_quick_print', 'snmp_set_quick_print', 'snmpget', 'snmpset', 'snmpwalk', 'snmpwalkoid', 'solid_close', 'solid_connect', 'solid_exec', 'solid_fetchrow', 'solid_fieldname', 'solid_fieldnum', 'solid_freeresult', 'solid_numfields', 'solid_numrows', 'solid_result', 'sort', 'soundex', 'split', 'sprintf', 'sql_regcase', 'sqrt', 'srand', 'stat', 'str_repeat', 'str_replace', 'strcasecmp', 'strchr', 'strcmp', 'strcspn', 'strftime', 'strip_tags', 'stripcslashes', 'stripslashes', 'stristr', 'strlen', 'strpos', 'strrchr', 'strrev', 'strrpos', 'strspn', 'strstr', 'strtok', 'strtolower', 'strtoupper', 'strtr', 'strval', 'substr', 'substr_replace', 'sybase_affected_rows', 'sybase_close', 'sybase_connect', 'sybase_data_seek', 'sybase_fetch_array', 'sybase_fetch_field', 'sybase_fetch_object', 'sybase_fetch_row', 'sybase_field_seek', 'sybase_free_result', 'sybase_num_fields', 'sybase_num_rows', 'sybase_pconnect', 'sybase_query', 'sybase_result', 'sybase_select_db', 'symlink', 'syslog', 'system', 'tan', 'tempnam', 'time', 'touch', 'trim', 'uasort', 'ucfirst', 'ucwords', 'uksort', 'umask', 'uniqid', 'unlink', 'unpack', 'unserialize', 'unset', 'urldecode', 'urlencode', 'usleep', 'usort', 'utf8_decode', 'utf8_encode', 'virtual', 'vm_addalias', 'vm_adduser', 'vm_delalias', 'vm_deluser', 'vm_passwd', 'wddx_add_vars', 'wddx_deserialize', 'wddx_packet_end', 'wddx_packet_start', 'wddx_serialize_value', 'wddx_serialize_vars', 'xml_error_string', 'xml_get_current_byte_index', 'xml_get_current_column_number', 'xml_get_current_line_number', 'xml_get_error_code', 'xml_parse', 'xml_parser_create', 'xml_parser_free', 'xml_parser_get_option', 'xml_parser_set_option', 'xml_set_character_data_handler', 'xml_set_default_handler', 'xml_set_element_handler', 'xml_set_external_entity_ref_handler', 'xml_set_notation_decl_handler', 'xml_set_object', 'xml_set_processing_instruction_handler', 'xml_set_unparsed_entity_decl_handler', 'yp_err_string', 'yp_errno', 'yp_first', 'yp_get_default_domain', 'yp_master', 'yp_match', 'yp_next', 'yp_order', 'odbc_field_num', 'undefine', 'mysql', 'mysql_fieldflags', 'mysql_fieldlen', 'mysql_fieldtable', 'mysql_freeresult', 'mysql_listdbs', 'mysql_listfields', 'mysql_listtables', 'mysql_numfields', 'mysql_numrows', 'tmpfile'
	// PHP Operator
	PHP_OPERATOR	is	'and', 'or', 'xor', 'not'
	// PHP Reserved
	PHP_RESERVED	is	'if', 'else', 'elseif', 'while', 'do', 'for', 'break',
						'continue', 'switch', 'require', 'include', 'function',
						'return', 'old_function', 'class', 'static', 'new', 'var',
						'float', 'double', 'integer', 'real', 'string',
						'object', 'extends', 'endif', 'endwhile', 'global', 'case',
						'default', 'endfor', 'enddo', 'endswitch', 'echo', 'exit'
)

%%tokens
InState IN_PHP_DEFAULT (
	PHP_DEFAULT			NOT_ALPHA			DONT_CARE?				DONT_CARE			_discard_
	PHP_IDENTIFIER		ID_START			ID_CONTAINS?			NOT_ID_CONTAINS		_discard_
	PHP_NUMBER			NUM_START			NUM_CONTAINS?			NOT_NUM_CONTAINS	_discard_
)

InState IN_PHP_COMMENT_LINE (
	PHP_COMMENT			DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_COMMENT_STAR (
	PHP_COMMENT			DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_EXECSTRING (
	PHP_EXECSTRING		DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_STRING (
	PHP_STRING			'[^"\\]'			DONT_CARE?				DONT_CARE			_discard_
	PHP_STRING			'\\'				DONT_CARE				DONT_CARE			_discard_
)

InState IN_PHP_STRING_SQ (
	PHP_STRING			'[^\'\\]'			DONT_CARE?				DONT_CARE			_discard_
	PHP_STRING			'\\'				DONT_CARE				DONT_CARE			_discard_
)

// Script Support
InState IN_PHP_SCRIPT_START (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_PHP_SCRIPT_STOP (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
PHP_START				push (-ALL_STATES						+[IN_PHP_DEFAULT])
PHP_STOP				pop ()

PHP_COMMENT_LINE_START	(+[IN_PHP_COMMENT_LINE]					-[IN_PHP_DEFAULT])
PHP_COMMENT_LINE_STOP	(-[IN_PHP_COMMENT_LINE]					+[IN_PHP_DEFAULT])

PHP_COMMENT_STAR_START	(+[IN_PHP_COMMENT_STAR]					-[IN_PHP_DEFAULT])
PHP_COMMENT_STAR_STOP	(-[IN_PHP_COMMENT_STAR]					+[IN_PHP_DEFAULT])

PHP_EXECSTRING_START	(+[IN_PHP_EXECSTRING]					-[IN_PHP_DEFAULT])
PHP_EXECSTRING_STOP		(-[IN_PHP_EXECSTRING]					+[IN_PHP_DEFAULT])

PHP_STRING_START		(+[IN_PHP_STRING]						-[IN_PHP_DEFAULT])
PHP_STRING_STOP			(-[IN_PHP_STRING]						+[IN_PHP_DEFAULT])

PHP_STRING_SQ_START		(+[IN_PHP_STRING_SQ]					-[IN_PHP_DEFAULT])
PHP_STRING_SQ_STOP		(-[IN_PHP_STRING_SQ]					+[IN_PHP_DEFAULT])

// Script support
SCRIPT_PHP_START		(-[IN_HTML_SCRIPT_START] +[IN_PHP_SCRIPT_START])
PHP_SCRIPT_START_STOP	(-[IN_PHP_SCRIPT_START] +[IN_PHP_DEFAULT])

PHP_SCRIPT_STOP_START 	(-[IN_PHP_DEFAULT] +[IN_PHP_SCRIPT_STOP])
PHP_SCRIPT_STOP_STOP	(-[IN_PHP_SCRIPT_STOP] +[IN_DEFAULT])

%%effects
PHP_DEFAULT				[]					clBlack				clLtSilver
PHP						[]					clRed				clLtSilver
PHP_COMMENT				[]					clGreen				clLtSilver
PHP_IDENTIFIER			[]					clBlack				clLtSilver
PHP_NUMBER				[]					clGreen				clLtSilver
PHP_RESERVED			[fsBold]			clBlue				clLtSilver
PHP_FUNCTION			[fsBold]			clNavy				clLtSilver
PHP_VARIABLE			[fsBold]			clBlack				clLtSilver
PHP_EXECSTRING			[fsBold]			clTeal				clLtSilver
PHP_OPERATOR			[fsBold]			clNavy				clLtSilver
PHP_STRING				[]					clTeal				clLtSilver
PHP_CONSTANT			[]					clBlue				clLtSilver
PHP_THIS				[fsBold]			clBlack				clLtSilver
PHP_SEPARATOR			[fsBold]			clBlack				clLtSilver

%%map
PHP_DEFAULT				PHP_DEFAULT
PHP						PHP
PHP_START				PHP
PHP_STOP				PHP
PHP_FUNCTION			PHP_FUNCTION
PHP_IDENTIFIER			PHP_IDENTIFIER
PHP_NUMBER				PHP_NUMBER
PHP_COMMENT				PHP_COMMENT
PHP_COMMENT_LINE_START	PHP_COMMENT
PHP_COMMENT_LINE_STOP	PHP_COMMENT
PHP_COMMENT_STAR_START	PHP_COMMENT
PHP_COMMENT_STAR_STOP	PHP_COMMENT
PHP_RESERVED			PHP_RESERVED
PHP_VARIABLE			PHP_VARIABLE
PHP_EXECSTRING			PHP_EXECSTRING
PHP_EXECSTRING_START	PHP_EXECSTRING
PHP_EXECSTRING_STOP		PHP_EXECSTRING
PHP_OPERATOR			PHP_OPERATOR
PHP_STRING				PHP_STRING
PHP_STRING_START		PHP_STRING
PHP_STRING_STOP			PHP_STRING
PHP_STRING_SQ_START		PHP_STRING
PHP_STRING_SQ_STOP		PHP_STRING
PHP_CONSTANT			PHP_CONSTANT
PHP_THIS				PHP_THIS
PHP_SEPARATOR			PHP_SEPARATOR
// Script support
SCRIPT_PHP_START		HTML_SCRIPT
PHP_SCRIPT_START_STOP	HTML_SCRIPT
PHP_SCRIPT_STOP_START	HTML_SCRIPT
PHP_SCRIPT_STOP_STOP	HTML_SCRIPT