/******************************************************************************
	PHP Color Coding Script Extension
	by B. Collier Jones
	Version 4.5.1
	
	Special Thanks to Marjolein Katsma for input and testing.
	
	Current Version Revision History:
	01/22/2000 - Rewritten from HTML+PHP 4.0 Beta
			   - Isolated PHP information into separate file to work with
				 new embedded languages support in TSyntaxMemo 4.0 for
				 HomeSite 4.5.1
	08/09/2000 - Added support for PHP inside of script blocks detected by
				 language attribute
	08/10/2000 - Added type="text/php" attribute detection
******************************************************************************/
// Elements
#define PHP_BASE					SERVER_SIDE_SCRIPT_BASE
#define PHP_DEFAULT					PHP_BASE + 0
#define PHP							PHP_BASE + 1
#define PHP_START					PHP_BASE + 2
#define PHP_STOP					PHP_BASE + 3
#define PHP_IDENTIFIER				PHP_BASE + 4
#define PHP_NUMBER					PHP_BASE + 5
#define PHP_COMMENT					PHP_BASE + 6
#define PHP_COMMENT_LINE_START		PHP_BASE + 7
#define PHP_COMMENT_LINE_STOP		PHP_BASE + 8
#define PHP_COMMENT_STAR_START		PHP_BASE + 9
#define PHP_COMMENT_STAR_STOP		PHP_BASE + 10
#define PHP_RESERVED				PHP_BASE + 11
#define PHP_FUNCTION				PHP_BASE + 12
#define PHP_VARIABLE				PHP_BASE + 13
#define PHP_CONSTANT				PHP_BASE + 14
#define PHP_EXECSTRING				PHP_BASE + 15
#define PHP_EXECSTRING_START		PHP_BASE + 16
#define PHP_EXECSTRING_STOP			PHP_BASE + 17
#define PHP_OPERATOR				PHP_BASE + 18
#define PHP_STRING					PHP_BASE + 19
#define PHP_STRING_START			PHP_BASE + 20
#define PHP_STRING_STOP				PHP_BASE + 21
#define PHP_STRING_SQ_START			PHP_BASE + 22
#define PHP_STRING_SQ_STOP			PHP_BASE + 23
#define PHP_THIS					PHP_BASE + 24
#define PHP_SEPARATOR				PHP_BASE + 25
// Script support
#define SCRIPT_PHP_START			PHP_BASE + 26
#define PHP_SCRIPT_START_STOP		PHP_BASE + 27
#define PHP_SCRIPT_STOP_START		PHP_BASE + 28
#define PHP_SCRIPT_STOP_STOP		PHP_BASE + 29

// States
#define IN_PHP_DEFAULT				PHP_BASE + 0
#define IN_PHP_COMMENT_LINE			PHP_BASE + 1
#define IN_PHP_COMMENT_STAR			PHP_BASE + 2
#define IN_PHP_STRING				PHP_BASE + 3
#define IN_PHP_STRING_SQ			PHP_BASE + 4
#define IN_PHP_EXECSTRING			PHP_BASE + 5
// Script support
#define IN_PHP_SCRIPT_START			PHP_BASE + 6
#define IN_PHP_SCRIPT_STOP			PHP_BASE + 7

// States where ASP can be found
#define PHP_STATES					IN_DEFAULT HTML_ATTRIBUTE_BASE..STYLE_SHEET_MAX

%%language
//Anchor							+=	[PHP_START]
// 1105
BoundStates						+=	[IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR IN_PHP_EXECSTRING IN_PHP_STRING IN_PHP_STRING_SQ]
EditableStyles						('PHP Delimiters'				, PHP),
									('PHP Default'					, PHP_DEFAULT),
									('PHP Comments'					, PHP_COMMENT),
									('PHP Identifiers'				, PHP_IDENTIFIER),
									('PHP Numbers'					, PHP_NUMBER),
									('PHP Reserved Words'			, PHP_RESERVED),
									('PHP Functions'				, PHP_FUNCTION),
									('PHP Variables'				, PHP_VARIABLE),
									('PHP Constants'				, PHP_CONSTANT),
									('PHP Shell Commands'			, PHP_EXECSTRING),
									('PHP Operators'				, PHP_OPERATOR),
									('PHP Strings'					, PHP_STRING),
									('PHP This'						, PHP_THIS),
									('PHP Separators'				, PHP_SEPARATOR)
																		
ExampleText						+=	'------- PHP -------\n\
									\<?php\n\
									\     $size = GetImageSize("testimg.jpg",&$info);\n\
									\     if (isset($info["APP13"])) {\n\
									\          $iptc = iptcparse($info["APP13"]);\n\
									\          var_dump($iptc);\n\
									\     }\n\
									\?>'
									
%%TriggerContexts
On PHP_START SeekTo	(PHP_DEFAULT [IN_PHP_DEFAULT])

%%words
// <SCRIPT> support
'language="php"'		DONT_CARE			SCRIPT_PHP_START		[IN_HTML_SCRIPT_START]
'type="text/php"'		DONT_CARE			SCRIPT_PHP_START		[IN_HTML_SCRIPT_START]
'>'						DONT_CARE			PHP_SCRIPT_START_STOP	[IN_PHP_SCRIPT_START]
'</script'				NOT_ALPHA			PHP_SCRIPT_STOP_START	[IN_PHP_DEFAULT]
'>'						DONT_CARE			PHP_SCRIPT_STOP_STOP	[IN_PHP_SCRIPT_STOP]
// PHP
'<?'					DONT_CARE			PHP_START				[PHP_STATES]
'<?php'					DONT_CARE			PHP_START				[PHP_STATES]
'?>'					DONT_CARE			PHP_STOP				[IN_PHP_DEFAULT IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR]
'<%'					DONT_CARE			PHP_START				[PHP_STATES]
'<%='					DONT_CARE			PHP_START				[PHP_STATES]
'%>'					DONT_CARE			PHP_STOP				[IN_PHP_DEFAULT IN_PHP_COMMENT_LINE IN_PHP_COMMENT_STAR]
// PHP Comments
'#'						DONT_CARE			PHP_COMMENT_LINE_START	[IN_PHP_DEFAULT]
'\/\/'					DONT_CARE			PHP_COMMENT_LINE_START	[IN_PHP_DEFAULT]
'\n'					DONT_CARE			PHP_COMMENT_LINE_STOP	[IN_PHP_COMMENT_LINE]
'\/*'					DONT_CARE			PHP_COMMENT_STAR_START	[IN_PHP_DEFAULT]
'*\/'					DONT_CARE			PHP_COMMENT_STAR_STOP	[IN_PHP_COMMENT_STAR]
// PHP Operator
'.'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'+'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'-'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'*'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'/'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'%'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'<'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'>'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'='						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'!'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'?'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
':'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'|'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'&'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'~'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'^'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
'@'						DONT_CARE			PHP_OPERATOR			[IN_PHP_DEFAULT]
// PHP separators
','						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
';'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'('						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
')'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'['						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
']'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'{'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
'}'						DONT_CARE			PHP_SEPARATOR			[IN_PHP_DEFAULT]
// PHP This
'$this'					NOT_ALPHA			PHP_THIS				[IN_PHP_DEFAULT]
// PHP Variable
'$'						'[A-Za-z_${]'		PHP_VARIABLE			[IN_PHP_DEFAULT]
//'$$'					ALPHA				PHP_VARIABLE			[IN_PHP_DEFAULT]
// PHP Execution String
'`'						DONT_CARE			PHP_EXECSTRING_START	[IN_PHP_DEFAULT]
'`'						DONT_CARE			PHP_EXECSTRING_STOP		[IN_PHP_EXECSTRING]
// PHP String
'"'						DONT_CARE			PHP_STRING_START		[IN_PHP_DEFAULT]
'"'						DONT_CARE			PHP_STRING_STOP			[IN_PHP_STRING]
'\''					DONT_CARE			PHP_STRING_SQ_START		[IN_PHP_DEFAULT]
'\''					DONT_CARE			PHP_STRING_SQ_STOP		[IN_PHP_STRING_SQ]

%%handlers
PHP_VARIABLE			'[A-Za-z0-9_$]'?			'[^A-Za-z0-9_]'				_discard_

%%kwtables
// 1192
ForState [IN_PHP_DEFAULT] endswith NOT_ALPHA (
	// PHP Constant
	PHP_CONSTANT	is	'__FILE__', '__LINE__', 'PHP_VERSION', 'PHP_OS', 'TRUE', 'FALSE',
						'E_ERROR', 'E_WARNING', 'E_PARSE', 'E_NOTICE', 'M_PI'
	// PHP Function
	PHP_FUNCTION	is	'abs', 'accept_connect', 'acos', 'addcslashes', 'addslashes', 'apache_lookup_uri', 'apache_note', 'array', 'array_count_values', 'array_diff', 'array_filter', 'array_flip', 'array_intersect', 'array_keys', 'array_map', 'array_merge', 'array_merge_recursive', 'array_multisort', 'array_pad', 'array_pop', 'array_push', 'array_rand', 'array_reduce', 'array_reverse', 'array_search', 'array_shift', 'array_slice', 'array_splice', 'array_sum', 'array_unique', 'array_unshift', 'array_values', 'array_walk', 'arsort', 'ascii2ebcdic', 'asin', 'asort', 'aspell_check', 'aspell_check_raw', 'aspell_new', 'aspell_suggest', 'assert', 'assert_options', 'atan', 'atan2', 'base64_decode', 'base64_encode', 'base_convert', 'basename', 'bcadd', 'bccomp', 'bcdiv', 'bcmod', 'bcmul', 'bcpow', 'bcscale', 'bcsqrt', 'bcsub', 'bin2hex', 'bind', 'bindec', 'bindtextdomain', 'bzclose', 'bzcompress', 'bzdecompress', 'bzerrno', 'bzerror', 'bzerrstr', 'bzflush', 'bzopen', 'bzread', 'bzwrite', 'call_user_func', 'call_user_func_array', 'call_user_method', 'call_user_method_array', 'ceil', 'chdir', 'checkdate', 'checkdnsrr', 'chgrp', 'chmod', 'chop', 'chown', 'chr', 'chroot', 'chunk_split', 'class_exists', 'clearstatcache', 'close', 'closedir', 'closelog', 'com', 'com_addref', 'com_get', 'com_invoke', 'com_load', 'com_propget', 'com_propput', 'com_propset', 'com_release', 'com_set', 'compact', 'connect', 'connection_aborted', 'connection_status', 'connection_timeout', 'constant', 'convert_cyr_string', 'copy', 'cos', 'count', 'count_chars', 'cpdf_add_annotation', 'cpdf_add_outline', 'cpdf_arc', 'cpdf_begin_text', 'cpdf_circle', 'cpdf_clip', 'cpdf_close', 'cpdf_closepath', 'cpdf_closepath_fill_stroke', 'cpdf_closepath_stroke', 'cpdf_continue_text', 'cpdf_curveto', 'cpdf_end_text', 'cpdf_fill', 'cpdf_fill_stroke', 'cpdf_finalize', 'cpdf_finalize_page', 'cpdf_global_set_document_limits', 'cpdf_import_jpeg', 'cpdf_lineto', 'cpdf_moveto', 'cpdf_newpath', 'cpdf_open', 'cpdf_output_buffer', 'cpdf_page_init', 'cpdf_place_inline_image', 'cpdf_rect', 'cpdf_restore', 'cpdf_rlineto', 'cpdf_rmoveto', 'cpdf_rotate', 'cpdf_save', 'cpdf_save_to_file', 'cpdf_scale', 'cpdf_set_char_spacing', 'cpdf_set_creator', 'cpdf_set_current_page', 'cpdf_set_font', 'cpdf_set_horiz_scaling', 'cpdf_set_keywords', 'cpdf_set_leading', 'cpdf_set_page_animation', 'cpdf_set_subject', 'cpdf_set_text_matrix', 'cpdf_set_text_pos', 'cpdf_set_text_rendering', 'cpdf_set_text_rise', 'cpdf_set_title', 'cpdf_set_word_spacing', 'cpdf_setdash', 'cpdf_setflat', 'cpdf_setgray', 'cpdf_setgray_fill', 'cpdf_setgray_stroke', 'cpdf_setlinecap', 'cpdf_setlinejoin', 'cpdf_setlinewidth', 'cpdf_setmiterlimit', 'cpdf_setrgbcolor', 'cpdf_setrgbcolor_fill', 'cpdf_setrgbcolor_stroke', 'cpdf_show', 'cpdf_show_xy', 'cpdf_stringwidth', 'cpdf_stroke', 'cpdf_text', 'cpdf_translate', 'crc32', 'create_function', 'crypt', 'ctype_alnum', 'ctype_alpha', 'ctype_cntrl', 'ctype_digit', 'ctype_graph', 'ctype_lower', 'ctype_print', 'ctype_punct', 'ctype_space', 'ctype_upper', 'ctype_xdigit', 'curl_close', 'curl_exec', 'curl_init', 'curl_setopt', 'curl_version', 'current', 'cybercash_base64_decode', 'cybercash_base64_encode', 'cybercash_decr', 'cybercash_encr', 'cybermut_creerformulairecm', 'cybermut_creerreponsecm', 'cybermut_testmac', 'date', 'dba_close', 'dba_delete', 'dba_exists', 'dba_fetch', 'dba_firstkey', 'dba_insert', 'dba_nextkey', 'dba_open', 'dba_optimize', 'dba_popen', 'dba_replace', 'dba_sync', 'dbase_add_record', 'dbase_close', 'dbase_create', 'dbase_delete_record', 'dbase_get_record', 'dbase_get_record_with_names', 'dbase_numfields', 'dbase_numrecords', 'dbase_open', 'dbase_pack', 'dbase_replace_record', 'dblist', 'dbmclose', 'dbmdelete', 'dbmexists', 'dbmfetch', 'dbmfirstkey', 'dbminsert', 'dbmnextkey', 'dbmopen', 'dbmreplace', 'dbx_close', 'dbx_compare', 'dbx_connect', 'dbx_error', 'dbx_query', 'dbx_sort', 'dcgettext', 'debugger_off', 'debugger_on', 'decbin', 'dechex', 'decoct', 'define', 'define_syslog_variables', 'defined', 'deg2rad', 'delete', 'dgettext', 'die', 'dir', 'dirname', 'disk_total_space', 'diskfreespace', 'dl', 'domxml_add_root', 'domxml_attributes', 'domxml_children', 'domxml_dumpmem', 'domxml_get_attribute', 'domxml_new_child', 'domxml_new_xmldoc', 'domxml_root', 'domxml_set_attribute', 'doubleval', 'each', 'easter_date', 'easter_days', 'ebcdic2ascii', 'echo', 'empty', 'end', 'ereg', 'ereg_replace', 'eregi', 'eregi_replace', 'error_log', 'error_reporting', 'escapeshellarg', 'escapeshellcmd', 'eval', 'exec', 'exit', 'exp', 'explode', 'extension_loaded', 'extract', 'ezmlm_hash', 'fbsql_affected_rows', 'fbsql_autocommit', 'fbsql_change_user', 'fbsql_close', 'fbsql_connect', 'fbsql_create_db', 'fbsql_data_seek', 'fbsql_database_password', 'fbsql_db_query', 'fbsql_drop_db', 'fbsql_errno', 'fbsql_error', 'fbsql_fetch_array', 'fbsql_fetch_assoc', 'fbsql_fetch_field', 'fbsql_fetch_lengths', 'fbsql_fetch_object', 'fbsql_fetch_row', 'fbsql_field_flags', 'fbsql_field_len', 'fbsql_field_name', 'fbsql_field_seek', 'fbsql_field_table', 'fbsql_field_type', 'fbsql_free_result', 'fbsql_insert_id', 'fbsql_list_dbs', 'fbsql_list_fields', 'fbsql_list_tables', 'fbsql_next_result', 'fbsql_num_fields', 'fbsql_num_rows', 'fbsql_pconnect', 'fbsql_query', 'fbsql_result', 'fbsql_select_db', 'fbsql_tablename', 'fbsql_warnings', 'fclose', 'fdf_close', 'fdf_create', 'fdf_get_file', 'fdf_get_status', 'fdf_get_value', 'fdf_next_field_name', 'fdf_open', 'fdf_save', 'fdf_set_ap', 'fdf_set_encoding', 'fdf_set_file', 'fdf_set_flags', 'fdf_set_javascript_action', 'fdf_set_opt', 'fdf_set_status', 'fdf_set_submit_form_action', 'fdf_set_value', 'feof', 'fflush', 'fgetc', 'fgetcsv', 'fgets', 'fgetss', 'file', 'file_exists', 'fileatime', 'filectime', 'filegroup', 'fileinode', 'filemtime', 'fileowner', 'fileperms', 'filepro', 'filepro_fieldcount', 'filepro_fieldname', 'filepro_fieldtype', 'filepro_fieldwidth', 'filepro_retrieve', 'filepro_rowcount', 'filesize', 'filetype', 'flock', 'floor', 'flush', 'fopen', 'fpassthru', 'fputs', 'fread', 'frenchtojd', 'fscanf', 'fseek', 'fsockopen', 'fstat', 'ftell', 'ftp_cdup', 'ftp_chdir', 'ftp_connect', 'ftp_delete', 'ftp_fget', 'ftp_fput', 'ftp_get', 'ftp_login', 'ftp_mdtm', 'ftp_mkdir', 'ftp_nlist', 'ftp_pasv', 'ftp_put', 'ftp_pwd', 'ftp_quit', 'ftp_rawlist', 'ftp_rename', 'ftp_rmdir', 'ftp_site', 'ftp_size', 'ftp_systype', 'ftruncate', 'func_get_arg', 'func_get_args', 'func_num_args', 'function_exists', 'fwrite', 'get_browser', 'get_cfg_var', 'get_class', 'get_class_methods', 'get_class_vars', 'get_current_user', 'get_declared_classes', 'get_defined_constants', 'get_defined_functions', 'get_defined_vars', 'get_extension_funcs', 'get_html_translation_table', 'get_included_files', 'get_loaded_extensions', 'get_magic_quotes_gpc', 'get_magic_quotes_runtime', 'get_meta_tags', 'get_object_vars', 'get_parent_class', 'get_required_files', 'get_resource_type', 'getallheaders', 'getcwd', 'getdate', 'getenv', 'gethostbyaddr', 'gethostbyname', 'gethostbynamel', 'getimagesize', 'getlastmod', 'getmxrr', 'getmyinode', 'getmypid', 'getmyuid', 'getprotobyname', 'getprotobynumber', 'getrandmax', 'getrusage', 'getservbyname', 'getservbyport', 'gettext', 'gettimeofday', 'gettype', 'gmdate', 'gmmktime', 'gmp_abs', 'gmp_add', 'gmp_and', 'gmp_clrbit', 'gmp_cmp', 'gmp_div', 'gmp_div_q', 'gmp_div_qr', 'gmp_div_r', 'gmp_divexact', 'gmp_fact', 'gmp_gcd', 'gmp_gcdext', 'gmp_hamdist', 'gmp_init', 'gmp_intval', 'gmp_invert', 'gmp_jacobi', 'gmp_legendre', 'gmp_mod', 'gmp_mul', 'gmp_neg', 'gmp_or', 'gmp_perfect_square', 'gmp_popcount', 'gmp_pow', 'gmp_powm', 'gmp_prob_prime', 'gmp_random', 'gmp_scan0', 'gmp_scan1', 'gmp_setbit', 'gmp_sign', 'gmp_sqrt', 'gmp_sqrtrm', 'gmp_strval', 'gmp_sub', 'gmp_xor', 'gmstrftime', 'gregoriantojd', 'gzclose', 'gzcompress', 'gzdeflate', 'gzencode', 'gzeof', 'gzfile', 'gzgetc', 'gzgets', 'gzgetss', 'gzinflate', 'gzopen', 'gzpassthru', 'gzputs', 'gzread', 'gzrewind', 'gzseek', 'gztell', 'gzuncompress', 'gzwrite', 'header', 'headers_sent', 'hebrev', 'hebrevc', 'hexdec', 'highlight_file', 'highlight_string', 'htmlentities', 'htmlspecialchars', 'hw_array2objrec', 'hw_children', 'hw_childrenobj', 'hw_close', 'hw_connect', 'hw_cp', 'hw_deleteobject', 'hw_docbyanchor', 'hw_docbyanchorobj', 'hw_document_attributes', 'hw_document_bodytag', 'hw_document_content', 'hw_document_setcontent', 'hw_document_size', 'hw_edittext', 'hw_error', 'hw_errormsg', 'hw_free_document', 'hw_getanchors', 'hw_getanchorsobj', 'hw_getandlock', 'hw_getchildcoll', 'hw_getchildcollobj', 'hw_getchilddoccoll', 'hw_getchilddoccollobj', 'hw_getobject', 'hw_getobjectbyquery', 'hw_getobjectbyquerycoll', 'hw_getobjectbyquerycollobj', 'hw_getobjectbyqueryobj', 'hw_getparents', 'hw_getparentsobj', 'hw_getremote', 'hw_getremotechildren', 'hw_getsrcbydestobj', 'hw_gettext', 'hw_getusername', 'hw_identify', 'hw_incollections', 'hw_info', 'hw_inscoll', 'hw_insdoc', 'hw_insertdocument', 'hw_insertobject', 'hw_mapid', 'hw_modifyobject', 'hw_mv', 'hw_new_document', 'hw_objrec2array', 'hw_output_document', 'hw_pconnect', 'hw_pipedocument', 'hw_root', 'hw_unlock', 'hw_who', 'ibase_close', 'ibase_commit', 'ibase_connect', 'ibase_errmsg', 'ibase_execute', 'ibase_fetch_object', 'ibase_fetch_row', 'ibase_field_info', 'ibase_free_query', 'ibase_free_result', 'ibase_num_fields', 'ibase_pconnect', 'ibase_prepare', 'ibase_query', 'ibase_rollback', 'ibase_timefmt', 'ibase_trans', 'icap_close', 'icap_delete_event', 'icap_fetch_event', 'icap_list_alarms', 'icap_list_events', 'icap_open', 'icap_snooze', 'icap_store_event', 'iconv', 'iconv_get_encoding', 'iconv_set_encoding', 'ifx_affected_rows', 'ifx_blobinfile_mode', 'ifx_byteasvarchar', 'ifx_close', 'ifx_connect', 'ifx_copy_blob', 'ifx_create_blob', 'ifx_create_char', 'ifx_do', 'ifx_error', 'ifx_errormsg', 'ifx_fetch_row', 'ifx_fieldproperties', 'ifx_fieldtypes', 'ifx_free_blob', 'ifx_free_char', 'ifx_free_result', 'ifx_get_blob', 'ifx_get_char', 'ifx_getsqlca', 'ifx_htmltbl_result', 'ifx_nullformat', 'ifx_num_fields', 'ifx_num_rows', 'ifx_pconnect', 'ifx_prepare', 'ifx_query', 'ifx_textasvarchar', 'ifx_update_blob', 'ifx_update_char', 'ifxus_close_slob', 'ifxus_create_slob', 'ifxus_free_slob', 'ifxus_open_slob', 'ifxus_read_slob', 'ifxus_seek_slob', 'ifxus_tell_slob', 'ifxus_write_slob', 'ignore_user_abort', 'imagealphablending', 'imagearc', 'imagechar', 'imagecharup', 'imagecolorallocate', 'imagecolorat', 'imagecolorclosest', 'imagecolorclosestalpha', 'imagecolordeallocate', 'imagecolorexact', 'imagecolorexactalpha', 'imagecolorresolve', 'imagecolorresolvealpha', 'imagecolorset', 'imagecolorsforindex', 'imagecolorstotal', 'imagecolortransparent', 'imagecopy', 'imagecopymerge', 'imagecopymergegray', 'imagecopyresampled', 'imagecopyresized', 'imagecreate', 'imagecreatefromgif', 'imagecreatefromjpeg', 'imagecreatefrompng', 'imagecreatefromstring', 'imagecreatefromwbmp', 'imagecreatetruecolor', 'imagedashedline', 'imagedestroy', 'imageellipse', 'imagefill', 'imagefilledarc', 'imagefilledellipse', 'imagefilledpolygon', 'imagefilledrectangle', 'imagefilltoborder', 'imagefontheight', 'imagefontwidth', 'imagegammacorrect', 'imagegif', 'imageinterlace', 'imagejpeg', 'imageline', 'imageloadfont', 'imagepng', 'imagepolygon', 'imagepsbbox', 'imagepsencodefont', 'imagepsextendfont', 'imagepsfreefont', 'imagepsloadfont', 'imagepsslantfont', 'imagepstext', 'imagerectangle', 'imagesetbrush', 'imagesetpixel', 'imagesetstyle', 'imagesetthickness', 'imagesettile', 'imagestring', 'imagestringup', 'imagesx', 'imagesy', 'imagetruecolortopalette', 'imagettfbbox', 'imagettftext', 'imagetypes', 'imagewbmp', 'imap_8bit', 'imap_alerts', 'imap_append', 'imap_base64', 'imap_binary', 'imap_body', 'imap_check', 'imap_clearflag_full', 'imap_close', 'imap_createmailbox', 'imap_delete', 'imap_deletemailbox', 'imap_errors', 'imap_expunge', 'imap_fetch_overview', 'imap_fetchbody', 'imap_fetchheader', 'imap_fetchstructure', 'imap_get_quota', 'imap_getmailboxes', 'imap_getsubscribed', 'imap_header', 'imap_headerinfo', 'imap_headers', 'imap_last_error', 'imap_listmailbox', 'imap_listsubscribed', 'imap_mail', 'imap_mail_compose', 'imap_mail_copy', 'imap_mail_move', 'imap_mailboxmsginfo', 'imap_mime_header_decode', 'imap_msgno', 'imap_num_msg', 'imap_num_recent', 'imap_open', 'imap_ping', 'imap_qprint', 'imap_renamemailbox', 'imap_reopen', 'imap_rfc822_parse_adrlist', 'imap_rfc822_parse_headers', 'imap_rfc822_write_address', 'imap_scanmailbox', 'imap_search', 'imap_set_quota', 'imap_setflag_full', 'imap_sort', 'imap_status', 'imap_subscribe', 'imap_uid', 'imap_undelete', 'imap_unsubscribe', 'imap_utf7_decode', 'imap_utf7_encode', 'imap_utf8', 'implode', 'in_array', 'include', 'include_once', 'ingres_autocommit', 'ingres_close', 'ingres_commit', 'ingres_connect', 'ingres_fetch_array', 'ingres_fetch_object', 'ingres_fetch_row', 'ingres_field_length', 'ingres_field_name', 'ingres_field_nullable', 'ingres_field_precision', 'ingres_field_scale', 'ingres_field_type', 'ingres_num_fields', 'ingres_num_rows', 'ingres_pconnect', 'ingres_query', 'ingres_rollback', 'ini_alter', 'ini_get', 'ini_restore', 'ini_set', 'intval', 'ip2long', 'iptcparse', 'ircg_channel_mode', 'ircg_disconnect', 'ircg_html_encode', 'ircg_ignore_add', 'ircg_ignore_del', 'ircg_is_conn_alive', 'ircg_join', 'ircg_kick', 'ircg_lookup_format_messages', 'ircg_msg', 'ircg_nick', 'ircg_notice', 'ircg_part', 'ircg_pconnect', 'ircg_register_format_messages', 'ircg_set_current', 'ircg_topic', 'ircg_whois', 'is_array', 'is_bool', 'is_dir', 'is_double', 'is_executable', 'is_file', 'is_float', 'is_int', 'is_integer', 'is_link', 'is_long', 'is_null', 'is_numeric', 'is_object', 'is_readable', 'is_real', 'is_resource', 'is_scalar', 'is_string', 'is_subclass_of', 'is_uploaded_file', 'is_writable', 'is_writeable', 'isset', 'java_last_exception_clear', 'java_last_exception_get', 'jddayofweek', 'jdmonthname', 'jdtofrench', 'jdtogregorian', 'jdtojewish', 'jdtojulian', 'jdtounix', 'jewishtojd', 'join', 'juliantojd', 'key', 'krsort', 'ksort', 'lcg_value', 'ldap_add', 'ldap_bind', 'ldap_close', 'ldap_compare', 'ldap_connect', 'ldap_count_entries', 'ldap_delete', 'ldap_dn2ufn', 'ldap_err2str', 'ldap_errno', 'ldap_error', 'ldap_explode_dn', 'ldap_first_attribute', 'ldap_first_entry', 'ldap_free_result', 'ldap_get_attributes', 'ldap_get_dn', 'ldap_get_entries', 'ldap_get_option', 'ldap_get_values', 'ldap_get_values_len', 'ldap_list', 'ldap_mod_add', 'ldap_mod_del', 'ldap_mod_replace', 'ldap_modify', 'ldap_next_attribute', 'ldap_next_entry', 'ldap_read', 'ldap_rename', 'ldap_search', 'ldap_set_option', 'ldap_unbind', 'leak', 'levenshtein', 'link', 'linkinfo', 'list', 'listen', 'localeconv', 'localtime', 'log', 'log10', 'long2ip', 'lstat', 'ltrim', 'mail', 'max', 'mb_convert_encoding', 'mb_convert_kana', 'mb_convert_variables', 'mb_decode_mimeheader', 'mb_decode_numericentity', 'mb_detect_encoding', 'mb_detect_order', 'mb_encode_mimeheader', 'mb_encode_numericentity', 'mb_http_input', 'mb_http_output', 'mb_internal_encoding', 'mb_language', 'mb_output_handler', 'mb_parse_str', 'mb_preferred_mime_name', 'mb_send_mail', 'mb_strcut', 'mb_strimwidth', 'mb_strlen', 'mb_strpos', 'mb_strrpos', 'mb_strwidth', 'mb_substitute_character', 'mb_substr', 'mcal_append_event', 'mcal_close', 'mcal_create_calendar', 'mcal_date_compare', 'mcal_date_valid', 'mcal_day_of_week', 'mcal_day_of_year', 'mcal_days_in_month', 'mcal_delete_calendar', 'mcal_delete_event', 'mcal_event_add_attribute', 'mcal_event_init', 'mcal_event_set_alarm', 'mcal_event_set_category', 'mcal_event_set_class', 'mcal_event_set_description', 'mcal_event_set_end', 'mcal_event_set_recur_daily', 'mcal_event_set_recur_monthly_mday', 'mcal_event_set_recur_monthly_wday', 'mcal_event_set_recur_none', 'mcal_event_set_recur_weekly', 'mcal_event_set_recur_yearly', 'mcal_event_set_start', 'mcal_event_set_title', 'mcal_expunge', 'mcal_fetch_current_stream_event', 'mcal_fetch_event', 'mcal_is_leap_year', 'mcal_list_alarms', 'mcal_list_events', 'mcal_next_recurrence', 'mcal_open', 'mcal_popen', 'mcal_rename_calendar', 'mcal_reopen', 'mcal_snooze', 'mcal_store_event', 'mcal_time_valid', 'mcrypt_cbc', 'mcrypt_cfb', 'mcrypt_create_iv', 'mcrypt_decrypt', 'mcrypt_ecb', 'mcrypt_enc_get_algorithms_name', 'mcrypt_enc_get_block_size', 'mcrypt_enc_get_iv_size', 'mcrypt_enc_get_key_size', 'mcrypt_enc_get_modes_name', 'mcrypt_enc_get_supported_key_sizes', 'mcrypt_enc_is_block_algorithm', 'mcrypt_enc_is_block_algorithm_mode', 'mcrypt_enc_is_block_mode', 'mcrypt_enc_self_test', 'mcrypt_encrypt', 'mcrypt_generic', 'mcrypt_generic_end', 'mcrypt_generic_init', 'mcrypt_get_block_size', 'mcrypt_get_cipher_name', 'mcrypt_get_iv_size', 'mcrypt_get_key_size', 'mcrypt_list_algorithms', 'mcrypt_list_modes', 'mcrypt_module_get_algo_block_size', 'mcrypt_module_get_algo_key_size', 'mcrypt_module_get_algo_supported_key_sizes', 'mcrypt_module_is_block_algorithm', 'mcrypt_module_is_block_algorithm_mode', 'mcrypt_module_is_block_mode', 'mcrypt_module_open', 'mcrypt_module_self_test', 'mcrypt_ofb', 'md5', 'mdecrypt_generic', 'metaphone', 'method_exists', 'mhash', 'mhash_count', 'mhash_get_block_size', 'mhash_get_hash_name', 'mhash_keygen_s2k', 'microtime', 'min', 'mkdir', 'mktime', 'move_uploaded_file', 'msql', 'msql_affected_rows', 'msql_close', 'msql_connect', 'msql_create_db', 'msql_createdb', 'msql_data_seek', 'msql_dbname', 'msql_drop_db', 'msql_dropdb', 'msql_error', 'msql_fetch_array', 'msql_fetch_field', 'msql_fetch_object', 'msql_fetch_row', 'msql_field_seek', 'msql_fieldflags', 'msql_fieldlen', 'msql_fieldname', 'msql_fieldtable', 'msql_fieldtype', 'msql_free_result', 'msql_freeresult', 'msql_list_dbs', 'msql_list_fields', 'msql_list_tables', 'msql_listdbs', 'msql_listfields', 'msql_listtables', 'msql_num_fields', 'msql_num_rows', 'msql_numfields', 'msql_numrows', 'msql_pconnect', 'msql_query', 'msql_regcase', 'msql_result', 'msql_select_db', 'msql_selectdb', 'msql_tablename', 'mssql_close', 'mssql_connect', 'mssql_data_seek', 'mssql_fetch_array', 'mssql_fetch_field', 'mssql_fetch_object', 'mssql_fetch_row', 'mssql_field_length', 'mssql_field_name', 'mssql_field_seek', 'mssql_field_type', 'mssql_free_result', 'mssql_get_last_message', 'mssql_min_error_severity', 'mssql_min_message_severity', 'mssql_next_result', 'mssql_num_fields', 'mssql_num_rows', 'mssql_pconnect', 'mssql_query', 'mssql_result', 'mssql_select_db', 'mt_getrandmax', 'mt_rand', 'mt_srand', 'mysql_affected_rows', 'mysql_change_user', 'mysql_close', 'mysql_connect', 'mysql_create_db', 'mysql_data_seek', 'mysql_db_name', 'mysql_db_query', 'mysql_drop_db', 'mysql_errno', 'mysql_error', 'mysql_escape_string', 'mysql_fetch_array', 'mysql_fetch_assoc', 'mysql_fetch_field', 'mysql_fetch_lengths', 'mysql_fetch_object', 'mysql_fetch_row', 'mysql_field_flags', 'mysql_field_len', 'mysql_field_name', 'mysql_field_seek', 'mysql_field_table', 'mysql_field_type', 'mysql_free_result', 'mysql_get_client_info', 'mysql_get_host_info', 'mysql_get_proto_info', 'mysql_get_server_info', 'mysql_insert_id', 'mysql_list_dbs', 'mysql_list_fields', 'mysql_list_tables', 'mysql_num_fields', 'mysql_num_rows', 'mysql_pconnect', 'mysql_query', 'mysql_result', 'mysql_select_db', 'mysql_tablename', 'mysql_unbuffered_query', 'natcasesort', 'natsort', 'next', 'nl2br', 'number_format', 'ob_end_clean', 'ob_end_flush', 'ob_get_contents', 'ob_get_length', 'ob_gzhandler', 'ob_iconv_handler', 'ob_implicit_flush', 'ob_start', 'ocibindbyname', 'ocicancel', 'ocicollassign', 'ocicollassignelem', 'ocicollgetelem', 'ocicollmax', 'ocicollsize', 'ocicolltrim', 'ocicolumnisnull', 'ocicolumnname', 'ocicolumnprecision', 'ocicolumnscale', 'ocicolumnsize', 'ocicolumntype', 'ocicolumntyperaw', 'ocicommit', 'ocidefinebyname', 'ocierror', 'ociexecute', 'ocifetch', 'ocifetchinto', 'ocifetchstatement', 'ocifreecollection', 'ocifreecursor', 'ocifreedesc', 'ocifreestatement', 'ociinternaldebug', 'ociloadlob', 'ocilogoff', 'ocilogon', 'ocinewcollection', 'ocinewcursor', 'ocinewdescriptor', 'ocinlogon', 'ocinumcols', 'ociparse', 'ociplogon', 'ociresult', 'ocirollback', 'ocirowcount', 'ocisavelob', 'ocisavelobfile', 'ociserverversion', 'ocisetprefetch', 'ocistatementtype', 'ociwritelobtofile', 'octdec', 'odbc_autocommit', 'odbc_binmode', 'odbc_close', 'odbc_close_all', 'odbc_columnprivileges', 'odbc_columns', 'odbc_commit', 'odbc_connect', 'odbc_cursor', 'odbc_do', 'odbc_error', 'odbc_errormsg', 'odbc_exec', 'odbc_execute', 'odbc_fetch_into', 'odbc_fetch_row', 'odbc_field_len', 'odbc_field_name', 'odbc_field_num', 'odbc_field_precision', 'odbc_field_scale', 'odbc_field_type', 'odbc_foreignkeys', 'odbc_free_result', 'odbc_gettypeinfo', 'odbc_longreadlen', 'odbc_num_fields', 'odbc_num_rows', 'odbc_pconnect', 'odbc_prepare', 'odbc_primarykeys', 'odbc_procedurecolumns', 'odbc_procedures', 'odbc_result', 'odbc_result_all', 'odbc_rollback', 'odbc_setoption', 'odbc_specialcolumns', 'odbc_statistics', 'odbc_tableprivileges', 'odbc_tables', 'opendir', 'openlog', 'openssl_error_string', 'openssl_free_key', 'openssl_get_privatekey', 'openssl_get_publickey', 'openssl_open', 'openssl_pkcs7_decrypt', 'openssl_pkcs7_encrypt', 'openssl_pkcs7_sign', 'openssl_pkcs7_verify', 'openssl_seal', 'openssl_sign', 'openssl_verify', 'openssl_x509_checkpurpose', 'openssl_x509_free', 'openssl_x509_parse', 'openssl_x509_read', 'ora_bind', 'ora_close', 'ora_columnname', 'ora_columnsize', 'ora_columntype', 'ora_commit', 'ora_commitoff', 'ora_commiton', 'ora_do', 'ora_error', 'ora_errorcode', 'ora_exec', 'ora_fetch', 'ora_fetch_into', 'ora_getcolumn', 'ora_logoff', 'ora_logon', 'ora_numcols', 'ora_numrows', 'ora_open', 'ora_parse', 'ora_plogon', 'ora_rollback', 'orbitenum', 'orbitobject', 'orbitstruct', 'ord', 'ovrimos_close', 'ovrimos_close_all', 'ovrimos_commit', 'ovrimos_connect', 'ovrimos_cursor', 'ovrimos_exec', 'ovrimos_execute', 'ovrimos_fetch_into', 'ovrimos_fetch_row', 'ovrimos_field_len', 'ovrimos_field_name', 'ovrimos_field_num', 'ovrimos_field_type', 'ovrimos_free_result', 'ovrimos_longreadlen', 'ovrimos_num_fields', 'ovrimos_num_rows', 'ovrimos_prepare', 'ovrimos_result', 'ovrimos_result_all', 'ovrimos_rollback', 'pack', 'parse_str', 'parse_url', 'passthru', 'pathinfo', 'pclose', 'pdf_add_annotation', 'pdf_add_bookmark', 'pdf_add_launchlink', 'pdf_add_locallink', 'pdf_add_note', 'pdf_add_outline', 'pdf_add_pdflink', 'pdf_add_thumbnail', 'pdf_add_weblink', 'pdf_arc', 'pdf_arcn', 'pdf_attach_file', 'pdf_begin_page', 'pdf_begin_pattern', 'pdf_begin_template', 'pdf_circle', 'pdf_clip', 'pdf_close', 'pdf_close_image', 'pdf_close_pdi', 'pdf_close_pdi_page', 'pdf_closepath', 'pdf_closepath_fill_stroke', 'pdf_closepath_stroke', 'pdf_concat', 'pdf_continue_text', 'pdf_curveto', 'pdf_delete', 'pdf_end_page', 'pdf_end_pattern', 'pdf_end_template', 'pdf_endpath', 'pdf_fill', 'pdf_fill_stroke', 'pdf_findfont', 'pdf_get_buffer', 'pdf_get_font', 'pdf_get_fontname', 'pdf_get_fontsize', 'pdf_get_image_height', 'pdf_get_image_width', 'pdf_get_parameter', 'pdf_get_pdi_parameter', 'pdf_get_pdi_value', 'pdf_get_value', 'pdf_initgraphics', 'pdf_lineto', 'pdf_makespotcolor', 'pdf_moveto', 'pdf_new', 'pdf_open', 'pdf_open_ccitt', 'pdf_open_file', 'pdf_open_gif', 'pdf_open_image', 'pdf_open_image_file', 'pdf_open_jpeg', 'pdf_open_memory_image', 'pdf_open_pdi', 'pdf_open_pdi_page', 'pdf_open_png', 'pdf_open_tiff', 'pdf_place_image', 'pdf_place_pdi_page', 'pdf_rect', 'pdf_restore', 'pdf_rotate', 'pdf_save', 'pdf_scale', 'pdf_set_border_color', 'pdf_set_border_dash', 'pdf_set_border_style', 'pdf_set_char_spacing', 'pdf_set_duration', 'pdf_set_font', 'pdf_set_horiz_scaling', 'pdf_set_info', 'pdf_set_leading', 'pdf_set_parameter', 'pdf_set_text_pos', 'pdf_set_text_rendering', 'pdf_set_text_rise', 'pdf_set_transition', 'pdf_set_value', 'pdf_set_word_spacing', 'pdf_setcolor', 'pdf_setdash', 'pdf_setflat', 'pdf_setfont', 'pdf_setgray', 'pdf_setgray_fill', 'pdf_setgray_stroke', 'pdf_setlinecap', 'pdf_setlinejoin', 'pdf_setlinewidth', 'pdf_setmatrix', 'pdf_setmiterlimit', 'pdf_setpolydash', 'pdf_setrgbcolor', 'pdf_setrgbcolor_fill', 'pdf_setrgbcolor_stroke', 'pdf_show', 'pdf_show_boxed', 'pdf_show_xy', 'pdf_skew', 'pdf_stringwidth', 'pdf_stroke', 'pdf_translate', 'pear', 'pear_error', 'pfpro_cleanup', 'pfpro_init', 'pfpro_process', 'pfpro_process_raw', 'pfpro_version', 'pfsockopen', 'pg_client_encoding', 'pg_close', 'pg_cmdtuples', 'pg_connect', 'pg_dbname', 'pg_end_copy', 'pg_errormessage', 'pg_exec', 'pg_fetch_array', 'pg_fetch_object', 'pg_fetch_row', 'pg_fieldisnull', 'pg_fieldname', 'pg_fieldnum', 'pg_fieldprtlen', 'pg_fieldsize', 'pg_fieldtype', 'pg_freeresult', 'pg_getlastoid', 'pg_host', 'pg_loclose', 'pg_locreate', 'pg_loexport', 'pg_loimport', 'pg_loopen', 'pg_loread', 'pg_loreadall', 'pg_lounlink', 'pg_lowrite', 'pg_numfields', 'pg_numrows', 'pg_options', 'pg_pconnect', 'pg_port', 'pg_put_line', 'pg_result', 'pg_set_client_encoding', 'pg_trace', 'pg_tty', 'pg_untrace', 'php_logo_guid', 'php_sapi_name', 'php_uname', 'phpcredits', 'phpinfo', 'phpversion', 'pi', 'popen', 'pos', 'posix_ctermid', 'posix_getcwd', 'posix_getegid', 'posix_geteuid', 'posix_getgid', 'posix_getgrgid', 'posix_getgrnam', 'posix_getgroups', 'posix_getlogin', 'posix_getpgid', 'posix_getpgrp', 'posix_getpid', 'posix_getppid', 'posix_getpwnam', 'posix_getpwuid', 'posix_getrlimit', 'posix_getsid', 'posix_getuid', 'posix_isatty', 'posix_kill', 'posix_mkfifo', 'posix_setgid', 'posix_setpgid', 'posix_setsid', 'posix_setuid', 'posix_times', 'posix_ttyname', 'posix_uname', 'pow', 'preg_grep', 'preg_match', 'preg_match_all', 'preg_quote', 'preg_replace', 'preg_replace_callback', 'preg_split', 'prev', 'print', 'print_r', 'printer_abort', 'printer_close', 'printer_create_brush', 'printer_create_dc', 'printer_create_font', 'printer_create_pen', 'printer_delete_brush', 'printer_delete_dc', 'printer_delete_font', 'printer_delete_pen', 'printer_draw_bmp', 'printer_draw_chord', 'printer_draw_elipse', 'printer_draw_line', 'printer_draw_pie', 'printer_draw_rectangle', 'printer_draw_roundrect', 'printer_draw_text', 'printer_end_doc', 'printer_end_page', 'printer_get_option', 'printer_list', 'printer_logical_fontheight', 'printer_open', 'printer_select_brush', 'printer_select_font', 'printer_select_pen', 'printer_set_option', 'printer_start_doc', 'printer_start_page', 'printer_write', 'printf', 'pspell_add_to_personal', 'pspell_add_to_session', 'pspell_check', 'pspell_clear_session', 'pspell_config_create', 'pspell_config_ignore', 'pspell_config_mode', 'pspell_config_personal', 'pspell_config_repl', 'pspell_config_runtogether', 'pspell_config_save_repl', 'pspell_new', 'pspell_new_config', 'pspell_new_personal', 'pspell_save_wordlist', 'pspell_store_replacement', 'pspell_suggest', 'putenv', 'quoted_printable_decode', 'quotemeta', 'rad2deg', 'rand', 'range', 'rawurldecode', 'rawurlencode', 'read', 'read_exif_data', 'readdir', 'readfile', 'readgzfile', 'readline', 'readline_add_history', 'readline_clear_history', 'readline_completion_function', 'readline_info', 'readline_list_history', 'readline_read_history', 'readline_write_history', 'readlink', 'realpath', 'recode', 'recode_file', 'recode_string', 'register_shutdown_function', 'register_tick_function', 'rename', 'require', 'require_once', 'reset', 'restore_error_handler', 'rewind', 'rewinddir', 'rmdir', 'round', 'rsort', 'rtrim', 'satellite_caught_exception', 'satellite_exception_id', 'satellite_exception_value', 'sem_acquire', 'sem_get', 'sem_release', 'sem_remove', 'serialize', 'sesam_affected_rows', 'sesam_commit', 'sesam_connect', 'sesam_diagnostic', 'sesam_disconnect', 'sesam_errormsg', 'sesam_execimm', 'sesam_fetch_array', 'sesam_fetch_result', 'sesam_fetch_row', 'sesam_field_array', 'sesam_field_name', 'sesam_free_result', 'sesam_num_fields', 'sesam_query', 'sesam_rollback', 'sesam_seek_row', 'sesam_settransaction', 'session_cache_limiter', 'session_decode', 'session_destroy', 'session_encode', 'session_get_cookie_params', 'session_id', 'session_is_registered', 'session_module_name', 'session_name', 'session_register', 'session_save_path', 'session_set_cookie_params', 'session_set_save_handler', 'session_start', 'session_unregister', 'session_unset', 'session_write_close', 'set_error_handler', 'set_file_buffer', 'set_magic_quotes_runtime', 'set_time_limit', 'setcookie', 'setlocale', 'settype', 'shm_attach', 'shm_detach', 'shm_get_var', 'shm_put_var', 'shm_remove', 'shm_remove_var', 'shmop_close', 'shmop_delete', 'shmop_open', 'shmop_read', 'shmop_size', 'shmop_write', 'show_source', 'shuffle', 'similar_text', 'sin', 'sizeof', 'sleep', 'snmp_get_quick_print', 'snmp_set_quick_print', 'snmpget', 'snmpset', 'snmpwalk', 'snmpwalkoid', 'socket', 'socket_get_status', 'socket_set_blocking', 'socket_set_timeout', 'sort', 'soundex', 'split', 'spliti', 'sprintf', 'sql_regcase', 'sqrt', 'srand', 'sscanf', 'stat', 'str_pad', 'str_repeat', 'str_replace', 'strcasecmp', 'strchr', 'strcmp', 'strcoll', 'strcspn', 'strerror', 'strftime', 'strip_tags', 'stripcslashes', 'stripslashes', 'stristr', 'strlen', 'strnatcasecmp', 'strnatcmp', 'strncasecmp', 'strncmp', 'strpos', 'strrchr', 'strrev', 'strrpos', 'strspn', 'strstr', 'strtok', 'strtolower', 'strtotime', 'strtoupper', 'strtr', 'strval', 'substr', 'substr_count', 'substr_replace', 'swf_actiongeturl', 'swf_actiongotoframe', 'swf_actiongotolabel', 'swf_actionnextframe', 'swf_actionplay', 'swf_actionprevframe', 'swf_actionsettarget', 'swf_actionstop', 'swf_actiontogglequality', 'swf_actionwaitforframe', 'swf_addbuttonrecord', 'swf_addcolor', 'swf_closefile', 'swf_definebitmap', 'swf_definefont', 'swf_defineline', 'swf_definepoly', 'swf_definerect', 'swf_definetext', 'swf_endbutton', 'swf_enddoaction', 'swf_endshape', 'swf_endsymbol', 'swf_fontsize', 'swf_fontslant', 'swf_fonttracking', 'swf_getbitmapinfo', 'swf_getfontinfo', 'swf_getframe', 'swf_labelframe', 'swf_lookat', 'swf_modifyobject', 'swf_mulcolor', 'swf_nextid', 'swf_oncondition', 'swf_openfile', 'swf_ortho', 'swf_ortho2', 'swf_perspective', 'swf_placeobject', 'swf_polarview', 'swf_popmatrix', 'swf_posround', 'swf_pushmatrix', 'swf_removeobject', 'swf_rotate', 'swf_scale', 'swf_setfont', 'swf_setframe', 'swf_shapearc', 'swf_shapecurveto', 'swf_shapecurveto3', 'swf_shapefillbitmapclip', 'swf_shapefillbitmaptile', 'swf_shapefilloff', 'swf_shapefillsolid', 'swf_shapelinesolid', 'swf_shapelineto', 'swf_shapemoveto', 'swf_showframe', 'swf_startbutton', 'swf_startdoaction', 'swf_startshape', 'swf_startsymbol', 'swf_textwidth', 'swf_translate', 'swf_viewport', 'swfaction', 'swfbitmap', 'swfbitmap.getheight', 'swfbitmap.getwidth', 'swfbutton', 'swfbutton.addaction', 'swfbutton.addshape', 'swfbutton.setaction', 'swfbutton.setdown', 'swfbutton.sethit', 'swfbutton.setover', 'swfbutton.setup', 'swfdisplayitem', 'swfdisplayitem.addcolor', 'swfdisplayitem.move', 'swfdisplayitem.moveto', 'swfdisplayitem.multcolor', 'swfdisplayitem.remove', 'swfdisplayitem.rotate', 'swfdisplayitem.rotateto', 'swfdisplayitem.scale', 'swfdisplayitem.scaleto', 'swfdisplayitem.setdepth', 'swfdisplayitem.setname', 'swfdisplayitem.setratio', 'swfdisplayitem.skewx', 'swfdisplayitem.skewxto', 'swfdisplayitem.skewy', 'swfdisplayitem.skewyto', 'swffill', 'swffill.moveto', 'swffill.rotateto', 'swffill.scaleto', 'swffill.skewxto', 'swffill.skewyto', 'swffont', 'swffont.getwidth', 'swfgradient', 'swfgradient.addentry', 'swfmorph', 'swfmorph.getshape1', 'swfmorph.getshape2', 'swfmovie', 'swfmovie.add', 'swfmovie.nextframe', 'swfmovie.output', 'swfmovie.remove', 'swfmovie.save', 'swfmovie.setbackground', 'swfmovie.setdimension', 'swfmovie.setframes', 'swfmovie.setrate', 'swfmovie.streammp3', 'swfshape', 'swfshape.addfill', 'swfshape.drawcurve', 'swfshape.drawcurveto', 'swfshape.drawline', 'swfshape.drawlineto', 'swfshape.movepen', 'swfshape.movepento', 'swfshape.setleftfill', 'swfshape.setline', 'swfshape.setrightfill', 'swfsprite', 'swfsprite.add', 'swfsprite.nextframe', 'swfsprite.remove', 'swfsprite.setframes', 'swftext', 'swftext.addstring', 'swftext.getwidth', 'swftext.moveto', 'swftext.setcolor', 'swftext.setfont', 'swftext.setheight', 'swftext.setspacing', 'swftextfield', 'swftextfield.addstring', 'swftextfield.align', 'swftextfield.setbounds', 'swftextfield.setcolor', 'swftextfield.setfont', 'swftextfield.setheight', 'swftextfield.setindentation', 'swftextfield.setleftmargin', 'swftextfield.setlinespacing', 'swftextfield.setmargins', 'swftextfield.setname', 'swftextfield.setrightmargin', 'sybase_affected_rows', 'sybase_close', 'sybase_connect', 'sybase_data_seek', 'sybase_fetch_array', 'sybase_fetch_field', 'sybase_fetch_object', 'sybase_fetch_row', 'sybase_field_seek', 'sybase_free_result', 'sybase_get_last_message', 'sybase_min_client_severity', 'sybase_min_error_severity', 'sybase_min_message_severity', 'sybase_min_server_severity', 'sybase_num_fields', 'sybase_num_rows', 'sybase_pconnect', 'sybase_query', 'sybase_result', 'sybase_select_db', 'symlink', 'syslog', 'system', 'tan', 'tempnam', 'textdomain', 'time', 'tmpfile', 'touch', 'trigger_error', 'trim', 'uasort', 'ucfirst', 'ucwords', 'udm_add_search_limit', 'udm_alloc_agent', 'udm_api_version', 'udm_cat_list', 'udm_cat_path', 'udm_clear_search_limits', 'udm_errno', 'udm_error', 'udm_find', 'udm_free_agent', 'udm_free_ispell_data', 'udm_free_res', 'udm_get_doc_count', 'udm_get_res_field', 'udm_get_res_param', 'udm_load_ispell_data', 'udm_set_agent_param', 'uksort', 'umask', 'uniqid', 'unixtojd', 'unlink', 'unpack', 'unregister_tick_function', 'unserialize', 'unset', 'urldecode', 'urlencode', 'user_error', 'usleep', 'usort', 'utf8_decode', 'utf8_encode', 'var_dump', 'variant', 'virtual', 'wddx_add_vars', 'wddx_deserialize', 'wddx_packet_end', 'wddx_packet_start', 'wddx_serialize_value', 'wddx_serialize_vars', 'wordwrap', 'write', 'xml_error_string', 'xml_get_current_byte_index', 'xml_get_current_column_number', 'xml_get_current_line_number', 'xml_get_error_code', 'xml_parse', 'xml_parse_into_struct', 'xml_parser_create', 'xml_parser_free', 'xml_parser_get_option', 'xml_parser_set_option', 'xml_set_character_data_handler', 'xml_set_default_handler', 'xml_set_element_handler', 'xml_set_external_entity_ref_handler', 'xml_set_notation_decl_handler', 'xml_set_object', 'xml_set_processing_instruction_handler', 'xml_set_unparsed_entity_decl_handler', 'xmldoc', 'xmldocfile', 'xmltree', 'xpath_eval', 'xpath_new_context', 'xslt_closelog', 'xslt_create', 'xslt_errno', 'xslt_error', 'xslt_fetch_result', 'xslt_free', 'xslt_openlog', 'xslt_output_begintransform', 'xslt_output_endtransform', 'xslt_process', 'xslt_run', 'xslt_set_sax_handler', 'xslt_transform', 'yaz_addinfo', 'yaz_ccl_conf', 'yaz_ccl_parse', 'yaz_close', 'yaz_connect', 'yaz_database', 'yaz_element', 'yaz_errno', 'yaz_error', 'yaz_hits', 'yaz_itemorder', 'yaz_present', 'yaz_range', 'yaz_record', 'yaz_scan', 'yaz_scan_result', 'yaz_search', 'yaz_sort', 'yaz_syntax', 'yaz_wait', 'yp_first', 'yp_get_default_domain', 'yp_master', 'yp_match', 'yp_next', 'yp_order', 'zend_logo_guid', 'zend_version', 'zip_close', 'zip_entry_close', 'zip_entry_compressedsize', 'zip_entry_compressionmethod', 'zip_entry_filesize', 'zip_entry_name', 'zip_entry_open', 'zip_entry_read', 'zip_open', 'zip_read'
	// PHP Operator
	PHP_OPERATOR	is	'and', 'or', 'xor', 'not'
	// PHP Reserved
	PHP_RESERVED	is	'break', 'case', 'class', 'continue', 'default', 'do', 'double',
						'else', 'elseif', 'enddo', 'endfor', 'endforeach', 'endif', 'endswitch',
						'endwhile', 'extends', 'float', 'for', 'foreach', 'function', 'global',
						'if', 'integer', 'new', 'object', 'old_function', 'parent',
						'real', 'return', 'static', 'string', 'switch', 'var', 'while'						
)

%%tokens
InState IN_PHP_DEFAULT (
	PHP_DEFAULT			NOT_ALPHA			DONT_CARE?				DONT_CARE			_discard_
	PHP_IDENTIFIER		ID_START			ID_CONTAINS?			NOT_ID_CONTAINS		_discard_
	PHP_NUMBER			NUM_START			NUM_CONTAINS?			NOT_NUM_CONTAINS	_discard_
)

InState IN_PHP_COMMENT_LINE (
	PHP_COMMENT			DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_COMMENT_STAR (
	PHP_COMMENT			DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_EXECSTRING (
	PHP_EXECSTRING		DONT_CARE			DONT_CARE?				DONT_CARE			_discard_
)

InState IN_PHP_STRING (
	PHP_STRING			'[^"\\]'			DONT_CARE?				DONT_CARE			_discard_
	PHP_STRING			'\\'				DONT_CARE				DONT_CARE			_discard_
)

InState IN_PHP_STRING_SQ (
	PHP_STRING			'[^\'\\]'			DONT_CARE?				DONT_CARE			_discard_
	PHP_STRING			'\\'				DONT_CARE				DONT_CARE			_discard_
)

// Script Support
InState IN_PHP_SCRIPT_START (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

InState IN_PHP_SCRIPT_STOP (
	HTML_SCRIPT			DONT_CARE			DONT_CARE?			DONT_CARE			_discard_
)

%%states
PHP_START				push (-ALL_STATES						+[IN_PHP_DEFAULT])
PHP_STOP				pop ()

PHP_COMMENT_LINE_START	(+[IN_PHP_COMMENT_LINE]					-[IN_PHP_DEFAULT])
PHP_COMMENT_LINE_STOP	(-[IN_PHP_COMMENT_LINE]					+[IN_PHP_DEFAULT])

PHP_COMMENT_STAR_START	(+[IN_PHP_COMMENT_STAR]					-[IN_PHP_DEFAULT])
PHP_COMMENT_STAR_STOP	(-[IN_PHP_COMMENT_STAR]					+[IN_PHP_DEFAULT])

PHP_EXECSTRING_START	(+[IN_PHP_EXECSTRING]					-[IN_PHP_DEFAULT])
PHP_EXECSTRING_STOP		(-[IN_PHP_EXECSTRING]					+[IN_PHP_DEFAULT])

PHP_STRING_START		(+[IN_PHP_STRING]						-[IN_PHP_DEFAULT])
PHP_STRING_STOP			(-[IN_PHP_STRING]						+[IN_PHP_DEFAULT])

PHP_STRING_SQ_START		(+[IN_PHP_STRING_SQ]					-[IN_PHP_DEFAULT])
PHP_STRING_SQ_STOP		(-[IN_PHP_STRING_SQ]					+[IN_PHP_DEFAULT])

// Script support
SCRIPT_PHP_START		(-[IN_HTML_SCRIPT_START] +[IN_PHP_SCRIPT_START])
PHP_SCRIPT_START_STOP	(-[IN_PHP_SCRIPT_START] +[IN_PHP_DEFAULT])

PHP_SCRIPT_STOP_START 	(-[IN_PHP_DEFAULT] +[IN_PHP_SCRIPT_STOP])
PHP_SCRIPT_STOP_STOP	(-[IN_PHP_SCRIPT_STOP] +[IN_DEFAULT])

%%effects
PHP_DEFAULT				[]					clBlack				clLtSilver
PHP						[]					clRed				clLtSilver
PHP_COMMENT				[]					clGreen				clLtSilver
PHP_IDENTIFIER			[]					clBlack				clLtSilver
PHP_NUMBER				[]					clGreen				clLtSilver
PHP_RESERVED			[fsBold]			clBlue				clLtSilver
PHP_FUNCTION			[fsBold]			clNavy				clLtSilver
PHP_VARIABLE			[fsBold]			clBlack				clLtSilver
PHP_EXECSTRING			[fsBold]			clTeal				clLtSilver
PHP_OPERATOR			[fsBold]			clNavy				clLtSilver
PHP_STRING				[]					clTeal				clLtSilver
PHP_CONSTANT			[]					clBlue				clLtSilver
PHP_THIS				[fsBold]			clBlack				clLtSilver
PHP_SEPARATOR			[fsBold]			clBlack				clLtSilver

%%map
PHP_DEFAULT				PHP_DEFAULT
PHP						PHP
PHP_START				PHP
PHP_STOP				PHP
PHP_FUNCTION			PHP_FUNCTION
PHP_IDENTIFIER			PHP_IDENTIFIER
PHP_NUMBER				PHP_NUMBER
PHP_COMMENT				PHP_COMMENT
PHP_COMMENT_LINE_START	PHP_COMMENT
PHP_COMMENT_LINE_STOP	PHP_COMMENT
PHP_COMMENT_STAR_START	PHP_COMMENT
PHP_COMMENT_STAR_STOP	PHP_COMMENT
PHP_RESERVED			PHP_RESERVED
PHP_VARIABLE			PHP_VARIABLE
PHP_EXECSTRING			PHP_EXECSTRING
PHP_EXECSTRING_START	PHP_EXECSTRING
PHP_EXECSTRING_STOP		PHP_EXECSTRING
PHP_OPERATOR			PHP_OPERATOR
PHP_STRING				PHP_STRING
PHP_STRING_START		PHP_STRING
PHP_STRING_STOP			PHP_STRING
PHP_STRING_SQ_START		PHP_STRING
PHP_STRING_SQ_STOP		PHP_STRING
PHP_CONSTANT			PHP_CONSTANT
PHP_THIS				PHP_THIS
PHP_SEPARATOR			PHP_SEPARATOR
// Script support
SCRIPT_PHP_START		HTML_SCRIPT
PHP_SCRIPT_START_STOP	HTML_SCRIPT
PHP_SCRIPT_STOP_START	HTML_SCRIPT
PHP_SCRIPT_STOP_STOP	HTML_SCRIPT